#include <stdio.h>
#include <math.h>
#include <values.h>

void comp_min(unsigned c, unsigned d, unsigned cnt, unsigned *min) { 
  static unsigned Primes[] = {  2,  3,  5,  7, 11, 13, 17, 19, 23, 29, 
			       31, 37, 41, 43, 47, 53, 59, 61, 71, 73 };
  static unsigned a[20];
  static double ret = 1;

  unsigned i, j, lcnt;
  double lret;

  for (i = c ; 2 <= i ; i--)
    if (!(d%i)) {
      lcnt = cnt;
      lret = ret;
      a[cnt++] = i;
      for (j = 0; j < a[cnt-1]-1; j++) {
	ret *= 1.0*Primes[cnt-1];
	if (ret > UINT_MAX)
	  goto AA;
      }
      if (d/i == 1) {
	if (ret != 1 && ret < *min) 
	  *min = ret;
      } else 
	comp_min(i, d/i, cnt, min);
    AA:
      cnt = lcnt;
      ret = lret;
    }
}

unsigned Comp_min(unsigned d) {
  /* Returns the smallest number with exactly d divisors
   * if it is smaller than UINT_MAX, otherwise returns 0.
   */
  static unsigned min;

  if (d == 1)
    return 1;
  min = UINT_MAX;
  comp_min(d, d, 0, &min);
  return (min == UINT_MAX) ? 0 : min;
}

#define MAXANS 1000000
int main () {
  unsigned n, a, b;

  while (scanf("%u", &n) != EOF) {
    a = Comp_min(2*n);
    if (a > MAXANS)
      a = 0;
    b = Comp_min (2*n-1);
    if (b > MAXANS)
      b = 0;
    if (a && b)
      printf ("%u\n", a < b ? a : b);
    else if (a) 
      printf ("%u\n", a);
    else if (b)
      printf ("%u\n", b);
    else
      printf("Too big\n");
  }
  return 0;
}

