/* David's Star, PR */

#include <stdio.h> 
#include <assert.h>

int v[12], p[12], na[13], pa[13], solutions, R; 
int len;

#define takeout(A) { na[pa[A]] = na[A]; pa[na[A]] = pa[A]; len--; }
#define putback(A) { pa[na[A]] = A; na[pa[A]] = A; len++; }

void try (int i, int fa) {
  int afa;

  if (len == 0) {
    if ((v[p[8]]+v[p[9]]+v[p[11]]+v[p[1]] == R) && 
	(v[p[10]]+v[p[11]]+v[p[5]]+v[p[7]] == R)) 
      solutions++;
    return;
  }

  afa = fa;
  do {
    p[i] = afa;
    switch (i) {
    case 3:
      if (v[p[0]]+v[p[1]]+v[p[2]]+v[p[3]] != R) 
	goto CONT;
      break;
    case 6:
      if (v[p[3]]+v[p[4]]+v[p[5]]+v[p[6]] != R)
	goto CONT;
      break;
    case 8:
      if (v[p[6]]+v[p[7]]+v[p[8]]+v[p[0]] != R)
	goto CONT;
      break;
    case 10:
      if (v[p[9]]+v[p[2]]+v[p[4]]+v[p[10]] != R)
	goto CONT;
      break;
    default:
    }
    takeout (afa);
    try (i+1, na[afa]);
    putback(afa);
  CONT:
    afa = na[afa];
  } while (afa != fa);
}

int main(int argc, char *argv[]) { 
  int i, S; 

  /* circular list for keeping the not yet assigned points */
  for (i = 0; i < 12; i++) {  
    na[i] = i+1;
    pa[i] = i-1;
  }
  na[11] = 0; pa[0] = 11;
  len = 12;

  while (1) {
    S = 0;
    for (i = 0; i < 12; i++) {
      if (scanf("%d", &v[i]) < 1)
	return 0;
      S += v[i];
    }

    if (S%3) { /* if doable, 2*S must be divisible by 6 */
      printf("0\n");
      continue;
    }
   
    R = S/3; 
    solutions = 0;

                                        /* this kills 6 rotations */
    takeout(0);
    p[0] = 0;
    try (1, 1);
    putback(0);

    takeout(1);
    p[0] = 1;
    try (1, 0);
    putback(1);

    printf("%d\n", solutions/2); /* this kills 2 reflections */
 }
 return(0) ; 
} 
