#include<stdio.h>
#include<string.h>
#define MAX 170

/****************************************************************************/
const char *inp_file = "routes.inp";
const char *out_file = "routes.out";

int N,solutions[MAX][2],brsol=0;
int brcyc=0,cycles[MAX][MAX];
int lencyc[MAX];
struct grad {
  int vr[MAX];
  int vr1[MAX];
  int br;
} city[MAX];
/****************************************************************************/
  void sort();
  void init();
  void findcycles();
  void done();
/****************************************************************************/
void main(){
  init();
  findcycles();
  done();
}
/****************************************************************************/
void sort(){
  for (int i=0;i<brsol;i++)
    if (solutions[i][0]>solutions[i][1]){
      int tmp=solutions[i][0];
      solutions[i][0]=solutions[i][1];
      solutions[i][1]=tmp;
    }
  for (int i=0;i<brsol;i++)
    for (int j=i+1;j<brsol;j++)
      if (solutions[i][0]>solutions[j][0]) {
        int tmp=solutions[i][0],tmp1=solutions[i][1];
        solutions[i][0]=solutions[j][0];
        solutions[i][1]=solutions[j][1];
        solutions[j][1]=tmp1;
        solutions[j][0]=tmp;
      }
      else
      if (solutions[i][0]==solutions[j][0])
        if (solutions[i][1]>solutions[j][1]) {
          //int tmp=solutions[i][0];
          //solutions[i][0]=solutions[j][0];
          //solutions[i][1]=tmp;
          int tmp=solutions[i][0],tmp1=solutions[i][1];
          solutions[i][0]=solutions[j][0];
          solutions[i][1]=solutions[j][1];
          solutions[j][1]=tmp1;
          solutions[j][0]=tmp;
        }
}
/****************************************************************************/
void init(){
  memset(solutions,0,sizeof(solutions));
  memset(city,0,sizeof(city));
  memset(cycles,0,sizeof(cycles));
  memset(lencyc,0,sizeof(lencyc));

  FILE *f=fopen(inp_file,"r");
  fscanf(f,"%d",&N);
  for (int i=0;i<N;i++) {
    fscanf(f,"%d",&city[i].br);

    for (int j=0;j<city[i].br;j++){
      fscanf(f,"%d",&city[i].vr[j]);
      city[i].vr1[city[i].vr[j]-1]=1;
    }
  }

  for (int i=0;i<N;i++)
    if (city[i].br==1){
      solutions[brsol][0]=i+1;
      solutions[brsol][1]=city[i].vr[0];
      city[i].vr[0]=0;
      city[i].br=0;
      brsol++;
    }
  sort();
  fclose(f);
}
/****************************************************************************/
void findcycles(){
  int temp[MAX],lnc=0,bb=0;
  memset(temp,0,sizeof(temp));
  for (int i=0;i<N;i++)
    if (bb==1) break;
    else
    for (int j=i+1;j<N;j++)
    if (bb==1) break;
    else
      for (int p=j+1;p<N;p++)
      if (bb==1) break;
      else
        if ((city[i].vr1[j]==1)&&(city[i].vr1[p]==1)&&(city[p].vr1[j]==1)) {
          temp[0]=i;
          temp[1]=j;
          temp[2]=p;
          lnc=3;
          bb=1;
          break;
        }

  for (int i=0;i<N;i++)
    for (int j=i+1;j<N;j++)
      for (int p=j+1;p<N;p++)
        if ((city[i].vr1[j]==1)&&(city[i].vr1[p]==1)&&(city[p].vr1[j]==1)) {
          int ii=0,jj=0,pp=0;
          for (int k=0;k<lnc;k++) {
            if (temp[k]==i) ii++;
            if (temp[k]==j) jj++;
            if (temp[k]==p) pp++;
          }
          if ((ii!=0)||(jj!=0)||(pp!=0)) {
            if (ii==0) {temp[lnc]=i;  lnc++;}
            if (jj==0) {temp[lnc]=j;  lnc++;}
            if (pp==0) {temp[lnc]=p;  lnc++;}
          }
          else {
            memmove(cycles[brcyc],temp,sizeof(temp));
            lencyc[brcyc]=lnc;
            brcyc++;
            memset(temp,0,sizeof(temp));
            //temp[0]=i;  temp[1]=j;  temp[2]=p;  lnc=3;
            bb=0; int s=i;
            for (int i=s;i<N;i++)
              if (bb==1);// break;
              else
              for (int j=i+1;j<N;j++)
              if (bb==1) break;
              else
                for (int p=j+1;p<N;p++)
                if (bb==1) break;
                else
                  if ((city[i].vr1[j]==1)&&(city[i].vr1[p]==1)&&(city[p].vr1[j]==1)) {
                    temp[0]=i;
                    temp[1]=j;
                    temp[2]=p;
                    lnc=3;
                    bb=1;
                    break;
                  }

          }
        }

  memmove(cycles[brcyc],temp,sizeof(temp));
  lencyc[brcyc]=lnc;
  brcyc++;
}
/****************************************************************************/
void done(){
  for (int i=0;i<brcyc;i++)
    for (int k=i+1;k<brcyc;k++)
      for (int j=0;j<lencyc[i];j++)
        for (int p=0;p<lencyc[k];p++)
          if (city[cycles[i][j]].vr1[cycles[k][p]]) {
            solutions[brsol][0]=cycles[i][j]+1;
            solutions[brsol][1]=cycles[k][p]+1;
            brsol++;
            //break;
          }
  sort();
  FILE *f=fopen(out_file,"w");
  for (int i=0;i<brsol;i++)
    fprintf(f,"%d %d\n",solutions[i][0],solutions[i][1]);
  fclose(f);
}
/****************************************************************************/

