
  Var Fin,Fout : Text;
      Cols     : Array [1..1000] of Record
                                      X,Y,R : Real;
                                    End;
      N        : Integer;
      FenceAng : Real;
      CNFence  : Integer;   {Current Number}
      SNFence  : Integer;   {Starting/Ending Number}
      Result   : Real;

  Procedure Init;
    Begin
      Assign (Fin, 'Fence.Inp');
      Reset(Fin);
      N:=0;
      Repeat
        Inc(N);
        Read(Fin,Cols[N].X);
        Read(Fin,Cols[N].Y);
        Read(Fin,Cols[N].R);
      Until Eof (Fin);
      Close(Fin);
      Result:=0;
    End;

  Procedure FindFirst;
      Var W : Integer;
          M : Real;
    Begin
      M:=100000000;
      For W := 1 To N Do
        If Cols[W].Y<M Then
          Begin
            M:=Cols[W].Y;
            SNFence:=W;
          End;
      FenceAng:=0;
    End;

  Procedure MakeFence;
      Var T              : Integer;
          Alpha,Alphamin : Real;
          XL,YL          : Real;
          Next           : Integer;
          Sd,Beta,MR     : Real;
    Begin
      FindFirst;
      CNFence:=SNFence;
      Repeat
        AlphaMin:=360;
        For T := 1 To N Do
          If T<>CNFence Then
            Begin
              XL:=(Cols[T].X-Cols[CNFence].X);
              YL:=(Cols[T].Y-Cols[CNFence].Y);
              If (XL>0) And (YL>0) Then Alpha:=180*ArcTan(XL/YL)/Pi-FenceAng;
              If (XL=0) And (YL>0) Then Alpha:=90-FenceAng;
              If (XL=0) And (YL<0) Then Alpha:=270-FenceAng;
              If (XL<0) And (YL>0) Then Alpha:=90-180*ArcTan(XL/YL)/Pi-FenceAng;
              If (XL<0) And (YL=0) Then Alpha:=180-FenceAng;
              If (XL<0) And (YL<0) Then Alpha:=180*ArcTan(XL/YL)/Pi-FenceAng+180;
              If (XL>0) And (YL=0) Then Alpha:=360-FenceAng;
              If (XL>0) And (YL<0) Then Alpha:=180*ArcTan(XL/YL)/Pi-FenceAng;
              If (Alpha<0) Then Alpha:=360-Alpha;
              If (Alpha>=360) Then Alpha:=Alpha-360;
              If (Alpha<AlphaMin) Then
                Begin
                  AlphaMin:=Alpha;
                  Next:=T;
                End;
            End;
      Sd:=(Sqrt(Sqr(Cols[CNFence].X-Cols[Next].X)+Sqr(Cols[CNFence].Y-Cols[Next].Y)));
      MR:=Cols[Next].R-Cols[CNFence].R;
      If (Sd<>Mr) And (Sd<>-Mr) Then Beta:=180*ArcTan(MR/(Sqrt(Sqr(Sd)-Sqr(MR))))/Pi
        Else
          Begin If Sd=Mr Then Beta:=45 Else Beta :=-45 End;
      Alpha:=AlphaMin-Beta;
      Result:=Result+(Alpha/360)*2*Pi*Cols[CNFence].R;
      Result:=Result+(Alpha/360)*2*Pi*Cols[Next].R;
      Result:=Result+(Sqrt(Sqr(Sd)-Sqr(MR)));
      FenceAng:=Alphamin+FenceAng;
      If Next<>SNFence Then CNFence:=Next;
      Until Next=SNFence;
      Result:=Result+2*Pi*Cols[Next].R*((360-FenceAng)/360);
    End;

BEGIN
  Init;
  MakeFence;
  Assign (Fout,'fence.out');
  Rewrite (Fout);
  Write (Fout,Result:2:2);
  Close(Fout);
END.