#include <fstream.h>

   ifstream in ("routes.inp");
   ofstream out ("routes.out");


  int n;

  int A[180][180];

  int B[180][180];

  int Pos[180];


  struct DDD
          {
            int i;
            int j;
          };


  DDD K;

  int Br [180];



  void ReadData ()
    {
      in >> n;
      for (int i = 1; i <= n; i++)
        {
          int c;
          in >> c;
          Br[i] = c;
          for (int j = 1; j <= c; j++)
            {
              in >> A[i][j];
              B[i][A[i][j]] = true;
            }
        }
    }

  void Depth (int vr)
    {
      Pos [vr] = true;
      for (int i = 1; i <= Br[vr]; i++)
        {
          if (!Pos[A[vr][i]] && A[vr][i] > 0)
            {
              Depth (A[vr][i]);
            }
        }
    }



  bool Obhod (int fi, int se)
    {
      int br = 0;
      for (int i = 1; i <= n; i++)
        {
          if (!Pos[i])
            {
              br++;
              Depth (i);
              if (br > 1)
                return false;
            }
        }
      return true;
    }

  void InitPos ()
    {
      for (int i = 1; i <= n; i++)
        {
          Pos[i] = false;
        }
    }


  DDD RemoveRebro (int ii, int jj)
    {
      DDD z;
      for (int i = 1; i <= Br[ii]; i++)
        if (A[ii][i] == jj)
          {
            A[ii][i] = -A[ii][i];
            z.i = i;
          }
      for (int i = 1; i <= Br[jj]; i++)
        if (A[jj][i] == ii)
          {
            A[jj][i] = -A[jj][i];
            z.j = i;
          }
       return z;
    }

  void AddRebro (int i, int j, int ii, int jj)
    {
      A[i][ii] = -A[i][ii];
      A[j][jj] = -A[j][jj];
    }



  void ProcessData ()
    {
      bool Bym;
      for (int i = 1; i <= n; i++)
        for (int j = i; j <= n; j++)
          {
            if (i != j && B[i][j])
              {
                K = RemoveRebro (i,j);
                Bym = Obhod (i,j);
                if (!Bym)
                  out << i  << " " << j << '\n';
                AddRebro (i,j,K.i,K.j);
                InitPos ();
              }
          }
    }




  int main ()
    {
      ReadData ();
      ProcessData ();
      return 0;
    }
