{$MODE objfpc}
{$H-}

Var
  N : Integer;
  Nr, Low : Array[0..170] Of Integer;
  G : Array[0..170, 0..255] Of Integer;
  Res : Array[0..170, 0..170] Of Boolean;
  A : Array[0..170] Of Boolean;
  F : Array[0..190] Of Integer;
  Vis, Vis2 : Array[0..200] Of Boolean;
  GNr : Integer;

Procedure ReadIn;

Var
  F : Text;
  I, J : Integer;

Begin
  FillChar(Res, SizeOf(Res), 0);
  FillChar(Nr, SizeOf(Nr), 0);
  FillChar(A, SizeOf(A), 0);
  ASSign(F, 'ROUTES.INP');
  Reset(F);
  Readln(F, N);
  For I := 1 To N Do
  Begin
    Read(F, G[I, 0]);
    For J := 1 To G[I, 0] Do
      Read(F, G[I, J]);
    Readln(F);
  End;
  Close(F);
End;

Procedure Dig(PQ, Q : Integer);

Var
  NL : Integer;
  II, I : Integer;
  Digs : Integer;

Begin
  Digs := 0;
  Inc(GNr);
  Nr[Q] := GNr;
  NL := Nr[Q];
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If I = PQ Then
      Continue;
    If Nr[I] <> 0 Then
    Begin
      If Nr[I] < NL Then
        NL := Nr[I];
    End
    Else
    Begin
      Inc(Digs);
      If (Q = 1) And (Digs > 1) Then
      Begin
{        Writeln('!', Q, ' ', I);}
        A[Q] := True;
      End;
      Dig(Q, I);
      If Low[I] < NL Then
        NL := Low[I];
    End;
  End;
  Low[Q] := NL;
  If PQ > 1 Then
  Begin
    If Low[Q] >= PQ Then
    Begin
      A[PQ] := True;
{      Writeln('!', PQ);}
    End;
  End;
End;

Procedure Dig2(Q : Integer);

Var
  I, II : Integer;

Begin
  If Nr[Q] <> 0 Then
    Exit;
  Nr[Q] := GNr;
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If Nr[I] <> 0 Then
      Continue;
    If A[I] Then
      Continue;
    Dig2(I);
  End;
End;

Procedure RRes(A, B : Integer);

Var
  tmp : Integer;

Begin
  If A > B Then
  Begin
    tmp := A;
    A := B;
    B := tmp;
  End;
  Res[A, B] := True;
End;

{Var
  Byebye : Boolean;}

Procedure Check2(Q : Integer);

Var
  II, I : Integer;

Begin
{  If Byebye = True Then
    Exit;}
  If Vis[Q] Then
    Exit;
{  Writeln('chk2 ', Q);}
  Vis[Q] := True;
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If Nr[I] <> 0 Then
    Begin
      If Vis2[Nr[I]] = False Then
      Begin
{        Writeln('lala', I);}
        Inc(F[Nr[I]]);
        Vis2[Nr[I]] := True;
      End;
    End
    Else
      Check2(I);
  End;
End;

Function TestEdge(S, E : Integer) : Boolean;

Var
  Found : Boolean;

  Procedure Dig3(V : Integer);

  Var
    I, II : Integer;

  Begin
{    Writeln('dig', V);}
    Vis2[V] := True;
    If Found Then
      Exit;
    For II := 1 To G[V, 0] Do
    Begin
      I := G[V, II];
      If (I = E) And (V = S) Then
        Continue;
      If (I = S) And (V = E) Then
        Continue;
      If Vis2[I] Then
        Continue;
      If I = E Then
      Begin
        Found := True;
        Exit;
      End;
{      Vis2[I] := True;}
      Dig3(I);
    End;
  End;

Begin
  Found := False;
  FillChar(Vis2, SizeOf(Vis2), 0);
  Dig3(S);
  TestEdge := Found;
End;

Procedure Check(Q : Integer);

Var
  I, II : Integer;

Begin
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If Not TestEdge(I, Q) Then
      RRes(I, Q);
  End;
  Exit;
{  Writeln('check', Q);}
  FillChar(F, SizeOf(F), 0);
  FillChar(Vis, N{*4}+8, 0);
  Vis[Q] := True;
{  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    F[Nr[I]] := 0;
  End;}
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If Nr[I] <> 0 Then
    Begin
{      Writeln('lala', I);}
      Inc(F[Nr[I]]);
    End
    Else
{      Check2(I)};
  End;
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If Nr[I] <> 0 Then
{      Inc(F[Nr[I]])}
    Else
    Begin
{      Byebye := False;}
      FillChar(Vis2, N+8, 0);
      Check2(I);
    End;
  End;
  For II := 1 To G[Q, 0] Do
  Begin
    I := G[Q, II];
    If F[Nr[I]] = 1 Then
    Begin
      RRes(I, Q);
    End;
  End;
{  For II := 1 To N Do
    If (Nr[II] <> 0) And (II <> Q) And (F[Nr[II]] = 1) Then
      RRes(II, Q);}
End;

Procedure WriteOut;

Var
  F : Text;
  I, J : Integer;

Begin
  ASSign(F, 'ROUTES.OUT');
  Rewrite(F);
  For I := 1 To N Do
    For J := I + 1 To N Do
      If Res[I, J] Then
        Writeln(F, I, ' ', J);
  Close(F);
End;

Var
  I : Integer;

Begin
  ReadIn;
  GNr := 0;
  Dig(-1, 1);
{  For I := 1 To N Do
    Writeln(Low[I]);}

  FillChar(Nr, SizeOf(Nr), 0);
  GNr := 0;
  For I := 1 To N Do
  Begin
    If (Nr[I] = 0) And (Not A[I]) Then
    Begin
      Inc(GNr);
      Dig2(I);
    End;
  End;
{  Writeln;
  For I := 1 To N Do
    Writeln(Nr[I]);}
  For I := 1 To N Do
    If A[I] Then
      Check(I);
  If N = 2 Then
    RRes(1, 2);
  WriteOut;
End.