{$IFDEF vesko}

USes DOS;
{$ENDIF}
const  infile = 'routes.inp';
      outfile = 'routes.out';
         MaxN = 170;
          inf = 99999;
type arr  = array [1..MaxN,1..MaxN] of boolean;
     darr = array [1..MaxN] of longint;
     parr = array [1..MaxN] of boolean;
var a,b: arr;
    d  : darr;
    n  : integer;
    p  : parr;
    clk1,clk2 : real;
{$IFDEF vesko}
Procedure Marktime;
 var h,m,s,ms: word;
 begin
 gettime(h,m,s,ms);
 clk1:=ms+s*100.0+m*6000.0+h*360000;
 end;

Procedure ShowTime;
 var h,m,s,ms: word;
 begin
 gettime(h,m,s,ms);
 clk2:=ms+s*100.0+m*6000.0+h*360000;
 writeln('Processing time: ',(clk2-clk1)/100:1:2,' seconds.');
 end;

{$ENDIF}
Procedure InX;
 var t : text;
     i : integer;
     x,y : integer;
     s : string;
 begin
 {init}
 fillchar(a,sizeof(a),0);
 fillchar(b,sizeof(b),0);
 fillchar(d,sizeof(d),0);

 assign(t, infile);
 reset (t);
 readln(t,n);
 for i:=1 to n do
  begin
  readln(t,s);
  if s<>'' then
  repeat
  if pos(' ',s)<>0 then val(copy(s,1,pos(' ',s)-1),x,y)
                   else val(s,x,y);
  a[i,x]:=TRUE;
  if pos(' ',s)<>0 then delete(s,1,pos(' ',s))
                   else s:='';
  until s = '';
  end;
 close (t);
 end;

Procedure Bt(node: byte);
 var i : byte;
 begin
 p[node]:=TRUE;
 for i:=1 to n do if (a[node,i]) and (not p[i]) then bt(i);
 end;

Function isConnected(d1,d2: integer): Boolean;
 var i,j: byte;
 begin
{ for i:=1 to n do
  begin
  fillchar(p,sizeof(p),0);
  bt(i);
  for j:=1 to n do if (not p[j]) then
   begin
   isConnected:=FALSE;
   exit;
   end;
  end;
 isConnected := TRUE;}
 fillchar(p,sizeof(p),0);
 bt(d1);
 for j:=1 to n do if (not p[j]) then
   begin
   isConnected:=FALSE;
   exit;
   end;
 fillchar(p,sizeof(p),0);
 bt(d2);
 for j:=1 to n do if (not p[j]) then
   begin
   isConnected:=FALSE;
   exit;
   end;
 isConnected:=TRUE;
 end;


Procedure DoWork;
 var i,j : integer;
 begin
 for i:=1 to n-1 do
  for j:=i+1 to n do if a[i,j] then
   begin
   a[i,j]:=FALSE;
   if not isconnected(i,j) then b[i,j]:=TRUE;
   a[i,j]:=TRUE;
   end;
 end;

Procedure OutX;
 var t:text;
     i,j : integer;
 begin
 assign(t, outfile);
 rewrite(t);
 for j:=1 to n-1 do
  for i:=j+1 to n do if b[j,i] then writeln(t,j,' ',i);
 close(t);
 end;

BEGIN

InX;
{$IFDEF vesko}
marktime;
{$ENDIF}
DoWork;
{$IFDEF vesko}
showtime;
{$ENDIF}

OutX;
END.