#include <stdio.h>

#define prevals

int mas[11][11];
int cnt,we,he;

int rememb[12][12];

int rekurs(int c)
{
  int i,j,x,y;

  if (c==0) { cnt++; return 0; }

/*  printf("\n");
  for (i=0;i<h;i++)
  {
    for (j=0;j<w;j++)
    {
       printf("%d ",mas[j][i]);
    }
    printf("\n");
  } */


  x=-1;
  for (i=0;i<we;i++)
  {
    for (j=0;j<he;j++)
    {
      if (mas[i][j]==-1) { x=i; y=j; break; }
    }
  }
  if (x==-1) { /* printf("Error!\n"); */ return 0; }

  mas[x][y] = 1;
  if ((x>=1) && (mas[x-1][y]==0)) {
    mas[x-1][y]=1;
    rekurs(c-2);
    mas[x-1][y]=0;
  }
  if ((y>=1) && (mas[x][y-1]==0)) {
    mas[x][y-1]=1;
    rekurs(c-2);
    mas[x][y-1]=0;
  }
  if ((x<we-1) && (mas[x+1][y]==0)) {
    mas[x+1][y]=1;
    rekurs(c-2);
    mas[x+1][y]=0;
  }
  if ((y<he-1) && (mas[x][y+1]==0)) {
    mas[x][y+1]=1;
    rekurs(c-2);
    mas[x][y+1]=0;
  }
  mas[x][y] = -1;
  return 0;
}

int emas(int lw,int lh)
{
  int i,j;
   for (i=0;i<lw;i++)
   {
     for (j=0;j<lh;j++)
     {
       mas[i][j]=0;
     }
   }
   return 0;
}

int populv(int lw,int lh)
{
  int c,c1,c2,i,j,t;
  c=0;
  c1=0;
  c2=0;

  he=lh;
  we=lw;

  for (i=0;i<we;i++)
  {
    for (j=0;j<he;j++)
    {
      if (mas[i][j]==0) { c++;
        if ((i+j)%2==1) { c1++; } else { c2++; }
      }
    }
  }

  if (c%2!=0) {
    cnt=0;
    return 0;
  }

  if (c1==c/2) {
    t=1;
  } else {
    if (c2==c/2) { t=0; } else
    {
      cnt=0;
//      printf("Cannot be divided %d %d %d",c,c1,c2);
      return 0;
    }
  }

  for (i=0;i<we;i++)
  {
    for (j=0;j<he;j++)
    {
      if (mas[i][j]==0) {
        if ((i+j)%2==t) { mas[i][j]=-1; }
      }
    }
  }

  cnt=0;

  rekurs(c);
  return cnt;
}

int probvay(int n,int lw,int lh)
{
   int i;

   if (lw==0) { return 1; }

   emas(lw,lh);

//   printf("i=%d\n",n);

   for (i=0;i<lh;i++)
   {
     if (n & (1<<i)) {
     mas[0][i]=1; }
   }

//   for (i=0;i<lh;i++)
//   {
//     printf("%d",mas[0][i]);
//   }

   populv(lw,lh);
//   printf("  current count = %d, pri %d %d",cnt,lw,lh);
//   printf("\n");

   return cnt;
}

int count(int w,int h)
{
  int od;
  if ((w*h)%2==1) { return 0; } // Nechetno
  if ((w*h)==0) { return 1; }

  if (rememb[w][h] != -1) { return rememb[w][h]; }

  if (w<h) { return count(h,w); }
  if (h==1) { return 1; } // ----
  if (w*h==4) { return 2; } // || =

  if (h==2) { // delim na dve 4asti
    int w1,w2;

    w1=w/2;
    w2=w-w1;
//    printf("Calculating %d %d - w1=%d w2=%d\n",w,h,w1,w2);

    od= (count(w1,h)*count(w2,h)) + ( count(w1-1,h)*count(w2-1,h) );
    rememb[w][h] = od;
    return od;
  } else
  {
    int t,w1,w2,b,c,morc,i,tmp;

    if (h%2==1)
    {
       t=h; h=w; w=t;
    } // h e chetno

    w1=w/2;
    w2=w-w1;

    b=h/2;

    c=(1<<b) - 1;  // broy na chislata s b bita i pone edna edinica
//    printf("Calculating %d %d - w1=%d w2=%d * %d ot %d\n",w,h,w1,w2,c,b);

    if (w1==w2)
    {
      morc=0;
      for (i=(1<<(h))-2;i>0;i--)
      {
        tmp=probvay(i,w1,h);
        morc+=tmp*tmp;
      }
    } else {
      morc=0;
      for (i=(1<<(h))-2;i>0;i--)
      {
        tmp=probvay(i,w1,h);
        if (tmp!=0) {
          morc+=tmp*probvay(i,w2,h);
        }
      }
    }

    od= (morc + (count(w1,h)*count(w2,h)) + (count(w1-1,h)*count(w2-1,h)));
    rememb[w][h] = od;
    return od;
  }
}

void initrememb(void)
{
  int i,j;
  for (i=0;i<12;i++)
  {
    for (j=0;j<12;j++)
    {
      rememb[i][j] = -1;
    }
  }
#ifdef prevals
  rememb[8][8] = 12988816;
  rememb[9][8] = 108435745;
  rememb[9][6] = 817991;
  rememb[11][6] = 21001799;
  rememb[10][6] = 4213133;
  rememb[10][7] = 53175517;
  rememb[10][5] = 185921;
  rememb[10][8] = 1031151241;
#endif
}


int main(void)
{
  FILE* f;
  int w,h;
  f = fopen("build.inp","rt");
  fscanf(f,"%d %d",&w,&h);
  fclose(f);
//  printf("%d %d\n",w,h);

//  emas(6,11);
//  populv(w,h);
//  printf("\n  %d\n",cnt);

  initrememb();
//  printf("  %d\n",count(w,h));

  f = fopen("build.out","wt");
  fprintf(f,"%d",count(w,h));
  fclose(f);

  return 0;
}
