#include <stdio.h>

int n=81;
int i,j;
int step;

int a[82][5];

int br[82];
int out[82];


void MnoSolve(int p,int q,int r){
	int same=0;
	for(int k=1;k<=4;k++)
		if((a[p][k]==a[q][k] && a[q][k]==a[r][k])||
				(a[p][k]!=a[q][k] && a[p][k]!=a[r][k] && a[q][k]!=a[r][k])) same++;
	if(same == 4){
		int best = p;
		if(br[q]>br[best]) best=q;
		if(br[r]>br[best]) best=r;
		br[q]--;
		br[p]--;
		br[r]--;
		out[best]=1;
	}
}

void MnoInit(int p,int q,int r){
	int same=0;
	for(int k=1;k<=4;k++)
		if((a[p][k]==a[q][k] && a[q][k]==a[r][k])||
				(a[p][k]!=a[q][k] && a[p][k]!=a[r][k] && a[q][k]!=a[r][k])) same++;
	if(same == 4){
		br[i]++;
		br[k]++;
		br[j]++;
	}
}

void Solve(){
	int k,p;
	for(i=0;i<=2;i++)
		for(j=0;j<=2;j++)
			for(k=0;k<=2;k++)
				for(p=0;p<=2;p++){
					step++;
					a[step][1]=i;
					a[step][2]=j;
					a[step][3]=k;
					a[step][4]=p;
				}

	for(i=1;i<=n-2;i++)
		for(j=i+1;j<=n-1;j++)
			for(k=j+1;k<=n;k++)
				MnoInit(i,j,k);

	for(i=1;i<=n-2;i++)
		for(j=i+1;j<=n-1;j++)
			for(k=j+1;k<=n;k++)
				if(!out[i] && !out[j] && !out[k])
					 MnoSolve(i,j,k);

}

void Output(){
	FILE *f = fopen("setfree.txt","wt");
	int broi=0;
	for(i=1;i<=n;i++)
		if(!out[i]) broi++;
	fprintf(f,"%d\n",broi);
	for(i=1;i<=n;i++)
		if(!out[i])
			fprintf(f,"%d %d %d %d\n",a[i][1],a[i][2],a[i][3],a[i][4]);
	fclose(f);
}

int main(){
	Solve();
	Output();
return 0;
}