#include <iostream.h>
#include <values.h>
#include <stdlib.h>

int n;
int x[202],y[202];
int w[170][170],label[202];
int perm[202];
int path[202];

void read()
{ cin>>n;
  for (int i=1;i<=n;i++)
    cin>>x[i]>>y[i];
}

long abs(long a,long b)
{ long c;
  c=a-b;
  if (c<0) return c*(-1);
  return c;
}

void initw()
{ for (int i=0;i<=n;i++)
    for (int j=0;j<=n;j++)
     { if (i==j) { w[i][j]=0;
		   continue;
		 }
       w[i][j]=MAXINT/2;
     }
  for (i=1;i<n;i++)
    for (int j=2;j<=n;j++)
     { w[i][j]=abs(x[i],x[j])+abs(y[i],y[j]);
       w[j][i]=abs(x[i],x[j])+abs(y[i],y[j]);
     }
}

void dejkstra(int s)
{ for (int i=1;i<=n;i++)
   { if (i==s) label[i]=0;
       else label[i]=MAXINT/2;
     perm[i]=0;
     path[i]=0;
   }
  long mdist,bi,pathp=1;
  while (1)
   { mdist=MAXINT/2;
     for (i=1;i<=n;i++)
       if (!perm[i] && mdist>label[i]) { mdist=label[i];
					     bi=i;
					   }
     if (mdist==MAXINT/2) return;
     perm[bi]=1;
     path[pathp]=bi;
     pathp++;
     for (int j=1;j<=n;j++)
       if (!perm[j] && label[j]>label[bi]+w[bi][j])
	 label[j]=label[bi]+w[bi][j];
   }
}

void write()
{ for (int i=1;i<=n;i++)
    cout<<path[i]<<' ';
  cout<<endl;
}

void main()
{ read();
  if (n>170) exit(1);
  initw();
  dejkstra(1);
  write();
}