Type Sp = ^Rec;
     S  = ^R;
     Rec = Record
          pFr:Byte;
          pTo:Byte;
          Len:Word;
          Adr:Sp;
     End;
     R = Record
       N:Byte;
       L:S;
     End;

Var M:Byte; F:Text; P:Sp; MLen:Word; Out:S;

Procedure Del(var P:Sp; var pFr,pTo:Byte; var Len:Word);
Var Q:Sp;
Begin
     Q:=P;
     pFr:=Q^.pFr;
     pTo:=Q^.pTo;
     Len:=Q^.Len;
     P:=P^.Adr;
     Dispose(Q);
End;

Procedure Inp(Var P:S; X:Byte);
Var Q:S;
Begin
     New(Q);
     Q^.N:=X;
     Q^.L:=P;
     P:=Q;
End;

Function D(var P:S):Byte;
Var Q:S;
Begin
     Q:=P;
     D:=Q^.N;
     P:=P^.L;
     Dispose(Q);
End;

Procedure Rever;
Var Q:S;
Begin
     Q:=Out;
     Out:=Nil;
     While Q<>Nil Do
           Inp(Out,D(Q));
End;

Procedure Input(var P:Sp; X:Word; pFr,pTo:Byte);
Var Q:Sp;
Begin
     New(Q);
     Q^.Len:=X;
     Q^.pTo:=pTo;
     Q^.pFr:=pFr;
     Q^.Adr:=P;
     P:=Q;
End;

Procedure Rev;
Var Q:Sp; X,Y:Byte; Z:Word;
Begin
     Q:=P;
     P:=Nil;
     While Q<>Nil Do Begin
           Del(Q,X,Y,Z);
           Input(P,Z,X,Y);
     End;
End;

Procedure MaxLen;
Var Q:Sp; I,J:Byte; Max:Integer;
Begin
     Q:=P; MLen:=0;
     For I:=1 To M-1 Do Begin
         Max:=Q^.Len;
         For J:=1 To M-I-1 Do Begin
             Q:=Q^.Adr;
             If Max<Q^.Len Then Max:=Q^.Len;
         End;
         MLen:=MLen+Max;
     End;
End;

Procedure Ent;
Var A:Array[1..200,1..2] Of Integer; I,J:Byte;
Begin
     Assign(F,'travel.inp');
     Reset(F);
     Readln(F,M);
     For I:=1 To M Do
           Readln(F,A[I,1],A[I,2]);
     Close(F);
     For I:=1 To M-1 Do
         For J:=I+1 To M Do
             Input(P,Abs(A[I,1]-A[J,1])+Abs(A[I,2]-A[J,2]),I,J);
     Rev;
     MaxLen;
End;

Function Find(X,Y:Byte):Word;
Var Q:Sp; Rez:Word;
Begin
     If X>Y Then Begin Rez:=X; X:=Y; Y:=Rez; End;
     Q:=P; Rez:=0;
     While Q<>Nil Do Begin
           If (Q^.pFr=X) And (Q^.pTo=Y) Then Begin Rez:=Q^.Len; Break; End;
           Q:=Q^.Adr;
     End;
     Find:=Rez;
End;

Function Found(P:S; X:Byte):Boolean;
Var Flag:Boolean;
Begin
     Flag:=False;
     While P<>Nil Do Begin
           If P^.N=X Then Flag:=True;
           P:=P^.L;
     End;
     Found:=Flag;
End;

Procedure Opt(Len:Word);
Var Q:S;
Begin
     If MLen>Len Then Begin
        MLen:=Len;
        Rever;
        Assign(F,'Travel.out');
        Rewrite(F);
        Q:=Out;
        While Q<>Nil Do Begin
              Write(F,Q^.N,' ');
              Q:=Q^.L;
        End;
        Close(F);
        Rever;
     End;
End;

Procedure Travel(pFrom,Count:Byte; Total:Word);
Var I,J:Byte; DD:Word;
Begin
     If Count=M Then
        Opt(Total)
     Else
         For J:=1 To M Do Begin
             If Found(Out,J) Then Continue;
             Inp(Out,J);
             Travel(J,Count+1,Total+Find(pFrom,J));
             DD:=D(Out);
         End;
End;

BEGIN
     P:=Nil;
     Out:=Nil;
     Inp(Out,1);
     Ent;
     Travel(1,1,0);
END.