
type acard=record a,b,c,d:byte; flag : boolean; end;

var ALL:array[1..81] Of acard;

procedure generate;
var i, j, k, l : byte;
    n : byte;
begin
   n := 0;
   for i:= 0 to 2 do
      for j := 0 to 2 do
         for k := 0 to 2 do
            for l := 0 to 2 do begin
               inc(n);
               all[n].a := i;
               all[n].b := j;
               all[n].c := k;
               all[n].d := l;
               all[n].flag := true;
            end;
end;

function checkinst(c1, c2, c3 : Byte) : boolean;
var ret : boolean;
begin
   ret := false;
   checkinst := false;
   if (all[c1].a = all[c2].a) and (all[c2].a = all[c3].a) then ret := true;
   if (all[c1].a <> all[c2].a) and (all[c2].a <> all[c3].a) and
      (all[c1].a <> all[c3].a) then ret := true;
   if not ret then exit;
   ret := false;
   if (all[c1].b = all[c2].b) and (all[c2].b = all[c3].b) then ret := true;
   if (all[c1].b <> all[c2].b) and (all[c2].b <> all[c3].b) and
      (all[c1].b <> all[c3].b) then ret := true;
   if not ret then exit;
   ret := false;
   if (all[c1].c = all[c2].c) and (all[c2].c = all[c3].c) then ret := true;
   if (all[c1].c <> all[c2].c) and (all[c2].c <> all[c3].c) and
      (all[c1].c <> all[c3].c) then ret := true;
   if not ret then exit;
   ret := false;
   if (all[c1].d = all[c2].d) and (all[c2].d = all[c3].d) then ret := true;
   if (all[c1].d <> all[c2].d) and (all[c2].d <> all[c3].d) and
      (all[c1].d <> all[c3].d) then ret := true;
   if not ret then exit;
   checkinst := true;
end;

function check(n : byte) : boolean;
var i, j : byte;
begin
   check := false;
   for i := 1 to n-2 do begin
      if not all[i].flag then continue;
      for j := i+1 to n-1 do begin
         if not all[j].flag then continue;
         if checkinst(i,j,n) then begin
            check := true;
            exit;
         end;
      end;
   end;
end;

procedure exclude;
var i : byte;
begin
   for i := 3 to 81 do begin
      if check(i) then begin
         all[i].flag := false;
      End;
   end;
end;

function count : byte;
var i, r : byte;
begin
   r := 0;
   for i := 1 to 81 do if all[i].flag then inc(r);
   count := r;
end;

procedure output;
var f : text;
    i : byte;
begin
   assign(f, 'setfree.txt');
   rewrite(f);
   writeln(f, count);
   for i := 1 to 81 do begin
      if not all[i].flag then continue;
      writeln(f, all[i].a, ' ', all[i].b, ' ', all[i].c, ' ', all[i].d);
   end;
   close(f);
end;

begin
   generate;
   exclude;
   output;
end.