(*
    Nikolay Georgiev Semov    A71
    11b klas PMG - Haskovo
*)

Type TPOINT = Record
                 X, Y : Integer;
                 Flag : Boolean;
              End;

     TPSET = Set Of Byte;

     TARR = Array[1..200] Of Byte;

Var P : Array[1..200] Of TPOINT;
    N : Byte;
    RESULT : TARR;
    _TEMP1 : TARR;
    _MIN : Longint;
    _TEMP : LONGINT;

Function Dist(P1, P2 : Byte) : Word;
Var Ret : Word;
Begin
   Ret := Abs(P[P1].X - P[P2].X);
   Ret := Ret + Abs(P[P1].Y - P[P2].Y);
   Dist := Ret;
End;

Function NearDist(P1, P2 : Byte) : Word;
Var Ret1, Ret2 : Word;
Begin
   Ret1 := Abs(P[P1].X - P[P2].X);
   Ret2 := Abs(P[P1].Y - P[P2].Y);
   If Ret1 > Ret2 Then
      NearDist := Ret1
   Else NearDist := Ret2;
End;

Function CalcSolution : Longint;
Var i : Integer;
    R : Longint;
Begin
   R := 0;
   For i := 1 To N - 1 Do Begin
      R := R + Dist(RESULT[i], RESULT[i+1]);
   End;
   R := R + Dist(RESULT[N], 1);
   CalcSolution := R;
End;

Procedure MoveArr(Source : TARR; Var Target : TARR);
Var i : Byte;
Begin
   For i := 1 To N Do Target[i] := Source[i];
End;

Procedure FindNearestPoints(Rel : Byte; Var Res : TPSET);
Var i : Byte; Min : Word; Temp : Word;
Begin
   Res := [];
   Min := 60000;
   For i:= 1 To N Do Begin
      If Not P[i].Flag Then Continue;
      Temp := NearDist(Rel, i);
      If Temp < Min Then Begin
         Res := [i];
         Min := Temp;
      End Else Begin
         If Temp = Min Then Begin
            Res := Res + [i];
         End;
      End;
   End;
End;

Procedure GetMinLen(SP : Byte; CNT : Byte);
Var R : TPSET;
    i : Byte;
Begin
   RESULT[CNT] := SP;
   P[SP].Flag := False;
   FindNearestPoints(SP, R);
   If R = [] Then Begin
      _TEMP := CalcSolution;
      If _TEMP < _MIN Then Begin
         _MIN := _TEMP;
         MoveArr(RESULT, _TEMP1);
      End;
      P[SP].Flag := True;
      Exit;
   End;
   For i := 1 To N Do Begin
      If Not (i In R) Then Continue;
      If Not P[i].Flag Then Continue;
      GetMinLen(i, CNT + 1);
   End;
   P[SP].Flag := True;
End;

Procedure Solve;
Var i : Byte;
Begin
   _MIN := 2147483647;
   GetMinLen(1, 1);
   MoveArr(_TEMP1, RESULT);
   For i := 1 To N Do Write(RESULT[i], ' ');
   WriteLn;
End;

Procedure Input;
Var i : Byte;
Begin
   ReadLn(N);
   For i := 1 To N Do Begin
      Read(P[i].X); ReadLn(P[i].Y);
      P[i].Flag := True;
   End;
End;

Procedure Klutz;
Begin
   Input;
   Solve;
End;

BEGIN
   Klutz;
END.