#include <stdio.h>

#define MAXN	65536

int num[MAXN];
int orig[MAXN];
int n;
int parent[MAXN];

int have[MAXN];
int list[MAXN];
int lc;

void read_data() {
	int i;

	scanf("%d", &n);
	for(i = 1; i <= n; i++) {
		scanf("%d", &orig[i]);
		num[i] = orig[i]%n;
	}
}

void print_result(int a, int d) {
	if (parent[a] < 0) {
		printf("%d %d", d+1, orig[-parent[a]]);
		return;
	}
	print_result((a - num[parent[a]] + n)%n, d+1);
	printf(" %d", orig[parent[a]]);
}

void solve() {
	int i, j;
	int t;

	for (i = 1; i <= n; i++) {
		for (j = lc - 1; j >= 0; j--) {
			t = (list[j] + num[i])%n;
			if (have[t])
				continue;
			have[t] = 1;
			list[lc++] = t;
			parent[t] = i;
		}
		if (have[num[i]])
			continue;
		have[num[i]] = 1;
		list[lc++] = num[i];
		parent[num[i]] = -i;

		if (have[0])
			break;
	}

	if (have[0])
		print_result(0, 0);
	else
		printf("-1");

	printf("\n");
}

int main() {
	read_data();
	solve();
	return 0;
}
