#include <stdio.h>
#include <stdlib.h>

#define MAXN 100000

#define MAGIC 4000

int a[MAXN], m;
long long suma;
int b[MAXN], n;
long long sumb;

int sa[MAGIC];
int sb[MAGIC];
int s[MAGIC];

int int_cmp(const void *a, const void *b) {
	return (*((int*)a) - *((int*)b));
}

void read_data() {
	int i;

	scanf("%d", &m);
	for (i = 0; i < m; i++) {
		scanf("%d", &a[i]);
		suma += a[i];
	}
	a[m++] = MAGIC+1;
		
	scanf("%d", &n);
	for (i = 0; i < n; i++) {
		scanf("%d", &b[i]);
		sumb += b[i];
	}
	b[n++] = MAGIC+1;

	qsort(a, m, sizeof(int), int_cmp);
	qsort(b, n, sizeof(int), int_cmp);
}

void solve() {
	int i, j;
	int min = MAGIC + 1;
	
	sa[0] = sb[0] = 1;

	for (i = 0; a[i] < MAGIC; i++)
		for (j = MAGIC-1; j >= a[i]; j--)
			if (sa[j - a[i]] > 0)
				sa[j] = 1;

	for (i = 0; b[i] < MAGIC; i++)
		for (j = MAGIC-1; j >= b[i]; j--)
			if (sb[j - b[i]] > 0)
				sb[j] = 1;

	for (i = 0; i < MAGIC; i++) {
		if (sa[i] == 0)
			continue;
		for (j = 0>i-min?0:i-min; j < i ; j++) {
			if (sb[j] == 0)
				continue;
			s[i-j] = 1;
			if ((i-j) < min)
				min = i-j;
		}
	}

	if (min < MAGIC)
		printf("%lld\n", suma - min);
	else
		printf("0\n");
}

int main() {
	read_data();
	solve();
	return 0;
}
