Program Nubia;

Const MaxSt  = 1000000;
      MaxBr  = 100000;

Type Ogr   = 1 .. MaxBr;
     TData = 1 .. MaxSt;
     TList = Array[Ogr] Of TData;
     TSum  = Int64;

Var k, p : TList;
    m, n : Ogr;
    sum  : TSum;

Procedure Input;

 Var i : Ogr;

  Begin
    sum := 0;
    Read(m);
    For i := 1 To m Do
      Begin
        Read(k[i]);
        Inc(sum, k[i])
      End;
    ReadLn;
    Read(n);
    For i := 1 To n Do
      Read(p[i])
  End;

Procedure Solve;

 Var i      : Ogr;
     Found  : Boolean;
     newsum : TSum;

 Procedure QSort(Var a : TList; Lo, Hi : Ogr);

   Procedure Sort(l, r : Ogr);

    Var i, j : Ogr;
        x, y : TData;

     Begin
       i := l;
       j := r;
       x := a[(l+r) Div 2];
       Repeat
         While a[i] < x Do
           Inc(i);
         While x < a[j] Do
           Dec(j);
         If i <= j Then
           Begin
             y := a[i];
             a[i] := a[j];
             a[j]:=y;
             Inc(i);
             Dec(j)
           End;
       Until i > j;
       If l < j Then Sort(l, j);
       If i < r Then Sort(i, r);
     End;

    Begin
      Sort(Lo,Hi)
    End;

  Procedure Find(a : TList; l, ind : Ogr; fsum : TSum);

   Var i : ogr;

    Begin
      If fsum = 0 Then
        Found := True
      Else
        For i := ind To l Do
          If (fsum > 0) And (Not Found) Then
            Begin
              Dec(fsum, a[i]);
              Find(a, l, ind+1, fsum);
              Inc(fsum, a[i])
            End
          Else
            Exit
    End;

  Begin
    QSort(k, 1, m);
    QSort(p, 1, n);
    newsum := sum;
    For i := 1 To Sum-1 Do
      Begin
        Found  := False;
        Find(k, m, 1, i);
        If Not Found Then
          Find(p, n, 1, newsum-sum+i)
        Else newsum := sum-i;
        If Not Found Then
          Begin
            Write(sum-i);
            Exit
          End
      End;
    Write(0)
  End;

Begin
  Input;
  Solve
End.
