#include <iostream>

using namespace std;

const int dr0[] = {-1, +1, +2, +1, -1, -2};
const int dc0[] = {+1, +1, 0, 0, 0, 0};
const int dr1[] = {-1, +1, +2, +1, -1, -2};
const int dc1[] = {0, 0, 0, -1, -1, 0};
const int INF = 500000;

int N, M, K;
int a[100 + 1][100 + 1];
bool p[100 + 1][100 + 1];
int l[100 + 1][100 + 1];
int D[100 + 1][100 + 1];
int Dg[100 + 1][100 + 1];
int ri, ci;
int r[50 + 1];
int c[50 + 1];
int s_r[100 + 1][100 + 1][6];
int s_c[100 + 1][100 + 1][6];
int bs[100 + 1][100 + 1];

void prep1(int r, int c) {
	int i;
	bs[r][c] = 0;

	if (r % 2 == 0) {
		//cheten red
		for (i = 0; i < 6; i++) {
			int nr = r + dr0[i];
			int nc = c + dc0[i];
			if (nr >= 1 && nr <= N && nc >= 1 && nc <= M) {
				if (!p[nr][nc]) {
					s_r[r][c][bs[r][c]] = nr;
					s_c[r][c][bs[r][c]] = nc;
					bs[r][c]++;
				}
			}
		}
	} else {
		//necheten red
		for (i = 0; i < 6; i++) {
			int nr = r + dr1[i];
			int nc = c + dc1[i];
			if (nr >= 1 && nr <= N && nc >= 1 && nc <= M) {
				if (!p[nr][nc]) {
					s_r[r][c][bs[r][c]] = nr;
					s_c[r][c][bs[r][c]] = nc;
					bs[r][c]++;
				}
			}
		}
	}
}

void izd(int r, int c, int D[100 + 1][100 + 1]) {
	bool mark[100 + 1][100 + 1];
	int i, j;
	int n;
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			mark[i][j] = false;
			D[i][j] = INF;
		}
	}

	D[r][c] = 0;
	n = N * M;
	while (n > 0) {
		int best_d = INF;
		int best_r, best_c;
		for (i = 1; i <= N; i++) {
			for (j = 1; j <= M; j++) {
				if (!mark[i][j]) {
					if (D[i][j] < best_d) {
						best_d = D[i][j];
						best_r = i;
						best_c = j;
					}
				}
			}
		}
		mark[best_r][best_c] = true;
		n--;
		for (i = 0; i < bs[best_r][best_c]; i++) {
			int nr = s_r[best_r][best_c][i];
			int nc = s_c[best_r][best_c][i];
			if (best_d + a[best_r][best_c] < D[nr][nc]) {
				D[nr][nc] = best_d + a[best_r][best_c];
			}
		}
	}

}

int main() {
	int i, j, k;
	cin >> N >> M >> K;
	for (i = 1; i <= N; i++) {
		for (int j = 1; j <= N; j++) {
			char c;
			cin >> c;
			if (c == 'X') {
				p[i][j] = true;
			} else {
				p[i][j] = false;
				a[i][j] = c - '0';
			}
		}
	}

	cin >> ri >> ci;
	for (i = 1; i <= K; i++) {
		cin >> r[i] >> c[i];
	}
	
	//SOLVE
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			if (!p[i][j]) {
				prep1(i, j);
			}
		}
	}

	/*
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			cout << i << ", " << j << ":\n";
			for (k = 0; k < bs[i][j]; k++) {
				cout << " " << s_r[i][j][k] << ", " << s_c[i][j][k] << '\n';
			}
		}
	}
	*/


	//V2

	izd(r[1], c[1], D);
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			l[i][j] = D[i][j];
		}
	}
	for (k = 2; k <= K; k++) {
		izd(r[k], c[k], D);
		for (i = 1; i <= N; i++) {
			for (j = 1; j <= M; j++) {
				if (D[i][j] < l[i][j]) {
					l[i][j] = D[i][j];
				}
			}
		}
	}
	izd(ri, ci, Dg);
/*
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			cout << "l[" << i << "][" << j << "]=" << l[i][j] << '\n';
		}
	}
*/
/*
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			cout << "Dg[" << i << "][" << j << "]=" << Dg[i][j];
			if (Dg[i][j] > l[i][j]) cout << "x";
			cout << '\n';
		}
	}
*/
	int best = 0;
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			if (Dg[i][j] < l[i][j]) {
				if (l[i][j] > best) {
					best = l[i][j];
				}
			}
		}
	}

	cout << best << '\n';

	return 0;
}