#include <iostream>

using namespace std;

class Node {
public:
	int d;
	Node* next;
};

int N;
int a[32768 + 1];
Node* l[32768];
int broj[32768];
int cache[2800 + 1][2800 + 1];
bool ch[2800 + 1][2800 + 1];

const int INF = 500000;

int f(int i, int m, int N) {
	if (cache[i][m] >= 0) return cache[i][m];
	if (i == 0) {
		if (m == 0) return 0;
		else return INF;
	} else {
		int v1 = 1 + f(i - 1, (a[i] + m) % N, N);
		int v2 = f(i - 1, m, N);
		if (v1 >= INF && v2 >= INF) {
			ch[i][m] = false;
			return cache[i][m] = INF;
		}
		if (v1 < INF && v2 < INF) {
			if (v1 > v2) {
				ch[i][m] = true;
				return cache[i][m] = v1;
			} else {
				ch[i][m] = false;
				return cache[i][m] = v2;
			}
		}
		if (v1 >= INF && v2 < INF) {
			ch[i][m] = false;
			return cache[i][m] = v2;
		}

		if (v1 < INF && v2 >= INF) {
			ch[i][m] = true;
			return cache[i][m] = v1;
		}

	}
}

void vz(int i, int m, int N) {
	if (i == 0) {
		return;
	} else {
		if (ch[i][m]) {
			cout << " " << a[i];
			vz(i - 1, (a[i] + m) % N, N);
		} else {
			vz(i - 1, m, N);
		}
	}
}

inline int min(int a, int b) {
	if (a < b) return a;
	else return b;
}

inline void insert_before(Node*& p, int x) {
	Node* q = new Node;
	q->d = x;
	q->next = p;
	p = q;
}

int main() {
	int i, j;
	cin >> N;
	for (i = 1; i <= N; i++) {
		cin >> a[i];
	}

	if (N >= 2800) {
		goto xxx;
	}

	for (i = 0; i <= N; i++) {
		for (j = 0; j < N; j++) {
			cache[i][j] = -1;
			ch[i][j] = false;
		}
	}

	int M;
	M = f(N, 0, N);

	if (M == 0) {
		cout << "-1\n";
	} else {
		cout << M;
		vz(N, 0, N);
		cout << '\n';
	}

	return 0;

xxx:

	for (i = 0; i < N; i++) {
		broj[i] = 0;
		l[i] = NULL;
	}

	for (i = 1; i <= N; i++) {
		int m = a[i] % N;

		insert_before(l[m], a[i]);
		broj[m]++;
	}

	/*
	for (i = 0; i < N; i++) {
		cout << "broj[" << i << "]=" << broj[i] << '\n';
	}
	*/

	/*
	for (i = 0; i < N; i++) {
		cout << i << ":";
		Node* p = l[i];
		while (p != NULL) {
			cout << " " << p->d;
			p = p->next;
		}
		cout << '\n';
	}
	*/


	//Node* answer = NULL;

	if (broj[0] > 0) {
		cout << "1 " << l[0]->d << '\n';
		return 0;
	}

	for (i = 0; i <= N / 2; i++) {
		if (broj[i] > 0 && broj[N - i] > 0) {
			cout << "2 " << l[i]->d << " " << l[N - i]->d << '\n';
			break;
		}
	}
	//cout << "kraj\n";


	return 0;
}