#include <stdio.h>
#include <malloc.h>

#define INF (1<<20)
#define M 10000

typedef struct sys sys;
typedef struct spi spi;

struct sys{
	int vryh;
	sys *next;
};

struct spi{
	int vreme;
	int br;
	sys *next;
};



void main() {
	int i, j, k, n, m, l, x1, y1, v, min;
	int fromigr, toigr, nextigr;
	int fromizv, toizv, nextizv;
	int opigr[M];
	int opizv[M];
	int pytdoizv[M];
	int pytdoigr[M];

	int flag[M];
	spi a[M];

	char inp[128][128];
	char t;
	sys *p;

	//freopen("chase.inp", "r", stdin);

	scanf("%d%d%d", &n, &m, &k);
	for(i=0; i<n*m; i++) {
		flag[i]=0;
		a[i].next = NULL;
		a[i].vreme = -1;
		a[i].br = 0;
		pytdoizv[i] = INF;
		pytdoigr[i] = INF;
	}

	for(j=0; j<n; j++) {
		scanf("%s", inp[j]);
		for(i=0; i<m; i++) {
			if(inp[j][i]!='X') {
				v = j*m+i; 
				a[v].vreme = inp[j][i] - '0';
				x1 = i;
				y1 = j+2;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
				x1 = i;
				y1 = j-2;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
				x1 = i-((j+1)%2);
				y1 = j+1;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
				x1 = i-((j+1)%2);
				y1 = j-1;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
				x1 = i + (j%2);
				y1 = j-1;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
				x1 = i + (j%2);
				y1 = j+1;
				if(x1 >= 0 && x1 < m && y1 >= 0 && y1 < n && flag[j*m+i]!=-1) {
					p = (sys *)malloc(sizeof(sys));
					p->next = a[v].next;
					p->vryh = y1*m + x1;
					a[v].next = p;
					a[v].br++;
				}
			}
			else 
				flag[j*m+i] = -1;
		}
	}
	scanf("%d%d", &x1, &y1);
	x1--;
	y1--;
	pytdoigr[y1*m+x1] = 0;
	flag[y1*m+x1] = 0;
	for(i=0; i<n*m; i++) {
		for(j=0, min = INF; j<n*m; j++) {
			if(min>pytdoigr[j] && flag[j]==0) {
				min = pytdoigr[j];
				l=j;
			}
		}
		flag[l] = 1;
		p=a[l].next;
		while(p) {
			if(flag[p->vryh]==0 && pytdoigr[p->vryh] > pytdoigr[l] + a[l].vreme) {
				pytdoigr[p->vryh] = pytdoigr[l] + a[l].vreme;
			}
			p=p->next;
		}
	}

	for(i=0; i<k; i++) {
		scanf("%d%d", &x1, &y1);
		x1--;
		y1--;
		opizv[i] = y1*m+x1;
		pytdoizv[y1*m+x1] = 0;
	}

	for(i=0; i<n*m; i++) {
		if(flag[i]!=-1) {
			flag[i]=0;
		}
	}

	for(i=0; i<n*m; i++) {
		for(j=0, min = INF; j<n*m; j++) {
			if(min>pytdoizv[j] && flag[j]==0) {
				min = pytdoizv[j];
				l=j;
			}
		}
		flag[l] = 1;
		p=a[l].next;
		while(p) {
			if(flag[p->vryh]==0 && pytdoizv[p->vryh] > pytdoizv[l] + a[l].vreme) {
				pytdoizv[p->vryh] = pytdoizv[l] + a[l].vreme;
			}
			p=p->next;
		}
	}
	for(i=0, min = INF; i<n*m; i++) {
		if(pytdoizv[i] - pytdoigr[i] <=0) {
			if(min > pytdoigr[i]) {
				min = pytdoigr[i];
			}
		}
	}
	if(min != INF) {
		printf("%d", min);
	}
	else
		printf("-1");
}