#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <time.h>
#define MAX (1 << 16)
#define MAX_NUM ((1 << 20) + 1)

typedef struct  {
  int a, r;
} kle;

kle a[MAX];
int an;
int o[MAX];
int p[MAX];
int ps[MAX_NUM];

int cmp (const void *p1, const void *p2)  {
  return (*(kle*)p1).r - (*(kle*)p2).r;
}

void pset (int num)  {
  int r, t;

  r = 0;
  t = num;

  while (t > 0)  {
    ++r;
    t -= a[p[t]].r;
  }

  t = num;
  printf ("%d", r);

  while (t > 0)  {
    printf (" %d", a[p[t]].a);
    t -= a[p[t]].r;
  }

  printf ("\n");
}

void init ()  {
  int i;

//freopen ("div.in" , "r", stdin );
//freopen ("div.out", "w", stdout);

  scanf ("%d", &an);

  for (i = 1; i <= an; ++i)  {
    scanf ("%d", &a[i].a);
    a[i].r = a[i].a % an;
    if (a[i].r == 0)  {
      printf ("1 %d\n", a[i].a);
      exit (0);
    }
  }
    
  qsort (a + 1, an, sizeof(kle), cmp);

  for (i = 1; i <= MAX_NUM; ++i)
    ps[i] = i;
}

void think ()  {
  int i, j, min, max;

  min = max = 0;
  
  o[0] = 1;
  ps[0] = 1;

  for (i = 1; i <= an; ++i)  {
    for (j = max; j >= min; j -= ps[j])  {
      if (o[j])  {
        o[a[i].r + j] = 1;
        if (ps[a[i].r + j] > a[i].r)
          ps[a[i].r + j] = a[i].r;
        if (p[a[i].r + j] == 0)
          p[a[i].r + j] = i;
        if (max < a[i].r + j)
          max = a[i].r + j;
        if (a[i].r + j == an)  {
          pset (an);
          exit (0);
        }
      }
    }
  }
}

void print()  {
  printf ("-1\n");
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

