#include <stdio.h>
#include <stdlib.h>

#define MAXN 100000

int n,m;
int a[MAXN], b[MAXN];
long long sum;

int cmp (const void *c, const void *d) {
	return *((int *)c)-*((int *)d);
}

int can_make (long long x, int k) {
	int i = k;

	while (i >= 0 && b[i] > x) i--;
	while (i >= 0) {
		if (x == b[i]) return 1;
		if (can_make(x-b[i],i-1)) return 1;
		i--;
	}

	return 0;
}

int can_make2 (long long x, int k) {
	int i = k;

	while (i >= 0 && a[i] > x) i--;
	while (i >= 0) {
		if (x == a[i]) return 1;
		if (can_make2(x-a[i],i-1)) return 1;
		i--;
	}

	return 0;
}


int main () {
	int i; long long s,p;
	// input
//	freopen("nubia.in","r",stdin);
	scanf("%d",&n);
	for (i = 0; i < n; i++) {
		scanf("%d",&a[i]);
		sum += a[i];
	}
	scanf("%d",&m);
	for (i = 0; i < m; i++) scanf("%d",&b[i]);

	// solution
	qsort(a,n,sizeof(int),cmp);
	qsort(b,m,sizeof(int),cmp);

	for (s = sum-1, p = sum; s > 0; s--) {
		if (can_make2(s,n-1)) p = s;
		else if (!can_make(p-s,m-1)) break;
//		printf("%d %d",s,sum-s);
	}

	// output
	printf("%ld",s);
}