#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

struct Type{
	int mod;
	int real;
};

const int N = 40000;

int i, j, n;
Type a[N];
int res[N];

void Input(){
	//freopen("div.in", "rt", stdin);
	scanf("%d", &n);
	int tmp;
	for(i=1; i<=n; i++){
		scanf("%d", &tmp);
		a[i].real = tmp;
		a[i].mod = tmp % n;	
	}
	return ;
}

bool HowToSort(Type t1, Type t2){
	return t1.mod < t2.mod;
}


void Output(){
	i = n;
	vector<int> result;
	while(i != 0){
		result.push_back(a[res[i]].real);
		i -= a[res[i]].mod;		
		i = (i+n)%n;
	}
	printf("%d", result.size());
	for(i=0; i<result.size(); i++)
		printf(" %d", result[i]);
	printf("\n");
	return ;
}


inline bool F(int arg, int step){
	
	arg = (arg + n)%n;
	//printf("*** %d - step %d\n", arg, step);
	if( res[arg] >= step )
		return true;

	for(int i=step; i<=n; i++)
		if( F(arg - a[i].mod, i+1) ){
			res[arg] = i;
			return true;
		}
	
	return false;
}



void Solve(){
	
	sort(a, a+n+1, HowToSort);
	
	for(i=1; i<=n; i++)
		res[a[i].mod] = i;

	a[n+1] = a[n];
	res[0] = 1;

	if(a[1].mod == 0){
		printf("1 %d\n", a[0].real);
		return ;
	}

	for(j=1; j<=n; j++)
		if( F(n-a[j].mod, j+1) ){
			res[n] = j;
			Output();
			return ;
		}

	printf("-1\n");
/*
	for(i=1; i<=n; i++){
		for(j=n-a[i].mod; j>=0; j--)
			if(res[j])
				res[j+a[i].mod] = i;
		}

	for(i=1; i<=n; i++)
		printf("prev(%d) = %d\n", i, res[i]);
*/
}


int main(){
	Input();
	Solve();
	return 0;
}
