#include <stdio.h>

#define MAX             110
#define MAXK            60
#define FREE            0
#define GOOD            1
#define BAD             2

typedef struct s
{
  int x,y;
  int status;
} tlist;

//FILE *f;

int n,m,k;
int matr[MAX][MAX];
int extr[MAXK][2];
int pos[MAXK][2];
int leave[MAX][MAX];             // moment za napuskane
int nasl[MAX][MAX][6][2];
int map[MAX][MAX];               // statusa na poleto
int tmpmap[MAX][MAX];
int tmpleave[MAX][MAX];
tlist list[MAX*MAX];             // spisak na novite elementi
int brel;
int px,py;
int pleave;
int brpos;
int answer;

void input()
{
  int i,i2;
  char c;

  scanf("%d %d %d",&n,&m,&k);


  for(i=0;i<n;i++)
  {
    do
    {
      scanf("%c",&c);
  
    }while(c!='X' && (c<'1' || c>'9'));

  
    if(c=='X')
      c = '0';
      
    matr[i][0] = c - '0';
  
    for(i2=1;i2<m;i2++)
    {
      scanf("%c",&c);
      if(c=='X')
        c = '0';

      matr[i][i2] = c - '0';
    }    
  }


  scanf("%d %d",&px,&py);
  px--;
  py--;

  for(i=0;i<k;i++)
  {
    scanf("%d %d",&extr[i][0],&extr[i][1]);
	extr[i][0]--;
	extr[i][1]--;
  }

}

void solve()
{

  int i,i2,i3,i4;
  int nx,ny;
  int st;
  int check;

  for(i=0;i<n;i++)
  {
    for(i2=0;i2<m;i2++)
    {
      if((i%2)==1)      // ako e chetno i
      {
        nasl[i][i2][0][0] = i-2;
        nasl[i][i2][0][1] = i2;
        
        nasl[i][i2][1][0] = i+2;
        nasl[i][i2][1][1] = i2;
        
        nasl[i][i2][2][0] = i-1;
        nasl[i][i2][2][1] = i2;
        
        nasl[i][i2][3][0] = i+1;
        nasl[i][i2][3][1] = i2;
        
        nasl[i][i2][4][0] = i-1;
        nasl[i][i2][4][1] = i2+1;
        
        nasl[i][i2][5][0] = i+1;
        nasl[i][i2][5][1] = i2+1;

      }
      else
      {
        nasl[i][i2][0][0] = i-2;
        nasl[i][i2][0][1] = i2;
        
        nasl[i][i2][1][0] = i+2;
        nasl[i][i2][1][1] = i2;
        
        nasl[i][i2][2][0] = i-1;
        nasl[i][i2][2][1] = i2-1;
        
        nasl[i][i2][3][0] = i+1;
        nasl[i][i2][3][1] = i2-1;
        
        nasl[i][i2][4][0] = i-1;
        nasl[i][i2][4][1] = i2;
        
        nasl[i][i2][5][0] = i+1;
        nasl[i][i2][5][1] = i2;

      }
      
    }
  
  }

/////////////////////////////////////////////


  for(i=0;i<n;i++)
    for(i2=0;i2<m;i2++)
    {
      map[i][i2] = FREE;
      leave[i][i2] = -1;
    }

  map[px][py] = GOOD;
  leave[px][py] = matr[px][py];
  brpos = 1;
//  list[0].x = px;
//  list[0].y = py;
//  list[0].status = GOOD;

//  brel = 1;

  for(i=0;i<k;i++)
  {
    map[extr[i][0]][extr[i][1]] = BAD;
    leave[extr[i][0]][extr[i][1]] = matr[extr[i][0]][extr[i][1]];
//    list[brel].x = extr[i][0];
//    list[brel].y = extr[i][1];
//    list[brel].status = BAD;
//    brel++;
  }

  for(i=1;;i++)
  {

     check = 0;

	for(i2=0;i2<n;i2++)
		for(i3=0;i3<m;i3++)
		{
			tmpmap[i2][i3] = map[i2][i3];
			tmpleave[i2][i3] = leave[i2][i3];
		}

    for(i2=0;i2<n;i2++)
      for(i3=0;i3<m;i3++)
      {
		if(map[i2][i3]==GOOD)
			check = 1;

        if(leave[i2][i3]==i)    // ako sega mozhem da napusnem
        {
          st = map[i2][i3];
          
          for(i4=0;i4<6;i4++)
          {
            nx = nasl[i2][i3][i4][0];
            ny = nasl[i2][i3][i4][1];

			if(nx<0 || nx>=n || ny<0 || ny>=m)
				continue;

            if(matr[nx][ny]!=0)
            {
              if(st==GOOD)
			  {
				check = 1;
				if(tmpmap[nx][ny]==FREE)
				{
					tmpmap[nx][ny] = GOOD;
					tmpleave[nx][ny] = i+matr[nx][ny];
//					brpos++;
				}
			  }
			  else
			  {
				if(tmpmap[nx][ny]!=BAD)
				{
//					if(map[nx][ny]==GOOD)
//						brpos--;

					tmpmap[nx][ny] = BAD;
					tmpleave[nx][ny] = i+matr[nx][ny];
				}
			  }
            }
            
          }
        }
      }

	for(i2=0;i2<n;i2++)
		for(i3=0;i3<m;i3++)
		{
			map[i2][i3] = tmpmap[i2][i3];
			leave[i2][i3] = tmpleave[i2][i3];
		}


	if(!check)
	{
	  answer = i-1;
	  break;
	}

  }

  printf("%d\n",answer);

}

int main()
{

//  f = fopen("chase.in","r");

  input();
  solve();

//  fclose(f);

  return 0;
}



