//#define DEBUG

#include <stdio.h>

#define	IN	"CHASE.IN"

#define MAX	110

long	n,m,k;
char	t[MAX][MAX];

struct REACH
{
	long v[10][MAX][MAX];
}robot,reach;

long	res;

long can_single(long x,long y,REACH &mas,long time)
{
	if(t[x][y]=='X')
		return 0;
	if(x<=0||y<=0||x>n||y>m)
		return 0;
	if(t[x][y]>time)
		return 0;

	return mas.v[(time-t[x][y])%10][x][y];
}

long can(long x,long y,REACH &mas,long time)
{
	if(can_single(x-2,y,mas,time)||can_single(x+2,y,mas,time))
		return 1;

	if(x%2)
	{
		return	can_single(x-1,y-1,mas,time)||
				can_single(x-1,y,mas,time)||
				can_single(x+1,y-1,mas,time)||
				can_single(x+1,y,mas,time);
	}
	else
	{
		return	can_single(x-1,y,mas,time)||
				can_single(x-1,y+1,mas,time)||
				can_single(x+1,y,mas,time)||
				can_single(x+1,y+1,mas,time);
	}
}

void solve()
{
	long	broi,i,j;

	broi=1;
	for(res=1;broi;res++)
	{
		broi=0;

		for(i=1;i<=n;i++)
			for(j=1;j<=m;j++)
			{
				robot.v[res%10][i][j]=0;
				if(t[i][j]!='X')
				{
					if(can(i,j,robot,res)||robot.v[(res-1)%10][i][j])
						robot.v[res%10][i][j]=1;
				}
			}

		for(i=1;i<=n;i++)
			for(j=1;j<=m;j++)
			{
				reach.v[res%10][i][j]=0;
				if(t[i][j]!='X')
				{
					if(can(i,j,reach,res)||reach.v[(res-1)%10][i][j])
						if(!robot.v[res%10][i][j])
						{
							reach.v[res%10][i][j]=1;
							broi++;
						}
				}
			}
	}
	res--;
}

void in()
{
#ifdef DEBUG
	freopen(IN,"r",stdin);
#endif

	long	i,j,x,y;

	scanf("%ld%ld%ld",&n,&m,&k);

	for(i=1;i<=n;i++)
	{
		getc(stdin);
		for(j=1;j<=m;j++)
		{
			scanf("%c",&t[i][j]);
			if(t[i][j]!='X')
				t[i][j]-='0';
		}
	}

	scanf("%ld%ld",&x,&y);
	reach.v[0][x][y]=1;

	for(i=0;i<k;i++)
	{
		scanf("%ld%ld",&x,&y);
		robot.v[0][x][y]=1;
	}

#ifdef DEBUG
	fclose(stdin);
#endif
}

void out()
{
	printf("%ld\n",res);
}

void main()
{
	in();
	solve();
	out();
}
