#include <stdio.h>
#include <string.h>

#define INF 1e9

#define MAXAL 64
#define MAX 102

#define NASL 6


#define UNDEF 0
#define DEF 1

typedef struct {
        int x,y;
} Alien;

Alien t[MAXAL];
int best[MAX][MAX];
int n,m,k;
char r[MAX][MAX];
int x,y;
char used[MAX][MAX];
int path[MAX][MAX];
int mem[MAX][MAX][9*MAX];
int maxt = 0;

Alien getnasl(int x,int y,int who) {
Alien res;
      if (x%2) {
         if (who==0) { res.x = x-1;res.y = y; }
         if (who==1) { res.x = x-2;res.y = y; }
         if (who==2) { res.x = x-1;res.y = y-1; }
         if (who==3) { res.x = x+2;res.y = y; }
         if (who==4) { res.x = x+1;res.y = y-1; }
         if (who==5) { res.x = x+1;res.y = y; }                  
      } else {
         if (who==0) { res.x = x-2;res.y = y; }
         if (who==1) { res.x = x-1;res.y = y; }
         if (who==2) { res.x = x-1;res.y = y+1; }
         if (who==3) { res.x = x+2;res.y = y; }
         if (who==4) { res.x = x+1;res.y = y; }
         if (who==5) { res.x = x+1;res.y = y+1; }
      
      }
      return res;
}

int toint(int x,int y) {
    return n*x+m*y;
}

void init() {
int i,j;
char ch;
//     FILE *f = fopen ( INP , "r");
     scanf("%d%d%d\n",&n,&m,&k);
     for (i=1;i<=n;i++) {
         for(j=1;j<=m;j++) {
                          scanf("%c",&r[i][j]);
         }
         scanf("%c",&ch);
     }
     scanf("%d%d",&x,&y);
     for (i=1;i<=k;i++)
         scanf("%d%d",&t[i].x,&t[i].y);
//     fclose(f);
}

int correct(Alien al) {
int ta = al.x;
int tb = al.y;
    return (ta>=1 && tb>=1 && ta<=n && tb<=m && r[ta][tb]!='X');
}

void dijkstra(int a,int b) {
int i,j,min;
int mi,mj;
int ax,ay,pt;
Alien res;
  memset(used,0,sizeof(used));
  for (i=1;i<=n;i++)
      for (j=1;j<=m;j++) {
          path[i][j] = INF;
      }
  path[a][b] = 0;
  while (1) {
     min = INF;
     for (i=1;i<=n;i++)
         for (j=1;j<=m;j++) {
             res.x = i;
             res.y = j;
             if (correct(res) && (!used[i][j]) && path[i][j]<min) {
                mi = i;
                mj = j;
                min = path[i][j];
             }
         }
     if (min==INF) break;
     used[mi][mj] = 1;
     for (j=0;j<NASL;j++) {
         res = getnasl(mi,mj,j);
         if (!correct(res))
            continue;
         ax = res.x;
         ay = res.y;
         pt = path[mi][mj]+r[mi][mj]-'0';
         if (path[ax][ay]>pt) {
            path[ax][ay] = pt;
         }
     }
  }
}

int rec(int p,int q,int t) {
Alien res;
int i;
    res.x = p;
    res.y = q;
    if (!correct(res)) return;
    if (best[p][q]<=t) return;
    if (mem[p][q][t]!=UNDEF) return;
    mem[p][q][t] = DEF;
    if (t>=maxt) {
       maxt=t;
    }
    for (i=0;i<NASL;i++) {
       res =getnasl(p,q,i);
       rec(res.x,res.y,t+r[p][q]-'0');
    }
    
}

void solve() {
int i;
Alien res;
int last;
int j,l;
  for (i=1;i<=n;i++)
      for (j=1;j<=m;j++) {
          best[i][j] = INF;
      }

     for (i=1;i<=k;i++) {
         dijkstra(t[i].x,t[i].y);
         for (j=1;j<=n;j++)
             for (l=1;l<=n;l++)
                 if (best[j][l]>path[j][l])
                    best[j][l] = path[j][l];
     }
     memset(mem,UNDEF,sizeof(mem));
     rec(x,y,0);
     printf("%d\n",maxt+1);
     
}

int main () {
    init();
    solve();
    return 0;
}
