#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define INP "a.in"
#define RSCR 10
#define MIXES 50
#define MAX 34000

int n;
int can[MAX],nach[MAX],t[MAX];
int list[MAX],sz=0;
int top[MAX];

void print(int value) {
int nc;
int tc=1;
int cur;
int i;
int next = n;
     if (value==-1) {
        printf("-1\n");
        exit(0);
     }
     top[0] = t[value];
     next-=t[value];
     while (next>0) {
           top[tc++] = t[nach[next]];
           next-=t[nach[next]];
     }
     printf("%d",tc);
     for (i=0;i<tc;i++)
         printf(" %d",top[i]);
     printf("\n");
     exit(0);
}

void solve() {
int i,j,sum;
int nsz;
    memset(can,0,sizeof(can));
    memset(nach,0,sizeof(nach));
     sz = 1;
     list[1] = 0;
     nach[1] = 0;
     for (i=1;i<=n;i++) {
         nsz = sz;
         for (j=1;j<=sz;j++) {
             sum = (list[j]+t[i])%n;
             if (!can[sum]) {
                can[sum] = 1;
                nach[sum] = i;
                nsz++;
                list[nsz] = sum;
             }
             if (sum==0) print(i);
         }
         sz = nsz;
     }
}


int scramble() {
int i;
    for (i=1;i<=MIXES;i++) {
    int p = rand()%n+1;
    int q = rand()%n+1;
    int tmp = t[p];
        t[p] = t[q];
        t[q] = tmp;
    }
}

void stupid_solve() {
int i,j;
int sum;
    memset(can,0,sizeof(can));
    memset(nach,0,sizeof(nach));
    sum = 0;
    nach[0] = 0;
    can[0] = 1;
    for (i=1;i<=n;i++) {
        sum+=t[i];
        sum%=n;
        if (can[sum]) {
           printf("%d",i-nach[sum]);
           for (j=nach[sum]+1;j<=i;j++)
               printf(" %d",t[j]);
           printf("\n");
           exit(0);
        }
        can[sum] = 1;
        nach[sum] = i;
    }
}

int cmp(const void *a,const void *b) {
    return *((int *)a)-*((int *)b);
}

int main () {
int i,q;
//    FILE *f = fopen ( INP , "r");
    scanf("%d",&n);
    for(i=1;i<=n;i++) {
                     scanf("%d",&q);
                     t[i] = q;
    }
    stupid_solve();
    qsort(t+1,n,sizeof(int),cmp);
    stupid_solve();
    solve();
    return 0;
}
