#include <stdio.h>

#define MAXN ((1 << 15) + 1)
#define MAXNUM ((1 << 15) + 1)

int n, m = 0;
int num[MAXNUM];
int realnum[MAXNUM];
int dyn[2][MAXNUM] = { 1 };
int used[MAXNUM] = { 0 };
int cur, prev;

int main(void)
{
	int i, j;
	FILE *fin = stdin;
	FILE *fout = stdout;
	fscanf(fin, "%d", &n);
	for (i = 1; i <= n; i++)
	{
		fscanf(fin, "%d", realnum + i);
		num[i] = realnum[i] % n;
		if (!num[i])
			num[i] = n;
	}
	for (i = 1, prev = 0, cur = 1; i <= n; i++, cur = (cur + 1) % 2, prev = (prev + 1) % 2) // 4isla
		for (j = 1; j <= n; j++) // ostatyci
		{
			dyn[cur][j] = dyn[prev][j];
			if (!dyn[cur][j] && dyn[prev][j - num[i] + (j - num[i] < 0) * n])
				dyn[cur][j] = i;
			if (dyn[cur][n])
			{
				prev = cur;
				goto out_of_cycle;
			}
		}
	
	out_of_cycle : cur = prev;
	
	for (i = n; i; i = i - num[dyn[cur][i]] + (i - num[dyn[cur][i]] < 0) * n)
	{
		used[dyn[cur][i]] = 1;
		m++;
	}
	if (m)
	{
		fprintf(fout, "%d", m);
		for (i = 1; i <= n; i++)
			if (used[i])
				fprintf(fout, " %d", realnum[i]);
	}
	else
		fprintf(fout, "-1");
	fclose(fin);
	fclose(fout);
	return 0;
}
