const
   maxn = 10000;
   maxm = 100000;

   infile = '';
   outfile = '';

type
   pnode = ^tnode;
   tnode = record
      next : pnode;
      ind  : longint;
      from : word;
      go, arr : longint;
   end;

var
   f : text;

   fl : boolean;

   cur, a, b, c, d, x, i, j, m, n : longint;

   y : tnode;
   tmp : pnode;

   dest : array[1..maxm] of tnode;
   traf : array[1..maxn] of pnode;

procedure sort(l,r: longint);
var
   i,j,x: longint;
begin
   i:=l;
   j:=r;
   x:=dest[(l+r) div 2].go;
   repeat
     while dest[i].go<x do inc(i);
     while x<dest[j].go do dec(j);
     if not(i>j) then
       begin
          y:=dest[i];
          dest[i]:=dest[j];
          dest[j]:=y;
          inc(i); dec(j);
       end;
   until i>j;
   if l<j then sort(l,j);
   if i<r then sort(i,r);
end;


procedure recur(vr : word; time : longint);
var p : pnode;
begin
   inc(cur);
   if vr=1 then begin fl:=true; writeln(dest[i].go); writeln(cur); end
   else
      begin
         p:=traf[vr];
         while (p<>nil) do
            begin
               with p^ do
                  begin
                     if go<=time then recur(from, arr);
                     if fl then begin writeln(ind); break; end;
                  end;
               p:=p^.next;
            end;
      end;
   dec(cur);
end;

begin
   assign(f, infile);
   reset(f);
   readln(f, n, m);
   for i:=1 to m do
      begin
         readln(f, a, b, c, d);
         if b=n then
            begin
               inc(x);
               dest[x].ind:=i;
               dest[x].from:=a;
               dest[x].arr:=c;
               dest[x].go:=dest[x].arr+d;
            end
         else
            begin
               new(tmp);
               tmp^.ind:=i;
               tmp^.from:=a;
               tmp^.arr:=c;
               tmp^.go:=tmp^.arr+d;
               tmp^.next:=traf[b];
               traf[b]:=tmp;
            end;
      end;
   close(f);

   sort(1, x);

   i:=0;
   repeat
      inc(i);
      recur(dest[i].from, dest[i].arr);
      if fl then writeln(dest[i].ind);
   until fl = true;
end.
