
 program number;

const
	MAXN					= 100000; { 100000 }
	INF					= 2000000000;{ 20000000 }
	inFile					= '';

type
	Integer					= LongInt;
	TData					= record
		i, v				: Integer;
	end;

var
	d					: Array [1 .. MAXN] of TData;
	ch					: Array [1 .. MAXN] of Integer;
	cCh					: Array [1 .. MAXN] of Integer;
	N					: Integer;
	i, j					: Integer;
	f					: Text;
	sum					: Int64;

procedure readInput;
begin
	assign(f, inFile);
	reset(f);
	readln(f, N);
	for i := 1 to N do begin
		read(f, d[i].v);
		d[i].i := i;
	end;
	close(f);
end;


procedure sort(l,r: integer);
var
  	i, j, x					: Integer;
	y					: TData;
begin
  	i := l; 
	j := r; 
	x := d[(l + r ) div 2].v;
  	repeat
    		while (d[i].v < x) do 
			i := i + 1;
    		while (x < d[j].v) do 
			j := j - 1;
    		if (i <= j) then begin
			y := d[i]; 
			d[i] := d[j]; 
			d[j]:=y;
      			i := i + 1; 
			j := j - 1;
    		end;
  	until (i > j);
  	if (l < j) then 
		sort(l, j);
  	if (i < r) then 
		sort(i, r);
end;

procedure Solve;
var
	cSum					: Integer;
	cWhere					: Integer;
begin
	sort(1, N);
	Sum := INF;
	for i := 1 to N do begin
		for j := 1 to N do
			cCh[j] := 0;
		cSum := 0;
		cWhere := d[i].v - 1;
		for j := (i - 1) downto 1 do begin
			cSum := cSum + abs(cWhere - d[j].v);
			cCh[d[j].i] := cWhere - d[j].v;
                        cWhere := cWhere - 1;
		end;
		cWhere := d[i].v + 1;
		for j := (i + 1) to N do begin
			cSum := cSum + abs(d[j].v - cWhere);
			cCh[d[j].i] := cWhere - d[j].v;
                        cWhere := cWhere + 1;
		end;
		if (cSum < Sum) then begin
			Sum := cSum;
			for j := 1 to N do
				ch[j] := cch[j];
		end;
	end;
end;

procedure writeOutput;
begin
	writeln(Sum);
	for i := 1 to (N - 1) do
		write(ch[i], ' ');
	writeln(ch[N]);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.