program fbi;

const
	MAXM					= 20;
	MAXN					= 10000;
	inFile					= '';

type
	Integer					= LongInt;

var
	d					: Array [1 .. MAXN] of Integer;
	results					: Array [1 .. MAXM] of Integer;
	passed					: Array [1 .. MAXN] of Boolean;
	N, M					: Integer;
	f					: Text;
	i, j					: Integer;

procedure readInput;
begin
	assign(f, inFile);
	reset(f);
	readln(f, M, N);
end;

procedure Solve;
var
	curr					: Integer;
	dist					: Integer;
	c 					: Integer;
	count					: Integer;
begin
	for curr := 1 to M do begin
		for i := 1 to (N - 1) do begin
			read(f, d[i]);
			passed[i] := False;
		end;
		readln(f, d[N]);
		passed[N] := False;
		count := 0;
		for i := 1 to (N - 1) do begin
			passed[d[i]] := True;
			dist := N - i;
			c := 0;
			for j := (d[i] + 1) to N do 
				if (not passed[j]) then
					c := c + 1;
			dist := dist - c;
			count := count + dist;
		end;
		results[curr] := count;
	end;
	close(f);
end;

procedure writeOutput;
begin
	for i := 1 to M do
		writeln(results[i]);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.