#include <stdio.h>
#include <stdlib.h>

#define MAX 100001

typedef struct number {
	int id;
	int num;
	int off;
} number;

number ar[MAX];
int solution[MAX];
int total=0;

int n;

void input();
void output();
void solve();

int cmp_num(const void *a, const void *b)
{
	return ( ((number *)a)->num - ((number *)b)->num );
}

int cmp_off(const void *a, const void *b)
{
	return ( ((number *)a)->off - ((number *)b)->off );
}

void input()
{
	int i;

	scanf("%d", &n);
	for (i=0;i<n;i++)
	{
		scanf("%d", &ar[i].num);
		ar[i].id = i;
	}
}

void solve()
{
	int i,c;

	qsort(&ar[0], n, sizeof(number), cmp_num);

	for (i=0;i<n;i++)
	{
		ar[i].off = i - ar[i].num;
	}

	qsort(&ar[0], n, sizeof(number), cmp_off);

	if (n%2 == 0) c = ar[n/2-1].off;
	else		  c = ar[n/2].off;

	for (i=0;i<n;i++)
	{
		ar[i].off -= c;
		solution[ar[i].id] = ar[i].off;
		total += abs(ar[i].off);
	}
}

void output()
{
	int i;

	printf("%d\n", total);
	for (i=0;i<n;i++)
	{
		printf("%d ", solution[i]);
	}
}

int main()
{
	input();
	solve();
	output();

	return 0;
}
