#include <stdio.h>

#define MAX_M 100001
#define MAX_N 10001

typedef struct bus {
	int src;
	int dst;
	int when;
	int arrive;
	int len;
} bus;

int c[MAX_N];
bus b[MAX_M];
int solution[MAX_M];
int m,n;

int main()
{
	int i,count,src,dst;

	scanf("%d %d", &n, &m);
	for (i=2;i<=n;i++)
	{
		c[i] = -1;
	}
	c[1]=0;

	b[0].dst  = 0;
	b[0].src  = 0;
	b[0].when = 0;
	b[0].len  = 0;

	for (i=1;i<=m;i++)
	{
		scanf("%d %d %d %d", &b[i].src, &b[i].dst, &b[i].when, &b[i].len);
		b[i].arrive = b[i].len + b[i].when;

		src = b[i].src;
		dst = b[i].dst;

		if ( (c[src]>=0 && (b[c[src]].arrive <= b[i].when)) && ( c[dst]<0 || b[c[dst]].arrive > b[i].arrive ) )
		{
			c[dst] = i;
		}
	}

	i = n;
	count = 0;

	while (i>0)
	{
		solution[count++] = c[i];
		i = b[c[i]].src;
	}

	count--;

	printf("%d\n", b[c[n]].arrive);
	printf("%d\n", count);
	for (i=count-1;i>=0;i--)
	{
		printf("%d\n", solution[i]);
	}

	return 0;
}
