/*
TASK:perm
LANG:C++
*/


// Author: Ivan Dimitrov Georgiev

#include <iostream>
using namespace std;

unsigned perm[10001], invperm[10001];
unsigned invansleft[10001], ansleft[10001], ansright[10001];
bool vis[10001], success;
unsigned n;
void compute(unsigned n)
 { unsigned s, x, permn, perms, help;
   if (n == 2)
    { if (perm[1] == 1 && perm[2] == 2)
       { invansleft[1] = 2; invansleft[2] = 1;
         ansright[1] = 2; ansright[2] = 1;
         return;
       }
      //perm[1] == 2 && perm[2] == 1
      //the permutation is odd
      success = false;
      return;
    }
   if (perm[1] != n) s = 1; else s = 2;
   x = perm[s];
   permn = perm[n]; perms = perm[s];
   //perm = (x n) o perm o (s n)
   perm[invperm[n]] = x;
   perm[invperm[x]] = n;
   help = perm[s];
   perm[s] = perm[n];
   perm[n] = help;
   //invperm = (s n) o invperm o (x n)
   invperm[permn] = s;
   invperm[perms] = n;
   help = invperm[x];
   invperm[x] = invperm[n];
   invperm[n] = help;
   compute(n-1);
   if (!success) return;
   //invansleft = invansleft o (x n)
   help = invansleft[x];
   invansleft[x] = invansleft[n];
   invansleft[n] = help;
   //ansright = ansright o (s n)
   help = ansright[s];
   ansright[s] = ansright[n];
   ansright[n] = help;
 }
void solvenoutput()
{ unsigned i, x;
  for (i = 1, x = 1; i <= n; i++)
   { if (!vis[x]) { vis[x] = true; x = perm[x]; }
     else break;
   }
  if (i == n+1) //cycle with length n
   { cout << 1 << endl;
     x = 1;
     cout << 1;
     x = perm[x];
     while (x != 1)
       { cout << ' ' << x;
         x = perm[x];
       }
     cout << endl;
     return;
   }
  compute(n);
  if (!success) cout << 0 << endl;
  else {
   for (i = 1; i <= n; i++)
    ansleft[invansleft[i]] = i;
   cout << 2 << endl;
   //print left cycle
   x = 1;
   cout << 1;
   x = ansleft[x];
   while (x != 1)
       { cout << ' ' << x;
         x = ansleft[x];
       }
     cout << endl;
   //print right cycle
   x = 1;
   cout << 1;
   x = ansright[x];
   while (x != 1)
       { cout << ' ' << x;
         x = ansright[x];
       }
     cout << endl;
  }
}
void initialize()
 { unsigned i;
   cin >> n;
   for (i = 1; i <= n; i++)
     { cin >> perm[i];
       invperm[perm[i]] = i;
       vis[i] = false;
       invansleft[i] = ansright[i] = i;
     }
   success = true;
 }
int main()
 { initialize();
   solvenoutput();
   int c;
   cin >> c;
   return 0;
 }

