/*
TASK:distance
LANG:C++
*/

#include <iostream>

#define dist2(i,j) (cor[i][0]-cor[j][0])*(cor[i][0]-cor[j][0]) + (cor[i][1]-cor[j][1])*(cor[i][1]-cor[j][1])

using namespace std;

int n,res=0,cur=0,cnt=0,mx=0;
int cor[24][2],dist[24][24];
long long m;
double d;
bool used[24];

void unite(int i)
{
	for(int j=i+1;j<n;j++)
		if(!used[j])
		{
			cur+=dist[i][j];
			used[j]^=1;
			cnt+=2;
//			printf("%d %d %d %d\n",i,cur,cnt,j);
			int k;
//			m=(long long)cur+((long long)(n-cnt)*mx)/2;
			d=(double)cur+(double)((double)(n-cnt)*(double)mx)/2;
//			cout<<m<<"\n";
			if(d>res)// || cur+((n-cnt)*mx)/2<0)
			{
				for(k=i+1;k<n;k++)
					if(!used[k])
					{
						used[k]=1;
						unite(k);
						used[k]=0;
						break;
					}
				if(k==n)
					if(cur>res)
						res=cur;
			}
			cnt-=2;
			used[j]&=0;
			cur-=dist[i][j];
		}
}

int main()
{
	scanf("%d\n",&n);
	for(int i=0;i<n;i++)
		scanf("%d %d",&cor[i][0],&cor[i][1]);
	for(int i=0;i<n;i++)
		for(int j=i+1;j<n;j++)
		{
			dist[i][j]/*=dist[j][i]*/=dist2(i,j);
			if(dist[i][j]>mx)
				mx=dist[i][j];
		}
/*	for(int i=0;i<n;i++)
	{
		for(int j=0;j<n;j++)
			printf("%d ",dist[i][j]);
		printf("\n");
	} */
//	printf("%d\n",mx);
	used[0]=1;
	unite(0);
	printf("%.3f\n",(float)res);
//	printf("%f\n",clock()/(double)CLOCKS_PER_SEC);
    return 0;
}
