/*
TASK: bignum
LANG: C++
*/
/*
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <map>
#include <algorithm>

using namespace std;

int n, k;

bool ok(string w) {
    map<string, bool> M;
    if( w.length() < k ) return true;
    for(int i = 0; i < w.length()-k+1; ++i) {
        string c = w.substr(i, k);
        if( M[c] ) return false;
        M[c] = true;
    }
    return true;
}

bool operator<(string a, string b) {
    if(a.length() < b.length()) return 1;
    if(a.length() > b.length()) return 0;
    for(int i = 0; i < a.length(); ++i)
        if( a[i] < b[i] ) return 1;
        else if( a[i] > b[i] ) return 0;
    return 1;
}

int main() {

    scanf("%d %d", &n, &k);
    queue<string> q; q.push("");
    string b = "";
    while( !q.empty() ) {
        string t = q.front(); q.pop();
        printf("%s\n", t.c_str());
        for(int i = 0; i < n; ++i) {
            string r = t;
            r += (char)i+'0';
            if( ok(r) ) { q.push(r); if( b < r ) b = r;  }
        }
    }

    printf("%s\n", b.c_str());

    return 0;
}

*/

#include <cstdio>
#include <string>

using namespace std;

int main() {

    int n, k;
    scanf("%d %d", &n, &k);
    string ans="";
    if( k == 1 ) {
        for(int i = n-1; i >= 0; --i)
            ans += (char)i+'0';
    }
    if( n == 2 ) {
        if( k == 2 ) ans = "11001";
        if( k == 3 ) ans = "1110100011";
        if( k == 4 ) ans = "1111011001010000111";
    }

    if( n == 3 ) {
        if( k == 2 ) ans = "2212011002";
//        if( k == 3 ) ans = ;
    }
    if( n == 4 ) {
        if( k == 2 ) ans = "33231302212011003";
    }

    printf("%s", ans.c_str());

    return 0;
}
