/*
TASK: distance
LANG: C++
*/

#include <cstdio>

const int MAXN      = 21;

struct point {
    float x;
    float y;
    point(float t1=0.0, float t2=0.0) : x(t1), y(t2) {}
};

int n, n2;
point A[24];
float dp[1<<MAXN];

inline float max(float a, float b) {
    return (a>b) ? a : b;
}

int main() {

    scanf("%d", &n);
    for(int i = 0; i < n; ++i)
        scanf("%f %f", &A[i].x, &A[i].y);
    n2 = (1<<n);
    
    dp[n2-1] = 0.0;
    for(int i = n2-1; i >= 0; --i)
        for(int j = 0; (1<<j) <= i; ++j)
            if( i&(1<<j) )
                for(int k = j+1; (1<<k) <= i; ++k)
                    if( (1<<k) & i ) {
                        float dist = (A[j].x-A[k].x)*(A[j].x-A[k].x) + (A[j].y-A[k].y)*(A[j].y-A[k].y);
                        int tmp = i^(1<<j);
                        tmp ^= (1<<k);
                        dp[tmp] = max(dp[i]+dist, dp[tmp]);
                    }
    printf("%.3f\n", dp[0]);

    return 0;
}
