/*
TASK: porters
LANG: C++
*/

#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

const int INF       = 5000000;

inline int max(int a, int b) {
    return (a>b) ? a : b;
}

struct ff {
    int v;
    int next;
};

vector<ff> A;

int n, k;

int main() {

    scanf("%d %d", &n, &k); A.resize(n+2); A[1].next = -1;
    for(int i = 1; i < n; ++i) {
        int k1; scanf("%d", &k1);
        A[i+1].next = k1;
    }

    for(int i = 0; i < k; ++i) {
        char* str = new char[16];
        int k1, k2, k3;
        scanf("%s %d %d %d", str, &k1, &k2, &k3);
        if( !strcmp("k4i", str) ) {
            int ans = 0;
            for(int p = k2; p != k3; p = A[p].next)
                ans = max(A[p].v, ans);
            ans = max(ans, A[k3].v );
            printf("%d\n", k1*10-ans);
        }
        else
            A[k2].v += k3;
    }

    return 0;
}
