/*
TASK: distance
LANG: C
*/
#include <stdio.h>
#define maxN 32

int n,dist[maxN][maxN],list[maxN][2];
int res,br,best;
char used[maxN];

void input()
{
     scanf("%d",&n);
     int i,j;
     for (i=1;i<=n;++i) scanf("%d%d",&list[i][0],&list[i][1]);
     for (i=1;i<=n;++i) for (j=1;j<=n;++j) dist[i][j] = (list[i][0]-list[j][0])*(list[i][0]-list[j][0]) + (list[i][1]-list[j][1])*(list[i][1]-list[j][1]);
}

void solve()
{
     if (br == n) {
        if (res > best) best = res;
        return ;
        }
     int i,j;
     for (i=1;i<=n;++i) if (!used[i])
         for (j=1;j<=n;++j) if (!used[j]) {
             res += dist[i][j];
             used[i] = used[j] = 1;
             br += 2;
             solve();
             br -= 2;
             used[i] = used[j] = 0;
             res -= dist[i][j];
             }
}

void solve2()
{
     int i,j,k,q,t;
     int sit[12];
     for (i=1;i<=n/2;++i) sit[i] = n/2+i;
     
     for (q=1;q<=100;++q) { // GLOBAL ITERATION
         
         for (i=1;i<=n/2;++i)  // GREEDY1
             for (j=i+1;j<=n/2;++j) 
                 if (dist[i][sit[j]]+dist[j][sit[i]] > dist[i][sit[i]]+dist[j][sit[j]]) {
                    t = sit[i];
                    sit[i] = sit[j];
                    sit[j] = t;
                    }
         
         for (i=1;i<=n/2;++i)  // GREEDY2
             for (j=i+1;j<=n/2;++j) 
                 if (dist[i][j]+dist[sit[i]][sit[j]] > dist[i][sit[i]]+dist[j][sit[j]]) {
                    sit[sit[i]] = sit[i]; sit[sit[j]] = sit[i];
                    sit[i] = j; sit[j] = i;
                    }
         
         for (i=1;i<=n/2;++i)  // GREEDY3
             for (j=i+1;j<=n/2;++j)
                 for (k=j+1;k<=n/2;++k) {
                     if (dist[i][sit[j]]+dist[j][sit[k]]+dist[k][sit[i]] > dist[i][sit[i]]+dist[j][sit[j]]+dist[k][sit[k]]) {
                        t = sit[i];
                        sit[i] = sit[j];
                        sit[j] = sit[k];
                        sit[k] = t;
                        }
                     if (dist[i][sit[k]]+dist[j][sit[i]]+dist[k][sit[j]] > dist[i][sit[i]]+dist[j][sit[j]]+dist[k][sit[k]]) {
                        t = sit[i];
                        sit[i] = sit[k];
                        sit[k] = sit[j];
                        sit[j] = t;
                        }
                     }
         
         t = 0;
         for (i=1;i<=n/2;++i) t += dist[i][sit[i]];
         if (t > best) best = t;
         //printf("%d\n",t);
         }
}

int main()
{
    input();
    if (n<=10) solve(); 
    else solve2();
    printf("%.3lf\n",(double)best);
    return 0;
}
