/*
TASK: bignum
LANG: C++
*/
#include <iostream>
#include <cmath>
#define MAXN 32768
using namespace std;
int mx;
int wi;
int q, k;
short nums[MAXN];
int hash(int num)
{
    int ret = 0;
    for (int i = 1; i <= mx; i++)
    {
        ret += i * (num % (int)pow(10.0, (double)i));
    }
    return ret;
}
int num(int s, int f)
{
    int ret = 0;
    int step = -1;
    for (int i = s; i <= f; i++)
    {
        step++;
        ret += (int)pow(10.0, (double)step) * nums[i];
    }
    return ret;
}
bool mth()
{
    //bool cache[200000000] = {false};
    bool cache[200000];
    for (long long i = 0; i <= 200000; i++) cache[i] = false;
    for (int i = 1; i <= mx - k - 1; i++)
    {
        //cout << i << endl;
        if (cache[hash(num(i, i + k))] == true) return false;
        else cache[hash(num(i, i + k))] = true;
    }
    return true;
}
void minus_one()
{
    if (nums[mx] > 0) nums[mx]--;
    else
    {
        int i = 0;
        for (i = mx; i >= 1; i--)
            if (nums[i] != 0)
            {
                for (int j = i + 1; j <= mx; j++) nums[j] = q - 1;
                nums[i]--;
                break;
            }
        wi--;
    }
}
int main()
{
    cin >> q >> k;
    mx = (int)pow((double)q, (double)k) + k - 1;
    wi = mx;
    for (int i = 1; i <= mx; i++) nums[i] = q - 1;
    //for (int i = 1; i <= mx; i++) cout << nums[i];
    //cout << endl;
    //while(1)
    for (int test = 1; test <= 10000; test++)
    {
        minus_one();
        //cout << "a";
        if (mth())
        {
            for (int i = 1; i <= mx; i++) cout << nums[i];
            cout << endl;
            return 0;
        }
    }
    return 0;
}
