/*
TASK: bignum
LANG: C++
*/

#include <iostream>
#include <string>
#include <set>
#include <algorithm>
using namespace std;

typedef long long type;

int k, q;
type POW;

set<type> V;
string ans;

void dfs (type curr)
{
	int c;
	type next;

	V.insert (curr);

	for (c=q-1; c>=0; c--) {
		next = (curr%POW)*10 + c;
		if ( V.count(next) == 0 )
			dfs (next);
	}

	ans += char(curr%10+'0');
}

int my_pow (int a, int b)
{
	int i, res=1;

	for (i=0; i<b; i++)
		res *= a;

	return res;
}

int main ()
{
	int i;
	type start=0;

	cin >> q >> k;

	for (POW=1, i=0; i<k; i++) {
		start = start*10 + (q-1);
		POW *= 10;
	}

	POW /= 10;
	
	dfs (start);

	ans += string(k-1,char(q-1+'0'));
	reverse(ans.begin(),ans.end());
	cout << ans << "\n";
	
	return 0;
}