/*
TASK: distance
LANG: C++
*/
#include <cstdio>
#include <algorithm>
#include <cstdlib>
using namespace std;

typedef struct {int x,y; double dist;}st;
st inp[32],srt[512];
int used[32]={0},n,cnt;
double MAX=0,tmp=0;
int indd[32]={0};

bool cmp (st,st);
void rec (int,int);

int main ()
{
    int i,j;
    
    scanf ("%d",&n);
    for (i=0;i<n;i++)
        {
            scanf ("%d %d",&inp[i].x,&inp[i].y);
            for (j=0;j<i;j++)
                {
                    srt[cnt].x=j;
                    srt[cnt].y=i;
                    srt[cnt].dist=(double)(inp[i].x-inp[j].x)*(inp[i].x-inp[j].x);
                    srt[cnt].dist+=(double)(inp[i].y-inp[j].y)*(inp[i].y-inp[j].y);
                    cnt++;
                }         
        }
    sort (srt,srt+cnt,cmp);
    
    indd[0]=0;
    indd[1]=n-1;
    for (i=2;i<n;i++)
        indd[i]+=2*indd[i-1]-indd[i-2]-1;
        
    for (i=0;i<n/2;i++)
        {
            //printf ("BOZA!!!\n");
            rec (i,1);
        }
    
    printf ("%.3lf\n",MAX);
    
    return 0;
}

bool cmp (st a,st b)
{
    if (a.x<b.x)
        return true;
    if (a.x>b.x)
        return false;
    if (a.dist>b.dist)
        return true;
    if (a.dist<b.dist)
        return false;
    if (a.y<b.y)
        return true;
    if (a.y>b.y)
        return false;
}

void rec (int i,int ind)
{
    int j,k,fl;
    used[srt[i].x]=1;
    used[srt[i].y]=1;
    tmp+=srt[i].dist;
    
    if (ind==n/2)
        {
            if (MAX<tmp)
                MAX=tmp;
            tmp-=srt[i].dist;
            used[srt[i].x]=0;
            used[srt[i].y]=0;
            return;
        }

    for (k=1;k<n;k++)
        {
            if (used[k])
                continue;
            for (j=indd[k];j<indd[k+1];j++)
                {
                    if (used[srt[j].x] || used[srt[j].y])
                        continue;
                    rec (j,ind+1);
                }
        }

    tmp-=srt[i].dist;   
    used[srt[i].x]=0;
    used[srt[i].y]=0;
    
    return;
}
