/*
TASK: distance
LANG: C++
*/

#include <stdio.h>
#include <algorithm>

using namespace std;

typedef struct {
    long x;
    long y;
} pos;

long pairs[24][24] = {0, 0};
bool used[24] = {0};
long srt[1000] = {0}, c = 0;
int n;
unsigned long sum = 0;

pos s[24];

long dist(pos, pos);

int main () {
    int i, j, k;
    long max = 0;
    long tmp;
    pos maxpos;
    scanf ("%d", &n);
    for (i = 0; i < n; i ++) {
        scanf ("%ld%ld", &s[i].x, &s[i].y);
        for (j = 0; j < i; j ++) {
            tmp = dist(s[i], s[j]);
            pairs[i][j] = pairs[j][i] = tmp;
            srt[c ++] = tmp;
        }
    }
    for (k = 0; k < n / 2; k ++) {
        max = 0;
        maxpos.x = maxpos.y = -1;
        for (i = 0; i < n; i ++) {
            if (used[i]) continue;
            for (j = 0; j < i; j ++) {
                if (used[j]) continue;
                if (pairs[i][j] > max) {
                    max = pairs[i][j];
                    maxpos.y = i;
                    maxpos.x = j;
                }
            }
        }
        sum += max;
        used[maxpos.x] = used[maxpos.y] = true;
    }
    printf ("%.3lf\n", double(sum));
    return 0;
}

long dist(pos a, pos b) {
    return ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
