
/*
TASK: perm
LANG: C++
*/

#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
\
#define DEBUG(x) cout << #x << ": " << x << endl;

int was[1 << 16];
int num[1 << 16];

int n;

void read() {
    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d", &num[i]);
}
int is_cyclic(int *num, int down = 0) {
    memset(&was, 0, sizeof(was));
    int k = 0, m = 0;
    int space = 0;
    if (down)
        printf("%d\n", 1);
    while (k < n) {
        if (down) {
            if (space) printf(" ");
            space = 1;
            printf("%d", m + 1);
        }
        if (was[m] == 1)
            break;
        was[m] = 1;
        m = num[m] - 1;
        ++k;
    }
    if (down)
        printf("\n");
    return (k == n);
}
void solve() {
    if (is_cyclic(num)) {
        is_cyclic(num, 1);
    } else {
        printf("%d\n", 0);
    }
}
int main() {
    read();
    solve();
    return 0;
}
