/*
TASK:lines
LANG:C++
*/

#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
using namespace std;

typedef long long LL;

int a,b;
LL ans;

int gcd(int a, int b)
{
 if (!a) return b;
 if (!b) return a;
 while (b>0)
 {
  int t=b;
  b=a%b;
  a=t;
 }
 return a;
}

struct state {
 int A,B,C;
 state() { }
 state(int q, int w, int e) { A=q; B=w; C=e; }
};

int main()
{
 cin>>a>>b;
 
 ans=0;
 
 vector <state> work;
 
 for (int x1=0;x1<=a;x1++)
  for (int y1=0;y1<=b;y1++)
   for (int x2=0;x2<=a;x2++)
    for (int y2=0;y2<=b;y2++)
    {
     if (x1==x2 &&  y1==y2) continue;
     int A=y1-y2,B=x2-x1,C=x1*y2-x2*y1;
     int tA=A,tB=B,tC=C;
     tA=abs(tA);
     tB=abs(tB);
     tC=abs(tC);
     int gt=gcd(tA,tB);
     int g=gcd(gt,tC);
//     if (g)
  //   {
      A/=g; 
      B/=g;
      C/=g;
    // }   
     state s(A,B,C);
     bool have=false;
     for (int i=0;i<work.size();i++)
      if (work[i].A==A && work[i].B==B && work[i].C==C ||
          work[i].A==-A && work[i].B==-B && work[i].C==-C) { have=true; break; }
     if (!have) { /*cout<<x1<<" "<<y1<<" "<<x2<<" "<<y2<<endl;*/ work.push_back(s); }
    }
 
 cout<<work.size()<<endl;
 
 /*number of different fractions of type (y2-y1)/(x2-x1)
 set < pair <int, int> > work;
 for (int i=0;i<=a;i++) 
  for (int j=0;j<=b;j++)
  {
   if (!i && !j) continue;
   int ti=i,tj=j;
   if (ti>0 && tj>0)
   {
    int g=gcd(ti,tj);
    ti/=g;
    tj/=g;
   }
   cout<<i<<" "<<j<<" "<<ti<<" "<<tj<<endl;
   work.insert(make_pair(ti,tj));
  }
 cout<<work.size()<<endl; 
 ans=(work.size()*2)+a+b+2;
 cout<<ans<<endl;*/
  
 //system("pause"); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 return 0;
}
