/*
TASK:table
LANG:C++
*/
#include <iostream>
#include <vector>
using namespace std;
int T[64][64];
int n,m;
struct perm
{
       int p[5];
       bool removed;
};
perm makePerm(int& a1,int& a2,int& a3,int& a4)
{
     perm t;
     t.p[1]=a1;     t.p[2]=a2;     t.p[3]=a3;     t.p[4]=a4;
     t.removed=false;
     return t;
}
vector<perm> P[64][64];
void fillPermutations()
{
     for(int i=0;i<=2;i++)
          for(int j=0;j<=2;j++)
               for(int k=0;k<=2;k++)
                    for(int t=0;t<=2;t++)
                    {
                            int val=(i+j+k+t)%3;
                            for(int q=1;q<=m;q++)
                                    for(int w=1;w<=n;w++)
                                        if(T[q][w]==val)
                                            {
                                                        if(w==1 && i!=0) continue;
                                                        if(w==m && k!=0) continue;
                                                        if(q==1 && t!=0) continue;
                                                        if(q==n && j!=0) continue;
                                                        P[q][w].push_back(makePerm(i,j,k,t));
                                            }
                    }
                    
}
void optimizePermutations()
{
     for(int i=1;i<=m;i++)
             for(int j=1;j<=n;j++)
             {
                     
//////////////////////////////////////////                     
                 if(j+2<=n)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j+2].size();t++)
                             {
                                     if(P[i][j][k].p[2]==P[i][j+2][t].p[4] && !P[i][j+2][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i][j+2].size();k++)
                     {
                             if(P[i][j+2][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i][j+2][k].p[4]==P[i][j][t].p[2] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i][j+2][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////                    
                     
//////////////////////////////////////////                     
                 if(j-2>0)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j-2].size();t++)
                             {
                                     if(P[i][j][k].p[4]==P[i][j-2][t].p[2] && !P[i][j-2][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i][j-2].size();k++)
                     {
                             if(P[i][j-2][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i][j-2][k].p[2]==P[i][j][t].p[4] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i][j-2][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////     

//////////////////////////////////////////                     
                 if(i-2>0)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i-2][j].size();t++)
                             {
                                     if(P[i][j][k].p[1]==P[i-2][j][t].p[3] && !P[i-2][j][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i-2][j].size();k++)
                     {
                             if(P[i-2][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i-2][j][k].p[3]==P[i][j][t].p[1] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i-2][j][k].removed=true;
                     }
                 }
                    
///////////////////////////////////////// 

//////////////////////////////////////////                     
                 if(i+2<=m)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i+2][j].size();t++)
                             {
                                     if(P[i][j][k].p[3]==P[i+2][j][t].p[1] && !P[i+2][j][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i+2][j].size();k++)
                     {
                             if(P[i+2][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i+2][j][k].p[1]==P[i][j][t].p[3] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i+2][j][k].removed=true;
                     }
                 }
                    
///////////////////////////////////////// 

//////////////////////////////////////////                     
                 if(i+1<=m && j+1<=n)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i+1][j+1].size();t++)
                             {
                                     if(P[i][j][k].p[2]==P[i+1][j+1][t].p[1] && P[i][j][k].p[3]==P[i+1][j+1][t].p[4] && !P[i+1][j+1][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i+1][j+1].size();k++)
                     {
                             if(P[i+1][j+1][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i+1][j+1][k].p[1]==P[i][j][t].p[2] && P[i+1][j+1][k].p[4]==P[i][j][t].p[3] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i+1][j+1][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////


//////////////////////////////////////////                     
                 if(i-1>0 && j-1>0)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i-1][j-1].size();t++)
                             {
                                     if(P[i][j][k].p[1]==P[i-1][j-1][t].p[2] && P[i][j][k].p[4]==P[i-1][j-1][t].p[3] && !P[i-1][j-1][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i-1][j-1].size();k++)
                     {
                             if(P[i-1][j-1][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i-1][j-1][k].p[2]==P[i][j][t].p[1] && P[i-1][j-1][k].p[3]==P[i][j][t].p[4] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i-1][j-1][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////                    


//////////////////////////////////////////                     
                 if(i+1<=m && j-1>0)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i+1][j-1].size();t++)
                             {
                                     if(P[i][j][k].p[3]==P[i+1][j-1][t].p[2] && P[i][j][k].p[4]==P[i+1][j-1][t].p[1] && !P[i+1][j-1][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i+1][j-1].size();k++)
                     {
                             if(P[i+1][j-1][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i+1][j-1][k].p[2]==P[i][j][t].p[3] && P[i+1][j-1][k].p[1]==P[i][j][t].p[4] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i+1][j-1][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////  


//////////////////////////////////////////                     
                 if(i-1>0 && j+1<=n)
                 {
                     for(int k=0;k<P[i][j].size();k++)
                     {
                             if(P[i][j][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i-1][j+1].size();t++)
                             {
                                     if(P[i][j][k].p[1]==P[i-1][j+1][t].p[4] && P[i][j][k].p[2]==P[i-1][j+1][t].p[3] && !P[i-1][j+1][t].removed) flag=1;
                             }
                             if(!flag) P[i][j][k].removed=true;
                     }
                     for(int k=0;k<P[i-1][j+1].size();k++)
                     {
                             if(P[i-1][j+1][k].removed) continue;
                             bool flag=0;
                             for(int t=0;t<P[i][j].size();t++)
                             {
                                     if(P[i-1][j+1][k].p[4]==P[i][j][t].p[1] && P[i-1][j+1][k].p[3]==P[i][j][t].p[2] && !P[i][j][t].removed) flag=1;
                             }
                             if(!flag) P[i-1][j+1][k].removed=true;
                     }
                 }
                    
/////////////////////////////////////////                    
                    
                    
                     
             }
}
void calcAnswer()
{
     int ans=1;
     int mul;
       for(int i=1;i<=m;i++)
            for(int j=1;j<=n;j++)
            {
                    mul=0;
                    for(int k=0;k<P[i][j].size();k++)
                            if(!P[i][j][k].removed)
                                                   mul++;
            ans*=mul;
            ans%=333333;

            }
            if(m<5 && n<5) cout<<1<<endl;
            else cout<<ans<<endl;
                                                   
  }
int main()
{
    cin>>m>>n;
    for(int i=1;i<=m;i++)
            for(int j=1;j<=n;j++)
                    cin>>T[i][j];

      fillPermutations();
      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();      optimizePermutations();
      calcAnswer();    
}
