/*
TASK: table
LANG: C++
*/

#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;

int Min(int a,int b){if (a<b)return a;return b;}
int Max(int a,int b){if (a>b)return a;return b;}
                 
#define MAXN 333333
#define Repi(n) for(int i=0;i<n;i++)
#define Repj(n) for(int j=0;j<n;j++)
#define Repk(n) for(int k=0;k<n;k++)

int m,n;

int FastPow(int a,int b){
    if(b==1){return a%MAXN;}
    if(b%2==0){return (FastPow(a,b/2)*FastPow(a,b/2))%MAXN;}
    else{return (FastPow(a,b/2)*FastPow(a,b/2)*a)%MAXN;}
}

/*
inline void Check(){
    Repi(m){
        Repj(n){
            TableConv[i][j]=0;
        }
    }
    
    Repi(m){
        Repj(n){
            Table[i][j]=Array[j+n*i];
        }
    }
    
    Repi(m){
        Repj(n){
            if(i+1<m){TableConv[i][j]+=Table[i+1][j];}
            if(i-1>=0){TableConv[i][j]+=Table[i-1][j];}
            if(j+1<n){TableConv[i][j]+=Table[i][j+1];}
            if(j-1>=0){TableConv[i][j]+=Table[i][j-1];}
            TableConv[i][j]%=3;
        }
    }
    
    int error=0;
    Repi(m){
        Repj(n){
            if(TableConv[i][j]!=TableReal[i][j]){error=1;}
        }
    }
    
    if(error==0){
        sol++;
        Repi(2){Repj(2){cout<<Table[i][j]<<" ";}cout<<endl;}cout<<endl;
    }
}
*/

int main(){
    cin>>m>>n;

    if(m%2==0 || n%2==0){
        cout<<1<<endl;
    }
    else {
        cout<<(FastPow(Max(m,n),Min(m,n)))%MAXN<<endl;
    }

//cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
//system("pause");

    return 0;
}
