/*
TASK: table
LANG: C++
*/
#include <iostream>
#include <cmath>
using namespace std;
#define MIN(a, b) a < b ? a : b
#define MAX(a, b) a > b ? a : b
#define FOR(i, a, b) for(int i = a; i <= b; i++)
int x, y, d[36][36];
bool is_sym()
{               
    FOR(i, 1, x)
        FOR(j, 1, y)
        {
            //cout << i << " " << j << " " << x - i + 1 << " " << y - j + 1 << endl;
            if (d[i][j] != d[x-i+1][y-j+1]) return false;
        }
    return true;
}
long long solve()
{
    int a1 = x, a2 = y;
    if (x == y)
    {
        if (is_sym()) return (long long)pow(3.0, (double)x);
        else return 0;
    }
    x = MIN(a1, a2);
    y = MAX(a1, a2);
    unsigned p = (int)pow(2.0, (double)x);
    if (y % p == 1)
    {
        if (is_sym()) return (long long)pow(3.0, (double)x);
        else return 0;
    }
    else return 1;
    return 0;
}
int main()
{
    cin >> x >> y;
    FOR(i, 1, x)
        FOR(j, 1, y)
        {
            cin >> d[i][j];
        }
    cout << solve() % 333333 << endl;
    return 0;
}
