/*
TASK: table
LANG: C++
*/

#include <iostream>
#define MAXN 32
using namespace std;

int m, n, T[MAXN][MAXN], S[MAXN][MAXN], br = 0;

void check_right() {
     int sum, i, j;
     for (i = 0; i < m; ++i) {
         for (j = 0; j < n; ++j) {
             sum = 0;
             if (i - 1 >= 0) sum += S[i - 1][j];
             if (j - 1 >= 0) sum += S[i][j - 1];
             if (i + 1 < m) sum += S[i + 1][j];
             if (j + 1 < n) sum += S[i][j + 1];
             if (sum%3 != T[i][j]) break;
         }
         if (j < n) break;
     }
     if (i >= m) br++;
     return;
}

void rec(int i, int j) 
{
     if (i < 0 || i >= m || j < 0 || j >= n) return;
     int sum = 0;
     if (i - 1 >= 0) sum += S[i - 1][j];
     if (j - 1 >= 0) sum += S[i][j - 1];
     sum = (T[i][j] + 3 - sum%3)%3;  
     if (i + 1 >= m && j + 1 >= n) {
           check_right();
           return;
     }
     switch (sum) {
            case 0: 
                 if (i + 1 < m && j + 1 < n) {
                       S[i][j + 1] = 2;
                       S[i + 1][j] = 1;
                       rec(i, j + 1);
                       S[i][j + 1] = 1;
                       S[i + 1][j] = 2;
                       rec(i, j + 1);
                       S[i][j + 1] = 0;
                       S[i + 1][j] = 0;
                       rec(i, j + 1);
                 }
                 else 
                      if (i + 1 < m) {
                         S[i + 1][j] = 0;
                         rec(i + 1, 0);
                      }
                      else if (j + 1 < n) {
                           S[i][j + 1] = 0;
                           rec(i, j + 1);
                      }
                 break;
            case 1: 
                 if (i + 1 < m && j + 1 < n) {
                       S[i][j + 1] = 0;
                       S[i + 1][j] = 1;
                       rec(i, j + 1);
                       S[i][j + 1] = 1;
                       S[i + 1][j] = 0;
                       rec(i, j + 1);
                       S[i][j + 1] = 2;
                       S[i + 1][j] = 2;
                       rec(i, j + 1);
                 }
                 else 
                      if (i + 1 < m) {
                         S[i + 1][j] = 1;
                         rec(i + 1, 0);
                      }
                      else if (j + 1 < n) {
                           S[i][j + 1] = 1;
                           rec(i, j + 1);
                      }
                 break;
            case 2: 
                 if (i + 1 < m && j + 1 < n) {
                       S[i][j + 1] = 0;
                       S[i + 1][j] = 2;
                       rec(i, j + 1);
                       S[i][j + 1] = 2;
                       S[i + 1][j] = 0;
                       rec(i, j + 1);
                       S[i][j + 1] = 1;
                       S[i + 1][j] = 1;
                       rec(i, j + 1);
                 }
                 else 
                      if (i + 1 < m) {
                         S[i + 1][j] = 2;
                         rec(i + 1, 0);
                      }
                      else if (j + 1 < n) {
                           S[i][j + 1] = 2;
                           rec(i, j + 1);
                      }
                 break;
     }
     return;
}

int main()
{
    int i, j;
    scanf("%d%d", &m, &n);
    
    for (i = 0; i < m; ++i) {
        for (j = 0; j < n; ++j) {
            scanf("%d", &T[i][j]);
        }
    }
    S[0][0] = 0;
    rec(0, 0);
    S[0][0] = 1;
    rec(0, 0);
    S[0][0] = 2;
    rec(0, 0);
    printf("%d\n", br%333333);
    return 0;
}
