/*
TASK:rings
LANG:c++
*/
#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>
using namespace std;
int n,m,a1,b1,a2,b2;
vector<int> a[1024];
int solve(int u,int v){
    int used1[1024],used2[1024];
    for(int i=1;i<=n;i++){used1[i]=-1;used2[i]=-1;}
    used1[u]=0;
    used2[v]=0;
    queue<int> q;
    q.push(u);
    while(!q.empty()){
        int p=q.front();q.pop();
        for(int i=0;i<a[p].size();i++)
        if(used1[a[p][i]]==-1){used1[a[p][i]]=used1[p]+1;q.push(a[p][i]);}
    }
    q.push(v);
    while(!q.empty()){
        int p=q.front();q.pop();
        for(int i=0;i<a[p].size();i++)
        if(used2[a[p][i]]==-1){used2[a[p][i]]=used2[p]+1;q.push(a[p][i]);}
    }
    int l=used1[v];
    int br=0;
    for(int i=1;i<=n;i++) if(used1[i]==(l-used2[i])) br++;
    return n-br;
}
int main(){
    scanf("%d %d",&n,&m);
    for(int i=0;i<m;i++){
        int u,v;
        scanf("%d %d",&u,&v);
        a[u].push_back(v);
        a[v].push_back(u);
    }
    scanf("%d %d",&a1,&b1);
    scanf("%d %d",&a2,&b2);
    int ans1=solve(a1,b1),ans2=solve(a2,b2);
    printf("%d %d\n",ans1,ans2);
    return 0;
}
