/*
TASK:rings
LANG:C++
*/



#include <cstdio>
#include <queue>
#include <vector>
#include <bitset>
using namespace std;

queue <int> q;
vector <int> a[1001];
int num[2][2][1001];
bitset <1001> used;

int n,m,mn[2],from[2],to[2];


void input() {
    scanf("%d%d",&n,&m);
    int x,y;
    
    for (int i=0;i<m;i++) {
	scanf("%d%d",&x,&y);
	a[x].push_back(y);
	a[y].push_back(x);
    }
    
    scanf("%d%d%d%d",&from[0],&to[0],&from[1],&to[1]);
}




void bfs(int from,int to,int ind,int indnum) {

	num[indnum][ind][from]=1;
	q.push(from);
	
	int x,y,size;
	
	while(!q.empty()) {
		
		x=q.front();

		q.pop();

		size=a[x].size();
		
		for (int i=0;i<size;i++) {

			y=a[x].at(i);
			if (num[indnum][ind][y]==0) {

				q.push(y);
				num[indnum][ind][y]=num[indnum][ind][x]+1;
				if (y==to) mn[indnum]=num[indnum][ind][to];
			}
		}
	}
	mn[indnum]++;
}

		




int main() {
	input();
	bfs(from[0],to[0],0,0);
	bfs(to[0],from[0],1,0);

	bfs(from[1],to[1],0,1);
	bfs(to[1],from[1],1,1);
	
	for (int indnum=0;indnum<2;indnum++) {
		int s=0;
		for (int i=1;i<=n;i++) if (num[indnum][0][i]+num[indnum][1][i]>mn[indnum]) s++;
		printf("%d",s);
		if (indnum==0) printf(" ");
		else printf("\n");
	}
	return 0;
}
