//Puni Andrei-Paul
//complexitate: O(N+M)
#include <stdio.h>

#define ull unsigned long long
#define Nmax 1000100

ull put[64], a[Nmax];

int N, M, A, B, C, X, Y;

int main() {
	freopen("tetris.in" , "r", stdin );
	freopen("tetris.out", "w", stdout);
	
	scanf("%d%d%d%d%d%d%d", &N, &M, &A, &B, &C, &X, &Y);
	
	put[0] = 1;
	for (int i = 1; i < 64; ++i)
		put[i] = put[i-1] * 2;
	
	if (A <= B) {
		a[A] += put[64-C];
		a[B+1] -= put[64-C];
	}
	else {
		a[B] += put[64-C];
		a[A+1] -= put[64-C];
	}
	
	for (int i = 2; i <= M; ++i) {		
		A = ((ull)A*i)%1008989;
		if (A > N)
			A = N;
		B = ((ull)B*i)%1008989;
		if (B > N)
			B = N;
		C = (C*X+Y)%47+1;
			
		if (A <= B) {
			a[A] += put[64-C];
			a[B+1] -= put[64-C];
		}
		else {
			a[B] += put[64-C];
			a[A+1] -= put[64-C];
		}				
	}
	
	int ret = 0;
	
	for (int i = 1; i <= N; ++i) {
		a[i] += a[i-1];
		ull tmp = a[i];
		while (tmp) {
			++ret;
			tmp = tmp&(tmp-1);
		}
	}
		
	printf("%d\n", ret);
	
	return 0;
}
