//Autor: Puni Andrei-Paul
//complexitate: O(N*C + M)

#include <stdio.h>

#define ull unsigned long long
#define Nmax 350100
#define Cmax 47

int a[Cmax][Nmax];

int N, M, A, B, C, X, Y;

int main() {
	freopen("tetris.in" , "r", stdin );
	freopen("tetris.out", "w", stdout);
	
	scanf("%d%d%d%d%d%d%d", &N, &M, &A, &B, &C, &X, &Y);

	
	if (A <= B) {
		++a[C-1][A];
		--a[C-1][B+1];
	}
	else {
		++a[C-1][B];
		--a[C-1][A+1];
	}				
	
	for (int i = 2; i <= M; ++i) {		
		A = ((ull)A*i)%1008989;
		if (A > N)
			A = N;
		B = ((ull)B*i)%1008989;
		if (B > N)
			B = N;
		C = (C*X+Y)%47+1;
			
		if (A <= B) {
			++a[C-1][A];
			--a[C-1][B+1];
		}
		else {
			++a[C-1][B];
			--a[C-1][A+1];
		}				
	}
	
	int ret = 0;
	
	for (int i = 1; i <= N; ++i) {
		for (int j = 46; j >= 0; --j) {
			a[j][i] += a[j][i-1];						
		}
	}
	
	for (int i = 1; i <= N; ++i) {
		for (int j = 46; j >= 0; --j) {
			ret += a[j][i] % 2;
			if (j > 0)
				a[j-1][i] += a[j][i] / 2;
		}
	}
		
	printf("%d\n", ret);
	
	return 0;
}
