/*
 * FAKE N^2 code
 * should have 0 points
 */

#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010

const double pi = acos(-1);
const double pi2 = pi * 2;

int N;

int xx[NMAX], yy[NMAX];
double uu[NMAX];

double mod_2pi(double x)
{
	while (x >= 2 * pi) x -= 2 * pi;

	return x;
}

int main()
{
	int i, j, step;

	freopen("hawaii.in", "r", stdin);
	freopen("hawaii.out", "w", stdout);

	scanf("%d", &N); N++;

	for (i = 1; i <= N; i++) {
		scanf("%d %d", &xx[i], &yy[i]);

		double u = -1;

		u = atan2(yy[i] - yy[1], xx[i] - xx[1]);
		if (u < 0) u += 2 * pi;

		uu[i] = u;
	}

	sort(uu + 2, uu + N + 1);

	for (i = N + 1; i < N + N; i++) uu[i] = uu[i - N + 1] + 2 * pi;

//	for (i = 1; i < N + N; i++) printf("%g ", uu[i] * 180 / pi);
//	printf("\n");
	
	long long rez = 0;

	for (i = 2; i <= N; i++) {
		int p1 = 1, p2 = 1;
		for (j = i + 1; j < N; j++) {
/*			int stepmax;
			for (stepmax = 1; stepmax <= N + N; stepmax <<= 1);

			int p1 = 0;
			for (step = stepmax; step; step >>= 1)
				if (p1 + step < N + N && uu[p1 + step] < uu[i]) p1 += step;

			int p2 = 0;
			for (step = stepmax; step; step >>= 1)
				if (p2 + step < N + N && uu[p2 + step] < uu[j]) p2 += step;

//			p1 = max(j, p1);
			int q = p2 - p1;
		
*/
			while (uu[p1] < uu[i]) p1++;
			while (uu[p2] < uu[j]) p2++;
			int q = p2 - p1;

			rez += (long long) q * q;
		}
	}


	printf("%lld\n", rez / 3);

	return 0;
}

