#include <fstream>
#include <cstdlib>
#include <cstring>

using namespace std;

const int MAXN = 1000010;
const int MAXL = 2510;
const int SIGMA = 26;

int N, M, L, K;
char A[MAXN];
char B[MAXL];
int cnt[SIGMA];

int check(int start) {
	int cnt = 0;

	for (int i = 1; i <= L; ++i)
		if (A[start+i] != B[i]) {
			++cnt;
			if (cnt > K) {
				return 0;
			}
		}

	return 1;
}

int main() {

	ifstream fin("radio.in");
	ofstream fout("radio.out");

	fin >> N >> M >> L >> K;

	fin >> (A+1);

	for (int i = 1; i <= N; ++i) 
		A[i] -= 'a';

	for (int t = 1; t <= M; ++t) {

		memset(cnt, 0, sizeof(cnt));

		fin >> (B+1);

		int res = 0, diff = 0;

		for (int i = 1; i <= L; ++i) {
			B[i] -= 'a';
			++cnt[(int) B[i]];
			--cnt[(int) A[i]];
		}

		for (int i = 0; i < SIGMA; ++i)
			diff += abs(cnt[i]);

		if (diff <= 2*K)
			res |= check(0);

		for (int i = L+1; i <= N && !res; ++i) {
			diff -= abs(cnt[(int) A[i]]);
			--cnt[(int) A[i]];
			diff += abs(cnt[(int) A[i]]);
			diff -= abs(cnt[(int) A[i-L]]);
			++cnt[(int) A[i-L]];
			diff += abs(cnt[(int) A[i-L]]);

			if (diff <= 2*K)
				res |= check(i-L);
		}


		fout << res << '\n';
	}

	return 0;
}
