/*
 * Autor: Marius Nicoli
 */
#include <stdio.h>
#include <vector>

#define MOD 987654
#define B 32

using namespace std;

int H[MOD][10];

char S[1000011];
char C[2600];

int i,j,k,p,ok,gasit,s,tot,put,h,N,K,L,M,len;

int main(){
	FILE *f = fopen("radio.in","r");
	FILE *g = fopen("radio.out","w");
	fscanf(f,"%d %d %d %d\n", &N, &M, &L, &K);
	
	fscanf(f,"%s",S+1);
	
	for (i=1;i<=N;i++)
		S[i]-=97;
	
	len = L/(K+1);
	put = 1;
	for (i=1, h=0; i<len;i++) {
		h = (h * B + S[i]) % MOD;
		put = (put * B) % MOD;
	}
	h = (h * B + S[i]) % MOD;
	
	++H[h][0];
	H[h][ H[h][0] ] = 1;
	for (i = len+1; i<=N; i++) {
		h = (h - S[i-len] * put) % MOD;
		h = ((h>=0) ? h : (h+MOD));
		h = (h * B + S[i]) % MOD;
		
		++H[h][0];
		H[h][H[h][0]] = i-len;
	}
	
	for (i = 1; i<=M; i++) {
		fscanf(f,"%s",C+1);
		for (j=1;j<=L;j++)
			C[j] -= 97;
		
		gasit = 0;
		
		for (j=0;j<=K;j++) {
			h = 0;
			for (k = 1; k <= len; k++)
				h = (h * B + C[j*len+k]) % MOD;
			if (H[h][0]) {
				for (k = 1; k <= H[h][0]; k++){
					tot = 0;
					s = H[h][k] - j*len;
					ok = 1;
					for (int p = 1; p <= L; p++) 
						if (S[s+p] != C[p]) {
							tot++;
							if (tot > K) {
								ok = 0;
								break;
							}
						}
					if (ok) {
						gasit = 1;
						break;
					}
				}
			}
		}
		fprintf(g,"%d\n",gasit);
	}
	fclose(f);
	fclose(g);
	return 0;
}
