//autor: Puni Andrei-Paul
//complexitate: O(N * CMMMC(cicluri))
#include <stdio.h>

#define Nmax 100100
#define DivMax 256

int n;
int sir[Nmax];
int perm[Nmax];
int retPerm[Nmax];
int tmpPerm[Nmax];
int RetPerm[Nmax];

void aplica_permutarea() {
	int i;
	for (i = 1; i <= n; ++i)
		tmpPerm[i] = retPerm[perm[i]];
	for (i = 1; i <= n; ++i)
		retPerm[i] = tmpPerm[i];		
}

int verifica() {
	int i;
	for (i = 1; i <= n; ++i) {
		if (sir[RetPerm[i]] > sir[retPerm[i]])
			return 1;
		if (sir[RetPerm[i]] < sir[retPerm[i]])
			return 0;
	}
	return 0;
}

void update() {
	int i;
	for (i = 1; i <= n; ++i)
		RetPerm[i] = retPerm[i];
}

int identica() {
	int i;
	for (i = 1; i <= n; ++i)
		if (retPerm[i] != i)
			return 0;
	return 1;
}

void afis() {
	int i;
	for (i = 1; i <= n; ++i)
		printf("%d ", retPerm[i]);
	printf("\n");
}

void afis2() {
	int i;
	for (i = 1; i <= n; ++i)
		printf("%d ", sir[retPerm[i]]);
	printf("\n");
}

int main() {
	freopen("randomizare.in" , "r", stdin );
	freopen("randomizare.out", "w", stdout);
	
	scanf("%d", &n);
	
	int i;
	
	for (i = 1; i <= n; ++i) {
		scanf("%d", &sir[i]);
		retPerm[i] = i;
		RetPerm[i] = i;
	}

	for (i = 1; i <= n; ++i) {
		scanf("%d", &perm[i]);
	}
	
	do {
		//afis2();
		if (verifica())
			update();
		aplica_permutarea();
	} while (!identica());

	
	for (i = 1; i <= n; ++i)
		printf("%d ", sir[RetPerm[i]]);
	
	return 0;
}
