/* Gheorghe Cosmin
 * Solutie O(N log N)
 */

#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

#define NMAX 200010

int N, K, rez = 0;

vector <int> leg[NMAX];
vector <pair<int, int> > fii[NMAX];
int djos[NMAX];

char viz[NMAX];

void back(int x)
{
	int y;

	viz[x] = 1;

	for (vector <int> :: iterator it = leg[x].begin(); it != leg[x].end(); ++it) {
		y = *it;

		if (viz[y]) continue;

		back(y);

		fii[x].push_back(make_pair(-(djos[y] + 1), y));
	}

	sort(fii[x].begin(), fii[x].end());

	int q = fii[x].size(), j = 0;
	while (j + 1 < q && -(fii[x][j].first + fii[x][j + 1].first) > K) {
		rez++;
		j++;
//		printf("%d - %d %d\n", fii[x][j].first, fii[x][j + 1].first);
	}

	if (j < q && -fii[x][j].first > K) {
		rez++;
		j++;
	}

	if (j < q) djos[x] = -fii[x][j].first;
	else djos[x] = 0;

//	printf("%d %d\n", x, djos[x]);
}

int main()
{
	int i, x, y;

	freopen("kdtree.in", "r", stdin);
	freopen("kdtree.out", "w", stdout);

	scanf("%d %d", &N, &K);

	for (i = 1; i < N; i++) {
		scanf("%d %d", &x, &y);

		leg[x].push_back(y);
		leg[y].push_back(x);
	}

	back(1);

	printf("%d\n", rez);

	return 0;
}

