/* Marius Dragus
 * Solutie O(N * K) timp si O(N * K) memorie
 */

#include<stdio.h>
#include<algorithm>
#include<vector>
#define pb push_back

using namespace std;
const int maxn = 100010;
const int maxk = 110;

vector<int> VECT[maxn];
int VER[maxn];
int DIN[maxn][maxk];
int N,K;

void dfs(int nod)
{
	if (VER[nod]) return ;
	VER[nod] = 1;
	for(int i = 0;i < VECT[nod].size(); ++i)
		dfs(VECT[nod][i]);
	for(int j = 1;j <= K; ++j)
	{
		if ((j * 2 - 1) <= K)
		{
			int sum = 0;
			for(int i = 0;i < VECT[nod].size(); ++i)
			{
				if (VER[VECT[nod][i]] == 1) continue;				
				sum += DIN[VECT[nod][i]][j - 1];		
			}
			DIN[nod][j] = sum;
		}
		else
		{
			int sum = 0;
			int aux = K - j;
			for(int i = 0;i < VECT[nod].size(); ++i)
			{
				if(VER[VECT[nod][i]] == 1) continue;
				sum += DIN[VECT[nod][i]][aux];
			}
			int maxim = -1000000;
			for(int i = 0;i < VECT[nod].size(); ++i)
			{
				if(VER[VECT[nod][i]] == 1) continue;
				maxim = max(maxim,DIN[VECT[nod][i]][aux] - DIN[VECT[nod][i]][j - 1]);												 
			}
			DIN[nod][j] = sum - maxim;
		}
		DIN[nod][j] = min(DIN[nod][j],DIN[nod][j - 1]);
	}
	DIN[nod][0] = min(DIN[nod][0],DIN[nod][K] + 1);
	for(int j = 1;j <= K; ++j)
		DIN[nod][j] = min(DIN[nod][j],DIN[nod][j - 1]);
	VER[nod] = 2;
	return ;
}


int main()
{
	freopen("kdtree.in","r",stdin);
	freopen("kdtree.out","w",stdout);
	scanf("%d %d\n",&N,&K);
	K++;
	for(int i = 1;i < N; ++i)
	{
		int x,y;
		scanf("%d %d\n",&x,&y);
		VECT[x].pb(y);
		VECT[y].pb(x);
	}
	for(int i = 1;i <= N; ++i)
		for(int j = 0;j <= K; ++j)
			DIN[i][j] = N;
	dfs(1);
	printf("%d\n",DIN[1][0] - 1);
	return 0;
}




