/*
	Airinei Adrian
	Complexitate O(N^2+M) optimizat
*/
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define MAXN 100100

int N, M, viz[MAXN], dist[MAXN], list[MAXN];
int query[MAXN], K[MAXN];
vector<int> Ans[MAXN], G[MAXN], C[MAXN];
int V[MAXN];

void dfs(int x)
{
	viz[x] = 1;
	int i;
	for(i = 0; i < G[x].size(); i++)
	{
		if(!viz[G[x][i]])
			dist[G[x][i]] = dist[x]+C[x][i], dfs(G[x][i]);
	}
}

void read_and_solve(void)
{
	int i, j, k, c;
	scanf("%d %d\n", &N, &M);
	for(i = 1; i < N; i++)
		scanf("%d %d %d\n", &j, &k, &c),
		G[j].push_back(k), G[k].push_back(j), C[j].push_back(c), C[k].push_back(c);
	for(i = 1; i <= M; i++)
		scanf("%d\n", &query[i]), K[query[i]]++;
	for(i = 1; i <= N; i++)
		if(K[i])
		{
			for(j = 1; j <= N; j++)
				viz[j] = 0;
			dist[i] = 0, dfs(i);
			for(j = 1; j <= N; j++)
				V[j] = dist[j];
			sort(V+1, V+N+1);
			reverse(V+1, V+N+1);
			for(j = 1; j <= K[i]; j++)
				Ans[i].push_back(V[j]);
		}
	for(i = 1; i <= M; i++)
		printf("%d\n", Ans[query[i]][ list[query[i]]++ ]);
}

int main(void)
{
	freopen("regat.in", "rt", stdin);
	freopen("regat.out", "wt", stdout);

	read_and_solve();

	return 0;
}






