#include <iostream.h>

int S,T;
int cur[12];
bool assigned[12];
int num[12];
bool used[12];
int sol;

inline bool rowok(int a, int b, int c, int d)
{
  int sum=(cur[a] + cur[b] + cur[c] + cur[d]);
  if (assigned[a] && assigned[b] && assigned[c] && assigned[d])
    return sum == T;
  else
    return sum < T;
}

inline bool ok()
{
  return 
    rowok(0, 1, 2, 3) &&
    rowok(3, 4, 5, 6) &&
    rowok(6, 7, 8, 0) &&
    rowok(9, 2, 4, 11) &&
    rowok(11, 5, 7, 10) &&
    rowok(10, 8, 1, 9);
}

void Rec(int ass)
{
  int i;
  if (ass == 12)
    {
      sol++;
      return;
    }

  for (i=1; i<12; i++)
    if (!used[i])
      {
	cur[ass] = num[i];
	assigned[ass] = true;
	if (ok())
	  {
	    used[i] = true;
	    Rec(ass+1);
	    used[i] = false;
	  }
	assigned[ass] = false;
	cur[ass] = 0;
      }
}

void CountThem()
{
  sol = 0;
 
  used[0] = true;

  cur[0] = num[0];
  assigned[0] = true;
  Rec(1);

  cur[1] = num[0]; 
  assigned[1] = true;
  for (int i=1; i<12; i++)
    {
      cur[0] = num[i];
      if (ok())
	{
	  used[i] = true;
	  Rec(2);
	  used[i] = false;
	}
    }

  cout << sol/2 << endl;
}

int main()
{
  int i;
  while (1)
    {
      S = 0;
      for (i=0; i<12; i++)
	{
	  cin >> num[i];
	  S += num[i];
	  assigned[i] = used[i] = false;
	  cur[i] = 0;
	}

      if (cin.fail())
	return 0;

      T = S/3;
      if (T*3 != S)
	cout << "0\n";
      else
	CountThem();
    }
}







