/* Romanian Champions */

/* @JUDGE_ID: 20659MA A C */
#include <stdio.h>

#define maxn 26
#define maxm 10000

typedef struct wh {long a[26],x,s;} wh;

long n,m;
long sol[maxn];
long i,j,tmp,ok,k;
char buff[1000];
wh w[maxm];
long nra[maxn],nrl[maxn];
long a[maxn][maxm],l[maxn][maxm];
long mark[maxn+1];
long left[maxn],nl,vl;

int sgn(long a){if(a<0) return -1;if(a>0) return 1;return 0;}

int calcmin(long a)
{
  long i,s,st,en;
  st=0;en=nl;
  s=w[a].s;
  for(i=k+1;i<n;i++){
    if(w[a].a[i]<0) s-=left[--en];
    if(w[a].a[i]>0) s+=left[st++];
    }
  return s;
  }
  
int calcmax(long a)
{
  long i,s,st,en;
  st=0;en=nl;
  s=w[a].s;
  for(i=k+1;i<n;i++){
    if(w[a].a[i]<0) s-=left[st++];
    if(w[a].a[i]>0) s+=left[--en];
    }
  return s;
  }
  
int pospune(long poz,long wh)
{
  long i,j,W,aa;
  for(i=0;i<nrl[poz];i++){
    W=l[poz][i];
    if(sgn(w[W].s+(w[W].a[poz]*wh))!=w[W].x) return 0;
    }
  return 1;
  }

int possible(long poz)
{
  long i,j,aa,W;
  nl=0;for(i=1;i<=n;i++) if(!mark[i]) left[nl++]=i;
  for(i=poz+1;i<n;i++)
    for(j=0;j<nrl[i];j++){
      W=l[i][j];
      if(w[W].x<0){aa=calcmin(W);if(aa>=0) return 0;}
      if(w[W].x>0){aa=calcmax(W);if(aa<=0) return 0;}
      if(w[W].x==0){
        aa=calcmin(W);if(aa>0) return 0;
        aa=calcmax(W);if(aa<0) return 0;
        }
      }
  return 1;
  }

void pune(long poz,long wh)
{
  long i,W;
  sol[poz]=wh;mark[wh]=1;
  for(i=0;i<nra[poz];i++){
    W=a[poz][i];
    w[W].s+=w[W].a[poz]*wh;
    }
  }

void scoate(long poz,long wh)
{
  long i,W;
  mark[wh]=0;
  for(i=0;i<nra[poz];i++){
    W=a[poz][i];
    w[W].s-=w[W].a[poz]*wh;
    }
  }
  
void back()
{
  long i;
  if(k==n) {ok=1;return;}
  
  for(i=1;i<=n;i++){
    if(mark[i]) continue;
    vl=i;if(!pospune(k,i)) continue;
    pune(k,i);
    if(possible(k)) {k++;back();k--;}
    if(ok) return;
    scoate(k,i);
    }
  }
  
int main()
{
  freopen("a.in","rt",stdin);
  while(1){
    if(scanf("%ld %ld",&n,&m)!=2) break;
    fgets(buff,1000,stdin);
    memset(nra,0,sizeof(nra));
    memset(nrl,0,sizeof(nrl));
    memset(a,0,sizeof(a));memset(l,0,sizeof(l));
    for(i=0;i<m;i++){
      fgets(buff,1000,stdin);
      memset(w+i,0,sizeof(w[i]));
      tmp=1;
      for(j=0;buff[j];j++){
        if(buff[j]=='=') {tmp=-1;continue;}
        if(buff[j]=='<') {tmp=-1;w[i].x=-1;continue;}
        if(buff[j]=='>') {tmp=-1;w[i].x=1;continue;}
        if(buff[j]>='a' && buff[j]<='z') w[i].a[buff[j]-'a']+=tmp;
        }
      for(j=0;j<maxn;j++) if(w[i].a[j]) a[j][nra[j]++]=i;
      for(j=maxn-1;j>=0;j--) if(w[i].a[j]) break;
      l[j][nrl[j]++]=i;
      }
    memset(sol,0,sizeof(sol));
    memset(mark,0,sizeof(mark));
    ok=k=0;back();
    if(ok){
      printf("Solution: %ld",sol[0]);
      for(i=1;i<n;i++) printf(" %ld",sol[i]);
      printf("\n");
      } else printf("No solution possible!\n");
    }
    
  return  0;
  }

/* @end_of_source_code */

