/* Romanian Champions */

/* @JUDGE_ID: 20659MA D C */
#include <stdio.h>
#include <math.h>

#define maxn 100000
#define real double

typedef struct punct {real x,y;} punct;
typedef struct dreapta {real a,b,c;} dreapta;

punct vf[maxn];
dreapta dr1[maxn],dr2[maxn];
long n,i,j;
real dd,rez;

real getpd(punct p,dreapta d)
{
  return fabs(p.x*d.a+p.y*d.b+d.c)/sqrt(d.a*d.a+d.b*d.b);
  }
  
void getdr(dreapta *d,punct p1,punct p2)
{
  d->a=p1.y-p2.y;
  d->b=p2.x-p1.x;
  d->c=p1.x*p2.y-p2.x*p1.y;
  }

void getint(punct *p,dreapta d1,dreapta d2)
{
  real tmp=d1.a*d2.b-d1.b*d2.a;
  p->x=( d2.b*d1.c-d1.b*d2.c   )/(-tmp);
  p->y=( d1.a*d2.c-d1.c*d2.a   )/(-tmp);
  }

void getnewdr(dreapta *d,dreapta x,punct p)
{
  dreapta d1,d2;
  real ct;
  real nr1,nr2;

  ct=dd*sqrt(x.a*x.a+x.b*x.b);
  d1.a=x.a;d1.b=x.b;d1.c=x.c-ct;
  d2.a=x.a;d2.b=x.b;d2.c=x.c+ct;
  nr1=getpd(p,d1);nr2=getpd(p,d2);
  if(nr1<nr2) {d->a=d1.a;d->b=d1.b;d->c=d1.c;} else
    {d->a=d2.a;d->b=d2.b;d->c=d2.c;}
  }
  
int main()
{
  freopen("d.in","rt",stdin);
  while(1){
    scanf("%lf %ld",&dd,&n);
    if(!dd && !n) break;
    for(i=0;i<n;i++) scanf("%lf %lf",&vf[i].x,&vf[i].y);
    if(n<3) {printf("0\n");continue;}
    for(i=0;i<3;i++) vf[n+i]=vf[i];
    for(i=0;i<n;i++) getdr(dr1+i,vf[i],vf[i+1]);
    for(i=0;i<n;i++) getnewdr(dr2+i,dr1[i],vf[i+2]);
    for(i=0;i<n-1;i++) getint(vf+i,dr2[i],dr2[i+1]);
    getint(vf+(n-1),dr2[n-1],dr2[0]);
    vf[n]=vf[0];
    rez=0;
    for(i=0;i<n;i++) rez+=fabs(vf[i].x*vf[i+1].y-vf[i].y*vf[i+1].x);
    printf("%3.3f\n",rez);
    }
  return 0;
  }


/* @end_of_source_code */

