#include <stdio.h>


#define N 11

int w, h;
int block[N+1][N+1] = {
 {0,0,0,0,0,0,0,0,0,0,0,0},

 {0,   0,  1,  0,  1,  0,  1,  0,  1,  0,  1,  0},
 {0,   1,  2,  3,  5,  8, 13, 21, 34, 55, 89,144},
 {0,   0,  3,  0, -1,  0, -1,  0, -1,  0, -1,  0},
 {0,   1,  5, -1, -1, -1, -1, -1, -1, -1, -1, -1},
 {0,   0,  8,  0, -1,  0, -1,  0, -1,  0, -1,  0},
 {0,   1, 13, -1, -1, -1, -1, -1, -1, -1, -1, -1},
 {0,   0, 21,  0, -1,  0, -1,  0, -1,  0, -1,  0},
 {0,   1, 34, -1, -1, -1, -1, -1, -1, -1, -1, -1},
 {0,   0, 55,  0, -1,  0, -1,  0, -1,  0, -1,  0},
 {0,   1, 89, -1, -1, -1, -1, -1, -1, -1, -1, -1},
 {0,   0,144,  0, -1,  0, -1,  0,  0,  0, -1,  0}
};

unsigned long doit(int wr, int hr);

int main(void)  {
  FILE *in, *out;
  in  = fopen("build.inp", "rt");
  out = fopen("build.out", "w+");
    fscanf(in, "%d %d", &w, &h);
    fprintf(out, "%d", doit(w, h));
  fclose(in);
  fclose(out);
  return 0;
}

unsigned long doit(int wr, int hr)  {
  int c, sum = 0;
  if(block[hr][wr] != -1) return block[hr][wr];
  for(c=1; c<wr; c++) sum+= doit(c, hr) + doit(wr-c, hr);
  for(c=1; c<hr; c++) sum+= doit(wr, c) + doit(wr, hr-c);
  return sum;
}
