const
 MaxN = 175;
var
 f1,f2   : Text;
 Cnt,Ind,
 N,II,JJ : Integer;
 G       : Array[1..MaxN,1..MaxN] Of Boolean;
 Used    : Array[1..MaxN] Of Boolean;

 function Reach(Src,Trg : Integer) : Boolean;
 var
  I : Integer;
 begin
  Used[Src] := True;

  If G[Src,Trg] Then
   Begin
    Reach := True;
    Exit;
   End;

  Reach := False;

  For I:=1 To N Do
  If not Used[I] Then
   If G[Src,I] Then
    If Reach(I,Trg) Then
     Begin
      Reach := True;
      Exit;
     End;
 end;

 procedure SolveSlow;
 var
  I,J : Integer;
 begin
  For I:=1 To N Do
   For J:=I+1 To N Do
    If G[I,J] Then
    Begin
     FillChar(Used,SizeOf(Used),False);
     G[I,J] := False;
     G[J,I] := False;
     If not Reach(I,J) Then
      Writeln(f2, I, ' ', J);
     G[I,J] := True;
     G[J,I] := True;
    End;
 end;

begin
 assign(f1, 'ROUTES.INP');
 reset(f1);

 readln(f1, N);

 For II:=1 To N Do
  For JJ:=1 To N Do
   G[II,JJ]:=False;

 For II:=1 To N Do
  Begin
   read(f1, Cnt);
   For Ind:=1 To Cnt Do
    Begin
     read(f1, JJ);
     G[II,JJ] := True;
     G[JJ,II] := True;
    End;
  End;

 For II:=1 To N Do G[II,II]:=False;

 close(f1);

 assign(f2, 'ROUTES.OUT');
 rewrite(f2);

 SolveSlow;

 close(f2);
end.