type
  need = record
           u : boolean;
           s, d : integer;
         end;

var
  a, n, b : integer;
  graph : array[1..200, 1..200] of boolean;
  sol : array[1..200] of need;

Procedure InputF;
var
  f : text;
  t, p : integer;
  begin
    assign(f, 'routes.inp');
    reset(f);
    readln(f, n);
    for a := 1 to n do
      begin
        read(f, t);
        for b := 1 to t do
          begin
            read(f, p);
            graph[a,p] := true; {!!!}
          end;
      end;
    close(f);
  end;

Procedure InitV;
  begin
    for a := 1 to 200 do
      for b := 1 to 200 do graph[a,b] := false;
    for a := 1 to 200 do
      begin
        sol[a].u := false;
        sol[a].s := 0;
        sol[a].d := 0;
      end;
  end;

Procedure Check(v : integer);
var
  i, br, t : integer;
  begin
    br := 0;
    for i := 1 to n do
      if graph[v,i] = true then
        begin
          t := i;
          inc(br);
        end;
    if br = 1 then
      begin
        sol[v].u := true;
        sol[v].s := v;
        sol[v].d := t;
      end;
  end;

Procedure Solution;
  begin
    for a := 1 to n do graph[a,a] := false;
    for a := 1 to n do Check(a);
  end;

Procedure WriteOut;
var
  f : text;
  begin
    assign(f, 'routes.out');
    rewrite(f);
    for a := 1 to n do      {!!!!!!!!}
      for b := 1 to n do
        if (a <> b) and (((sol[a].s = sol[b].s) and (sol[a].d = sol[b].d)) or
        ((sol[a].s = sol[b].d) and (sol[a].d = sol[b].s))) and (sol[a].u)
        and (sol[b].u) then
        sol[b].u := false;
    for a := 1 to n do
      if sol[a].u = true then
        if sol[a].s < sol[a].d then
          writeln(f, sol[a].s, ' ', sol[a].d)
        else
          writeln(f, sol[a].d, ' ', sol[a].s);
    close(f);
  end;

begin
  InitV;
  InputF;
  Solution;
  WriteOut;
end.
