const
 ifn = 'routes.inp';
 ofn = 'routes.out';
 maxn = 255;

var
 gr : array [0 .. maxn, 0 .. maxn] of longint;
 nn : array [0 .. maxn] of longint;
 u : array [0 .. maxn] of boolean;
 i, j, c, n : longint;
 t : text;
 wv : array [false .. true, 1..maxn] of longint;
 wl : array [false .. true] of longint;
 ic : array [0 .. maxn, 0..maxn] of byte;

procedure input;
var
 i, j : longint;

begin
 assign (t, ifn);
 reset (t);
 readln (t, n);
 for i := 1 to n do
  begin
   read (t, nn[i]);
   for j := 1 to nn[i] do
    begin
     read (t, gr[i, j]);
     ic [i, gr[i,j]] := 1;
     ic [gr[i,j], i] := 1;
    end;
  end;
 close (t);
end;

function tree (x: boolean) : boolean;
var
 c, nc : boolean;
 num : longint;
 v, vx, i, j : longint;

begin
 c := true;
 wv[c,1] := 1;
 wl [c] := 1;
 fillchar (u, sizeof (u), 0);
 num := n;

 while (wl[c] > 0) and (n > 0) do
  begin
   nc := not c;
   wl[nc] := 0;

   for i := 1 to wl[c] do
    begin
     v := wv[c, i];
     for j := 1 to nn[v] do
      begin
       vx := gr[v, j];
       if (not u [vx]) and (ic [v, vx] > 0) then
        begin
         u [vx] := true;
         inc (wl[nc]);
         wv[nc, wl[nc]] := vx;
         dec (num);
         if x then
          begin
           ic [v, vx] := 3;
           ic [vx, v] := 3;
          end;
        end;
      end;
    end;

   c := nc;
  end;

 tree := num = 0;
end;

function max (a,b : byte) : byte;
begin
 if a > b then max := a
  else max := b;
end;

procedure mirror;
var
 i, j : longint;

begin
 for i := 1 to n do
  for j := i+1 to n do
   begin
    if ic[i,j] < ic[j,i] then
     ic[i,j] := ic[j,i];
    ic[j,i] := ic[i,j];
   end;
end;

begin
 input;
 tree (true);

 assign (t, ofn);
 rewrite (t);
 for i := 1 to n do
  for j := i+1 to n do
   if ic[i,j] = 3 then
    begin
     ic [i,j] := 0;
     ic [j,i] := 0;
     if not tree(false) then
      writeln (t, i, ' ',j);
     ic [i,j] := 3;
     ic [j,i] := 3;
    end;

 close (t);
end.