#include <fstream.h>
#define maxn 171

int n,f=-1;
int br[maxn];

int visited[maxn];
int in[maxn],out[maxn];
int father[maxn];

int ima[maxn][maxn];
int tree[maxn][maxn];
int cicreb[maxn][maxn];

void input()
 {
  ifstream f("routes.inp");
  int fic,i,j;
  f>>n;
  for (i=0;i<n;i++)
   {
    f>>br[i];
    for (j=0;j<br[i];j++)
     {
      f>>fic;
      ima[i][fic-1]=ima[fic-1][i]=1;
     }
   }
  f.close();
 }

void deep(int k)
 {
  int j;
  visited[k]=1;
  f++;in[k]=f;
  for (j=0;j<n;j++)
   if (!visited[j] && ima[k][j] && k!=j)
    {
     tree[k][j]=tree[j][k]=1;
     father[j]=k;
     deep(j);
    }
  f++;out[k]=f;
 }

void findcicles()
 {
  int i,j,k,k1;
  for (i=0;i<n;i++)
   for (j=i+1;j<n;j++)
    if (!tree[i][j] && ima[i][j])
     {
      cicreb[i][j]=cicreb[j][i]=1;
      if (in[i]<in[j] && out[i]>out[j])
       {
	k=j;
	while (k!=i)
	 {
	  cicreb[k][father[k]]=cicreb[father[k]][k]=1;
	  k=father[k];
	 }
       }
      else if (in[j]<in[i] && out[j]>out[i])
       {
	k=i;
	while (k!=j)
	 {
	  cicreb[k][father[k]]=cicreb[father[k]][k]=1;
	  k=father[k];
	 }
       }
      else
       {
	k=j;
	while (in[i]>in[k] || out[i]<out[k])
	 {
	  cicreb[k][father[k]]=cicreb[father[k]][k]=1;
	  k=father[k];
	 }
	k1=i;
	while (k!=k1)
	 {
	  cicreb[k1][father[k1]]=cicreb[father[k1]][k1]=1;
	  k1=father[k1];
	 }
       }
    }
 }

void output()
 {
  ofstream f("routes.out");
  int i,j;
  for (i=0;i<n;i++)
   for (j=i+1;j<n;j++)
    if (ima[i][j] && !cicreb[i][j])
     f<<i+1<<' '<<j+1<<endl;
  f.close();
 }

void main()
 {
  input();
  deep(0);
  findcicles();
  output();
 }