/*
 * zadacha 1 - obikolka
 * Rangel Dokov
 * Plovdiv
 * A09
 */
#include <stdio.h>
#include <math.h>
#include <time.h>

struct snode{
       int x;
       int y;
};

struct snode nodes[201];
int edges[201][201];
int visited[201];
int curr_path[201];
int visited_count;
int curr_dist;
int best_path[201];
int best_dist=1000000000;
int count;
clock_t start_time;
clock_t curr_time;

void print_exit() {
     int i;

     printf("%d", best_path[1]);

     for( i=2; i<=count; i++)
          printf(" %d", best_path[i]);

     printf("\n");
     exit(0);
}

void search(int node) {
     int i;

     visited[node] = 1;
     visited_count++;
     curr_path[visited_count] = node;

     if( visited_count == count)
         if( curr_dist < best_dist) {
             memcpy(best_path, curr_path, 201*sizeof(int));
             best_dist = curr_dist;
         }

     curr_time = clock();
     if( (curr_time - start_time)/CLOCKS_PER_SEC > 4 )
         print_exit();

     for( i=1; i<=count; i++)
          if( !visited[i] ){
              curr_dist += edges[node][i];
              search(i);
              curr_dist -= edges[node][i];
          }

     visited[node] = 0;
     visited_count--;
}

int main() {
    int i, j;

    start_time = clock();

    scanf("%d", &count);
    for( i=1; i<=count; i++)
         scanf("%d %d", &nodes[i].x, &nodes[i].y);

    for( i=1; i<=count; i++)
         for( j=1; j<=count; j++)
              edges[i][j] = abs(nodes[i].x - nodes[j].x) +
                            abs(nodes[i].y - nodes[j].y);

    for( i=1; i<=count; i++)
         search(i);
    print_exit();
    return 0;
}
