Program Travel;
Const Nmax=200;
Type DistArray=array[1..Nmax,1..Nmax]of word;
Var i,j,N,index:byte;  {3<N<200}
    X,Y:array[1..Nmax] of integer;   {0<=x[i],y[i]<=10000}
    Dist:DistArray;
    Visited:array[1..Nmax]of boolean;

Procedure InitArray(var Dist:DistArray);
  var i,j:byte;
  begin
    for i:=1 to Nmax do
      for j:=1 to Nmax do
        Dist[i,j]:=0;

    for i:=1 to N do
      for j:=i to N do
        begin
          Dist[i,j]:=abs(X[i]-X[j])+abs(Y[i]-Y[j]);
          Dist[j,i]:=Dist[i,j]
        end;
  end;

Procedure MinDist(x:byte);
  var min,i:byte;
  begin
    min:=2;
    while Visited[min] do Inc(min);
    for i:=min+1 to N do
      if (Dist[x,min]>Dist[x,i])and(not Visited[i]) then
         min:=i;
    Visited[min]:=true;
    index:=min;
    write(index,' ')
  end;

Begin
  readln(N);
  for i:=1 to N do
    readln(X[i],Y[i]);

  for i:=1 to Nmax do
    Visited[i]:=false;

  InitArray(Dist);

  write(1,' ');
  Visited[1]:=true;
  index:=1;
  for i:=1 to N-1 do
    MinDist(index);
End.