#include <stdio.h>
#include <string.h>

const int iMax = 1000;

char chArr[iMax][iMax];
int iXL,iYL;
char chV[iMax][iMax];
int iVisit[iMax][iMax];
int iScanN=1;
int iMaxD=0;

int max(int i1,int i2){
	return i1 > i2 ? i1 : i2;
}

void load(){
	int iX,iY;

	scanf("%d%d\n",&iXL,&iYL);
	for (iY=0;iY<iYL;iY++){
			for (iX=0;iX<iXL;iX++)
					chArr[iX][iY]=getc(stdin);
			getc(stdin);
	}
}

void dfs(int iX,int iY,int iD){
	iVisit[iX][iY]=iScanN;
	iMaxD=max(iMaxD,iD);
	if (iX-1>-1 && iVisit[iX-1][iY]!=iScanN && chArr[iX-1][iY]=='.')
		 dfs(iX-1,iY,iD+1);
	if (iX+1<iXL && iVisit[iX+1][iY]!=iScanN && chArr[iX+1][iY]=='.')
		 dfs(iX+1,iY,iD+1);
	if (iY-1>-1 && iVisit[iX][iY-1]!=iScanN && chArr[iX][iY-1]=='.')
		 dfs(iX,iY-1,iD+1);
	if (iY+1<iYL && iVisit[iX][iY+1]!=iScanN && chArr[iX][iY+1]=='.')
		 dfs(iX,iY+1,iD+1);
}

void findLeafs(int iX,int iY){
	char chLeaf=1;
	chV[iX][iY]=1;
	if (iX-1>-1 && !chV[iX-1][iY] && chArr[iX-1][iY]=='.'){
		 findLeafs(iX-1,iY);
		 chLeaf=0;
	}
	if (iX+1<iXL && !chV[iX+1][iY] && chArr[iX+1][iY]=='.'){
		 findLeafs(iX+1,iY);
		 chLeaf=0;
	}
	if (iY-1>-1 && !chV[iX][iY-1] && chArr[iX][iY-1]=='.'){
		 findLeafs(iX,iY-1);
		 chLeaf=0;
	}
	if (iY+1<iYL && !chV[iX][iY+1] && chArr[iX][iY+1]=='.'){
		 findLeafs(iX,iY+1);
		 chLeaf=0;
	}
	if (chLeaf){
		 iScanN++;
		 dfs(iX,iY,0);
	}
}

void solve(){
	int iX,iY;

	memset(iVisit,0,sizeof(iVisit));
	memset(chV,0,sizeof(chV));
	for (iX=0;iX<iXL;iX++)
			for (iY=0;iY<iYL;iY++)
					if (chArr[iX][iY]=='.'){
						 findLeafs(iX,iY);
						 goto label1;
					}
	label1:;
}

void save(){
	printf("%d\n",iMaxD);
}

int main(){
	load();
	solve();
	save();

	return 0;
}