//chase

#include "iostream.h"
#include "conio.h"
#include "stdio.h"

#define min(a,b) ((a)<(b)?(a) : (b))
#define max(a,b) ((a)>(b)?(a) : (b))
#define MAXVAL 100000
#define MAXSIZE 10000

int bf[100][100];
int M,N,K;
int ds;

long adj[MAXSIZE][MAXSIZE];
int vis[MAXSIZE];
long dist[MAXSIZE];
int coords[50][2];
long mindista[MAXSIZE];

void dijkstra(int s)
{
	int i;
	for(i=0;i<ds;i++)
	{
		vis[i]=0;
		dist[i]=adj[s][i];
	}
	vis[s]=1;
	dist[s]=0;
	long mindist,u;
	while (1)
	{
		mindist=MAXVAL;
		for(i=0;i<ds;i++)
			if(!vis[i]&&mindist>dist[i])
			{
				mindist=dist[i];
				u=i;
			}
		if(mindist==MAXVAL) break;
		vis[u]=1;
		for(i=0;i<ds;i++)
			dist[i]=min(dist[i], dist[u]+adj[u][i]);
	}	
}

void dijkstrag(int s)
{
	int i;
	for(i=0;i<ds;i++)
	{
		vis[i]=0;
		dist[i]=adj[s][i];
		if(dist[i]>mindista[i])
			dist[i]=MAXVAL;
	}
//	vis[s]=1;
	dist[s]=0;
	long mindist,u;
	while (1)
	{
		mindist=MAXVAL;
		for(i=0;i<ds;i++)
			if(!vis[i]&&mindist>dist[i])
			{
				mindist=dist[i];
				u=i;
			}
		if(mindist==MAXVAL) break;
		vis[u]=1;
		if(dist[u]>mindista[u])
			dist[u]=MAXVAL;
		for(i=0;i<ds;i++)
		{
			dist[i]=min(dist[i], dist[u]+adj[u][i]);
	//			dist[i]=MAXVAL;
		}
	}	
}

int gc(int i,int j)
{
	return M*i+j;
}


void trace(int i,int j,int i1,int j1)
{
	adj[gc(i,j)][gc(i1,j1)]=bf[i][j];
	adj[gc(i1,j1)][gc(i,j)]=bf[i1][j1];
}

int main()
{
	int i,j;
	char buf[100];
	//
	cin>>N>>M>>K;
	ds=M*N;
	for(i=0;i<100;i++)
		for(j=0;j<100;j++)
			bf[j][j]=MAXVAL;
	for(i=0;i<N;i++)
	{
		cin>>buf;
		for(j=0;j<M;j++)
		{
			if(buf[j]!='X'&&buf[j]!='x')
				bf[i][j]=int(buf[j])-'0';
		}
	}
	
	int x1,y1;
	cin>>x1>>y1;
	x1--;
	y1--;
	for(i=0;i<K;i++)
	{
		cin>>coords[i][0]>>coords[i][1];
		coords[i][0]--;
		coords[i][1]--;
	}

////////
	for(i=0;i<ds;i++)
	{
		for(j=0;j<ds;j++)
			adj[i][j]=MAXVAL;
	}
	for(i=0;i<N;i+=2)
	{
		for(j=0;j<M;j++)
		{
			if(bf[i][j]!=MAXVAL)
			{
				if(j>1&&bf[i+1][j-1]!=MAXVAL)
					trace(i,j,i+1,j-1);
				if(bf[i+2][j]!=MAXVAL)
					trace(i,j,i+2,j);
				if(bf[i+1][j]!=MAXVAL)
					trace(i,j,i+1,j);
			}
		}
	}
	for(i=1;i<N;i+=2)
	{
		for(j=0;j<M;j++)
		{
			if(bf[i][j]!=MAXVAL)
			{
				if(bf[i+1][j]!=MAXVAL)
					trace(i,j,i+1,j);
				if(bf[i+2][j]!=MAXVAL)
					trace(i,j,i+2,j);
				if(bf[i+1][j+1]!=MAXVAL)
					trace(i,j,i+1,j+1);
			}
		}
	}
/////////
//////////izchislqvame minimalnite rastoqniq za izvynzemnite...
	for(i=0;i<ds;i++)
		mindista[i]=MAXVAL;
	for(i=0;i<K;i++)
	{
		dijkstra(gc(coords[i][1],coords[i][0]));
		for(j=0;j<ds;j++)
			if(dist[j]!=MAXVAL&&dist[j]<=mindista[j])
				mindista[j]=dist[j];
	}
	dijkstrag(gc(y1,x1));
	int maxlast=0;
	for(i=0;i<ds;i++)
	{
		if(dist[i]!=MAXVAL&&mindista[i]>maxlast)
			maxlast=mindista[i];
	}
	cout<<maxlast;
	return 1;
}