Type Sp=^Rec;
     Rec = Record
           Inf:String;
           Next:Sp;
     End;

Var K,S:Sp; N,M:LongInt; T:String;

Procedure Fill(var S1,S2:String);
Var I,L1,L2:Byte;
Begin
     L1:=Length(S1);
     L2:=Length(S2);
     If L1>L2 Then Begin
        For I:=1 To L1-L2 Do
            Insert('0',S2,1);
        L2:=L1;
     End Else Begin
         For I:=1 To L2-L1 Do
             Insert('0',S1,1);
         L1:=L2;
     End;
End;

Function Trim(S:String):String;
Var I:Byte;
Begin
     While S[1]='0' Do
           Delete(S,1,1);
     Trim:=S;
End;

Procedure Inp(var Q:Sp; X:String);
Var R:Sp;
Begin
     New(R);
     R^.Inf:=X;
     R^.Next:=Q;
     Q:=R;
End;

Function CStr(N:LongInt):String;
Var S:String;
Begin
     Str(N,S);
     CStr:=S;
End;

Function CInt(S:String):LongInt;
Var I:Integer; L:LongInt;
Begin
     Val(S,L,I);
     CInt:=L;
End;

Function Sum(S1,S2:String):String;
Var M,L1,L2,I,L,R:Byte; S:String;
Begin
     S:='';
     Fill(S1,S2);
     L1:=Length(S1);
     L2:=Length(S2);
     Insert('0',S1,1);
     Insert('0',S2,1);
     Inc(L1);
     Inc(L2);
     M:=0;
     For I:=L1 DownTo 1 Do Begin
         R:=CInt(S1[I])+CInt(S2[I])+M;
         If R>=10 Then Begin M:=R Div 10; R:=R mod 10; End
         Else M:=0;
         S:=CStr(R)+S
     End;
     Sum:=S;
End;

Function Subst(S1,S2:String):String;
Var L1,L2,I,L:Byte; S:String; M:ShortInt; R:Integer;
Begin
     S:='';
     L1:=Length(S1);
     L2:=Length(S2);
     If L1>L2 Then Begin
        For I:=1 To L1-L2 Do
            Insert('0',S2,1);
        L2:=L1;
     End Else Begin
         For I:=1 To L2-L1 Do
             Insert('0',S1,1);
         L1:=L2;
     End;
     M:=0;
     For I:=L1 DownTo 1 Do Begin
         R:=CInt(S1[I])-CInt(S2[I])+M;
         If R<0 Then Begin M:=-1; R:=10+R; End
         Else M:=0;
         S:=CStr(R)+S
     End;
     Subst:=S;
End;

Procedure Input;
Var X:LongInt; I:LongInt;
Begin
     K:=Nil;
     S:=Nil;
     T:='0';
     Read(M);
     For I:=1 To M Do Begin
         Read(X);
         T:=Trim(Sum(T,CStr(X)));
         Inp(K,CStr(X));
     End;
     Read(N);
     For I:=1 To N Do Begin
         Read(X);
         Inp(S,CStr(X));
     End;
End;

Function FindMin(Q:Sp):Sp;
Var P:Sp;
Begin
     P:=Q;
     Q:=Q^.Next;
     While Q<>Nil Do Begin
           If Cint(P^.Inf)>Cint(Q^.Inf) Then P:=Q;
           Q:=Q^.Next;
     End;
     FindMin:=P;
End;

Procedure Nub;
Var I,Z:String; Q,R:Sp;
Begin
     I:='1';
     If (FindMin(K)^.Inf=I) Or (FindMin(S)^.Inf=I) Then
     Repeat
           Q:=FindMin(K);
           R:=FindMin(S);
           Z:=Trim(Sum(I,'1'));
           If (CInt(R^.Inf)>CInt(Z)) And (CInt(Q^.Inf)>CInt(Z)) Then Break;
           If (CInt(R^.Inf)>CInt(I)) And (CInt(Q^.Inf)>CInt(I)) Then I:=Trim(Sum(I,'1'));
           If R^.Inf=I Then Begin T:=Trim(Subst(T,I)); R^.Inf:='1000001'; End;
           If Q^.Inf=I Then Begin T:=Trim(Subst(T,I)); Q^.Inf:='1000001'; End;
     Until False;
     T:=Trim(Subst(T,'1'));
     Q:=K;
     While Q<>Nil Do Begin
           Fill(Q^.Inf,T);
           If Q^.Inf=T Then Begin T:='0'; Break; End;
           Q:=Q^.Next;
     End;
End;

BEGIN
     Input;
     Nub;
     If T='0' Then Writeln(T)
     Else Writeln(Trim(T));
END.