/* Haralambi Haralambiev / A / Bourgas / chase */
#include <stdio.h>
#include <string.h>

const int maxn = 101;
const int ch1 = 48;
const int infinity = 1023456789;

int cost[maxn*maxn];
int n,m,k;
int me;
int alien[maxn];
int nei[maxn*maxn][7];
char unvis[maxn*maxn];
int d[maxn*maxn][2];
int ans;

/*************/
void input()
{
  memset(unvis, 0x01, sizeof(unvis));

  char ch;
  int i,j,tmp;

  scanf("%d%d%d%c",&n,&m,&k,&ch);
  for(i=1; i<=n; i++) {
    for(j=1; j<=m; j++) {
      tmp=(i-1)*m+j;
      scanf("%c",&ch);
      if(ch=='X') {
        cost[tmp]=-1;
        unvis[tmp]=0;
      }
      else cost[tmp]=ch-ch1;
    }
    scanf("%c",&ch);
  }

  int x,y;
  scanf("%d%d",&x,&y);
  me=(x-1)*m+y;

  for(i=1; i<=k; i++) {
    scanf("%d%d",&x,&y);
    alien[i]=(x-1)*m+y;
  }
}
/*************/
void makedist(int x,int y)
{
  int i,j,k,min;

  k=x; d[k][y]=0;
  while (k!=-1) {
    unvis[k]=0;
    
    for(i=1; i<=nei[k][0]; i++) {
      if ((unvis[nei[k][i]]) && (d[k][y]+cost[k] < d[nei[k][i]][y]))
        d[nei[k][i]][y]=d[k][y]+cost[k];
    }

    i=-1;min=infinity;
    for(j=1; j<=n*m; j++) {
      if ((unvis[j]) && (d[j][y]<min)) {
        i=j;
        min=d[j][y];
      }
    }
    k=i;
  }

}
/*************/
void go()
{
  int i,j,x,y;

  /**********************/
  /* BUILDING THE GRAPH */
  /**********************/
  for(i=1; i<=n; i++)
    for(j=1; j<=n; j++) {
      x=(i-1)*m+j;

      /* up */
      if(i>2) {
        nei[x][0]++;
        nei[x][nei[x][0]]=(i-3)*m+j;
      }
      /* down */
      if(i<n-1) {
        nei[x][0]++;
        nei[x][nei[x][0]]=(i+1)*m+j;
      }
      /* upleft */
      if (! ( ((i%2) && (j==1)) || (i==1))) {
        if (i%2) {
          nei[x][0]++;
          nei[x][nei[x][0]]=(i-2)*m+j-1;
        }
        else {
          nei[x][0]++;
          nei[x][nei[x][0]]=(i-2)*m+j;
        }
      }
      /* downleft */
      if (! ( ((i%2) && (j==1)) || (i==n))) {
        if (i%2) {
          nei[x][0]++;
          nei[x][nei[x][0]]=i*m+j-1;
        }
        else {
          nei[x][0]++;
          nei[x][nei[x][0]]=i*m+j;
        }
      }
      /* upright */
      if (! ( ((i%2==0) && (j==m)) || (i==1))) {
        if (i%2) {
          nei[x][0]++;
          nei[x][nei[x][0]]=(i-2)*m+j;
        }
        else {
          nei[x][0]++;
          nei[x][nei[x][0]]=(i-2)*m+j+1;
        }
      }
      /* downright */
      if (! ( ((i%2==0) && (j==m)) || (i==n))) {
        if (i%2) {
          nei[x][0]++;
          nei[x][nei[x][0]]=i*m+j;
        }
        else {
          nei[x][0]++;
          nei[x][nei[x][0]]=i*m+j+1;
        }
      }

    }

  /**********************/
  /* FINDING THE ANSWER */
  /**********************/

  for (i=1; i<=n*m; i++) {
    d[i][0]=infinity;
    d[i][1]=infinity;
  }

  makedist(me,0);
  for(i=1; i<=k; i++) {
    memset(unvis, 0x01, sizeof(unvis));
    for(j=1; j<=m*n; j++)
      if(cost[j]==-1) unvis[j]=0;
    makedist(alien[i],1);
  }
  ans=0;

  for(i=1; i<=n*m; i++) {
    j=d[i][1]-d[i][0];
    if ((j>0) && (ans<d[i][1]))
      ans=d[i][1];
  }
}
/*************/
void output()
{
  printf("%d\n",ans);

}
/*************/
int main()
{
  input();
  go();
  output();

  return 0;
}
