#include <stdio.h>

#define MAX             33000
#define NOTDEF          -1

int n;
int m[MAX];
int rem[MAX];
int tree[3*MAX];
int niva;
int stdv;
int begin,end;


void Insert(int pos,int val)
{
  int ind;

  ind = stdv+pos-1;

  while(ind>0)
  {
    tree[ind] += val;
    tree[ind] %= n;
    ind /= 2;
  }
}

int Check(int pos)
{
  int i;
  int ind;
  int stoj;
  int tmp;

  if(pos==n)
    return tree[1];

  ind = 1;
  tmp = stdv;
  stoj = 0;

  for(i=1;i<=niva;i++)
  {
    if(pos & tmp)
    {
      stoj += tree[ind];
      stoj %= n;
      ind++;
      ind *= 2;
    }
    else
    {
      ind *= 2;
    }

    tmp /= 2;
  }

  return stoj;

}


int main()
{
  int i;
  int tmp;
  int res;
  int sum;
  int small;

  scanf("%d",&n);

  for(i=0;i<n;i++)
  {
    scanf("%d",&m[i]);
  }

  stdv = 1;
  niva = 1;
  
  while(stdv<n)
  {
    stdv *= 2;
    niva++;
  }

  for(i=0;i<n;i++)
  {
    Insert(i+1,m[i]);
  }

  for(i=0;i<MAX;i++)
    rem[i] = NOTDEF;


  sum = 0;
  small = 0;
  begin = NOTDEF;

  while(sum<n)
  {
    sum += m[small];
    small++;
  }

  small--;

  for(i=0;i<small;i++)
  {
    res = Check(i+1);
    res %= n;
    if(rem[res]==NOTDEF)
      rem[res] = i;
  }

  for(i=small;i<n;i++)
  {
    res = Check(i+1);
    res %= n;
    if(res==0)
    {
      begin = 0;
      end = i;
      break;
    }
    
    if(rem[res]==NOTDEF)
      rem[res] = i;
    else
    {
      begin = rem[res]+1;
      end = i;
      break;
    }
  }

  if(begin!=NOTDEF)
  {

    printf("%d ",end-begin+1);

    for(i=begin;i<end;i++)
      printf("%d ",m[i]);

    printf("%d\n",m[end]);
  }
  else
    printf("-1\n");


  return 0;
}





