#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define MAXN 1<<15

int nums[MAXN];
int osts[MAXN];
int list[MAXN];
int l_br = 0;
int back[MAXN][2];
int n;
int TIMELIMIT = 0.45*CLOCKS_PER_SEC;

int cmp(const void *a,const void *b)
{
	return *((int*)a) - *((int*)b);
}

void Init()
{
	int i;
	memset(nums,0,sizeof(nums));
//	freopen("div.in","rt",stdin);
	scanf("%d",&n);
	for (i = 0;i < n;i++)
		scanf("%d",&nums[i]);
}

void OutputNo()
{
	printf("-1\n");
	exit(0);
}

void Output(int ost)
{
	int out_l[MAXN],m = 0;
	int i;
	while (ost != -1)
	{
		out_l[m++] = back[ost][0];
		ost = back[ost][1];
	}
	printf("%d",m);
	for (i = 0;i < m;i++)
		printf(" %d",out_l[i]);
	printf("\n");
	exit(0);
}

void Output2(int ost)
{
	int out_l[MAXN],m = 0;
	int i;
	int *ptr;
	while (ost != -1)
	{
		out_l[m++] = back[ost][0];
		ost = back[ost][1];
	}
	qsort(out_l,m,sizeof(out_l[0]),cmp);

	printf("%d",n - m);
	for (i = 0;i < n;i++)
	{
		ptr = (int*)bsearch(&nums[i],out_l,m,sizeof(out_l[0]),cmp);
		if (ptr)
		{
			*ptr = 0;
			qsort(out_l,m,sizeof(out_l[0]),cmp);
		}
		else printf(" %d",nums[i]);
	}
	printf("\n");
	exit(0);
}

void AddOst(int num)
{
	int i;
	int tmp;
	int n_br = l_br;
	for (i = 0;i < l_br;i++)
	{
		tmp = (list[i] % n + num % n) % n;
		if (!osts[tmp])
		{
			osts[tmp] = 1;
			back[tmp][0] = num;
			back[tmp][1] = list[i] % n;
			list[n_br++] = tmp;
		}
	}
	l_br = n_br;
}

void Solve()
{
	int i;
	int sum = 0;
	for (i = 0;i < n;i++)
		sum = (sum + (nums[i] % n)) % n;
	if (sum == 0)
	{
		printf("%d",n);
		for (i = 0;i < n;i++)
			printf(" %d",nums[i]);
		printf("\n");
		exit(0);
	}
	for (i = 0;i < n;i++)
	{
		if (clock() > TIMELIMIT) OutputNo();
		AddOst(nums[i]);
		if (!osts[nums[i] % n])
		{
			osts[nums[i] % n] = 1;
			list[l_br++] = nums[i] % n;
			back[nums[i] % n][0] = nums[i];
			back[nums[i] % n][1] = -1;
		}
		if (osts[0] == 1) Output(0);
		if (osts[sum] == 1) Output2(sum);
	}
}

int main()
{
	clock();
	Init();
	Solve();
	OutputNo();
	return 0;
}
