#include <stdio.h>

#define MAX			100010
#define MAX_CACHE	1000000
#define MAX_NUM		1100000

long		m,n,mas[MAX];
long		next[MAX];
__int64		res,sum[MAX],oursum;

char		cache[MAX_CACHE];

long bins(long x)
{
	long l=0,r=n-1,mid;

	while(l<=r)
	{
		mid=(l+r)>>1;
		if(mas[mid]<x) l=mid+1;
		else
			if(mas[mid]>x) r=mid-1;
			else
				return mid;
		
	}
	return next[r];
}

char possible(long num,long last)
{
	long i,end;

	if(num<0)
		return 0;

	if(num==0)
		return 1;

	if(num<MAX_CACHE&&cache[num])
		return 0;

	if(num<MAX_NUM)
		end=bins(num);
	else
		end=n-1;

	if(end>last) end=last;

	for(i=end;i>=0&&sum[i]>=num;i--)
		if(possible(num-mas[i], i-1))
			return 1;

	if(num<MAX_CACHE)
		cache[num]=1;

	return 0;
}

long	tmp;
void qsort(long l, long r,long *mas)
{
	long i=l,j=r,mid=mas[(l+r)>>1];

	do
	{
		while(mid>mas[i]) i++;
		while(mid<mas[j]) j--;

		if(i<=j)
		{
			tmp=mas[i];
			mas[i]=mas[j];
			mas[j]=tmp;
			i++;
			j--;
		}
	}while(i<=j);

	if(l<j) qsort(l,j,mas);
	if(i<r) qsort(i,r,mas);
}

void main()
{
	long	i,cur;

	scanf("%ld",&m);

	for(i=0;i<m;i++)
	{
		scanf("%ld",&cur);
		oursum+=cur;
	}

	scanf("%ld",&n);

	for(i=0;i<n;i++)
	{
		scanf("%ld",&cur);
		mas[i]=cur;
	}

	qsort(0,n-1,mas);

	next[n-1]=n-1;
	for(i=n-2;i>=0;i--)
		if(mas[i]==mas[i+1])
			next[i]=next[i+1];
		else
			next[i]=i;

	sum[0]=mas[0];
	for(i=1;i<n;i++)
		sum[i]=sum[i-1]+mas[i];

	for(i=1;;i++)
		if(!possible(i,n-1))
		{
			res=oursum-i;
			break;
		}


	printf("%hd\n",res);
}
