/*
TASK:BIGNUM
LANG:C++
*/
#include <cstdio>
#include <iostream>
#include <map>
#include <algorithm>
#define fst first
#define snd second
using namespace std;

const int BASE1 = 47;
const int BASE2 = 29;
const int MOD1 = 45631;
const int MOD2 = 654323;
map < pair<int, int>, int > A;
int i, j, q, k, L, p1[50], p2[50];
int st[100], br, d[100], sst[100], br2;
int ans[(1 << 15)];
int GL;
void solve () {
     pair<int, int> H, h, sH;
     H.fst = 0; H.snd = 0;
     for (i = 1; i <= k; i++) {
         ans[++L] = q;
         H.fst += (p1[i-1] * ans[i]) % MOD1;
         H.snd += (p2[i-1] * ans[i]) % MOD2;
         printf ("init first %d chars: %d %d\n", i, H.fst, H.snd);
         A[H]++;
     }
     bool flag = 1;
     int len, cnt, w, curcnt, qq=1;

     while (flag) {
           H.fst = 0; H.snd = 0;
           for (i = L, j = 0; i >= L - k + 2; i--, j++) {
               //add first k - 1 digits
               H.fst += (p1[j] * ans[i]);// opt.
               H.fst %= MOD1;
               H.snd += (p2[j] * ans[i]);// opt.
               H.snd %= MOD2;
               if (qq<4)printf ("hash first k-1 digits: %d %d\n", H.fst, H.snd), qq++;
           }
           sH = H;
           br = 0;
           len = k - 1;
           for (i = q; i >= 0; i--) st[++br] = i;
           while (len > 1 && br) {
                 //printf ("len = %d br = %d\n", len, br);
                 w = 0;
                 cnt = 999;
                 for (i = 1; i <= br; i++) {
                     h = H;
                     //add new digit
                     h.fst = (h.fst * BASE1 + st[i]) % MOD1;// opt.
                     h.snd = (h.snd * BASE2 + st[i]) % MOD2;// opt.
                     if(qq<5)printf ("H(%d %d)  %d %d\n", H.fst, H.snd, h.fst, h.snd), qq++;
                     curcnt = A[h];
                     if (d[i] > 0 && len == k - 1) d[i] = -1;
                     else d[i] = curcnt;
                     //
                     if (curcnt < cnt) cnt = curcnt, w = st[i];
                     GL++;
                     //if (GL>1000)return;
                 }
                 //reduce len
                 H.fst %= p1[len-1];
                 H.snd %= p2[len-1];
                 len--;
                 //refresh st
                 for (i = 1; i <= br; i++)
                     if (d[i] == cnt) sst[++br2] = st[i];
                 for (i = 1, br = br2; i <= br2; i++) st[i] = sst[i];
           }
           //add letter
           if (br == 0) printf ("end\n"), flag = 0;
           else {
                ans[++L] = st[1];
                sH.fst = 0; sH.snd = 0;
                for (i = 1; i <= k; i++) {
                    sH.fst += (p1[i-1] * ans[L-i+1]) % MOD1;// opt.
                    sH.snd += (p2[i-1] * ans[L-i+1]) % MOD2;// opt.
                    A[sH]++;
                }
           }
     }
     for (i = 1; i <= L; i++) printf ("%d", ans[i]);
     printf ("\n");
}

int main () {
    freopen ("a3.inp", "rt", stdin);
    p1[0] = 1; p2[0] = 1; for (i = 1; i <= 20; i++) {
          p1[i] = (p1[i-1] * BASE1) % MOD1;
          p2[i] = (p2[i-1] * BASE2) % MOD2;
    }
    //scanf ("%d %d", &q, &k);
    q = 2; k = 3;
    q--;
    solve ();
    return 0;
}

