/*
TASK: distance
LANG: C++
*/

#include <iostream>
#include <stdlib.h>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <stack>
#include <complex>
#include <algorithm>
#include <functional>
#include <cctype>
#include <math.h>
#include <bitset>
using namespace std;

typedef pair<unsigned int, unsigned int> pii;

#define f(i, n) for(register int i = 0; i < n; i ++)
#define sqr(a) ((a) * (a))
#define used first
#define sum second
#define wait system("pause")

#define MAX_N (1 << 5)
//#define MAX_Q (1 << 22)


int N;
unsigned int pos[MAX_N][2];
unsigned int a[MAX_N][MAX_N];
//bool used[MAX_Q];
set<unsigned int> used;
unsigned int best, end;
queue<pii> q;


inline void BFS()
{
register int size = 1;
register pii now, next;
	
	
	q.push(pii(0, 0));
	
	while(!q.empty())
	{
		now = q.front(); q.pop();
		
/*
		cout<< bitset<32>(now.used) <<"\n";
		cout<< now.sum <<"\n";
		wait;
*/
		
		if(now.used == end) best >?= now.sum;
		
		f(i, N) if(!(now.used & (1 << i))) f(j, N) if((j != i) && !(now.used & (1 << j)))
		{
			next = now;
			
			next.used |= (1 << i);
			next.used |= (1 << j);
			
			if(used.find(next.used) == used.end())
			{
				next.sum += a[i][j];
				
				q.push(next);
				
				if(next.used != end) used.insert(next.used);
			}
		}
	}
}

int main()
{
    scanf("%d", &N);
    
    f(i, N) scanf("%ld %ld", &pos[i][0], &pos[i][1]);
    
    f(i, N) f(j, N) a[i][j] = sqr(pos[i][0] - pos[j][0]) + sqr(pos[i][1] - pos[j][1]);
    
    end = (1 << N) - 1;
    
//    cout<< bitset<32>(end) <<"\n"; wait;
    
/*
    f(i, N)
    {
         f(j, N) cout<< a[i][j] <<"  ";
         cout<<"\n";
    }
*/
    
    
    BFS();
    
    
    
    printf("%ld.000\n", best);
    
//    wait;
    
    return 0;
}
/*
4
1 1
9 2
10 7
2 6
*/
