/*
TASK: bignum
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>

#define HSIZE 52428165

int q,k;
char sol[21000];
int br, hah=1;
char hash[HSIZE];

void solve(int p)
{
     if (p > 20000) return ;
     int i,j,r;
     if (br == hah) {
        for (i=1;i<p;++i) printf("%d",sol[i]);
        printf("\n");
        exit(0);
        }
     for (i=q-1;i>=0;--i) if (p >= k) {
         r = 1;
         for (j=p-k+1;j<p;++j) {r*=q;r+=sol[j];}
         r*=q;r+=i;
         if (hash[r%HSIZE] == 0) {
            hash[r%HSIZE] = 1; ++br;
            sol[p] = i;
            solve(p+1);
            hash[r%HSIZE] = 0; --br;
            }
         }
         else {
              for (i=q-1;i>=0;--i) {
                  sol[p] = i;
                  solve(p+1);
                  }
              } 
}

int main()
{
    int i;
    scanf("%d%d",&q,&k);
    for (i=0;i<k;++i) hah *= q;
    solve(1);
    return 0;
}
