/*
TASK: distance
LANG: C++
*/
// Iordan Boev SMG
# include <stdio.h>
# define MAXP (1<<5)

int long long n;
int long long ans;
struct points {
	int long long x,y;
} pnt[MAXP];
int long long data[MAXP][MAXP];
int long long connect[MAXP];

void read() {
	scanf("%lld", &n);
	for(int i = 1; i <= n; i++) {
		scanf("%lld %lld", &pnt[i].x,&pnt[i].y);	
	}
	for(int i = 1; i < n; i++) {
		for(int j = i+1; j <= n; j++) {
			data[i][j] = (pnt[i].x-pnt[j].x)*(pnt[i].x-pnt[j].x) + (pnt[i].y-pnt[j].y)*(pnt[i].y-pnt[j].y);	
			data[j][i] = data[i][j];
		}
	}
}

void solve() {
	ans = data[1][2];
	connect[1] = 2;
	connect[2] = 1;
	for(int i = 3; i < n; i+=2) {
		int long long current = ans + data[i][i+1]; 
		connect[i] = i+1;
		connect[i+1] = i;
		for(int j = 1; j < i; j++) {
			if(current < current-data[j][connect[j]]-data[i][connect[i]]+data[j][i]+data[connect[j]][connect[i]]) {
				current = current-data[j][connect[j]]-data[i][connect[i]]+data[j][i]+data[connect[j]][connect[i]];
				connect[connect[i]] = connect[j];
				connect[connect[j]] = connect[i];
				connect[j] = i;
				connect[i] = j;
			}
		}
		ans = current;	
	}
	//for(int i = 1; i <= n; i++) printf("%lld ", connect[i]);
	printf("%lld.000\n", ans);		
}

int main() {
	read();	
	solve();
	return 0;
}
