/*
TASK:distance
LANG:C++
*/
#include <cstdio>
#include <ctime>
#include <algorithm>

clock_t start;
int x[32], y[32];
int closest [32][32];

int N;
bool used [32];
bool TERMINATE = 0;
    long long max = 0;
    long long cur = 0;
    
int ind;
    

void solve () {
     if ((clock() - start) > 7900000 || TERMINATE) {
        TERMINATE = true;
        return;
     }
     int i = 0;
     for (;used[i];++i);
     if  (i == N) {
         if (cur > max) max = cur;
         return;
     }
     used[i] = true;
     for (int j = 0; j < N; ++j) {
         if (!used[closest[i][j]]) {
            int mult = (x[i] - x[closest[i][j]]) * (x[i] - x[closest[i][j]]) + 
                       (y[i] - y[closest[i][j]]) * (y[i] - y[closest[i][j]]);
            cur += mult;
            used[closest[i][j]] = true;
            solve();
            used[closest[i][j]] = false;
            cur -= mult;
         }
     }
     used[i] = false;
}

bool cmp (int a, int b) {
     long long dist1 = (x[ind] - x[a]) * (x[ind] - x[a]) + (y[ind] - y[a]) * (y[ind] - y[a]);
     long long dist2 = (x[ind] - x[b]) * (x[ind] - x[b]) + (y[ind] - y[b]) * (y[ind] - y[b]);
     
     return dist1 > dist2;
}

int main () {
    start = clock();
    scanf ("%d", &N);

    for (int i = 0; i < N; ++i)
        scanf ("%d %d", &x[i], &y[i]);
        
    for (ind = 0; ind < N; ++ind) {
        for (int j = 0; j < N; ++j)
            closest[ind][j] = j;
        std::sort (closest[ind], closest[ind] + N, cmp);
    }
            
    solve();
    printf ("%.3lf\n", (double)max);
    return 0;
}
