/*
TASK: distance
LANG: C++
*/

#include <cstdio>
#include <cmath>
using namespace std;

int n;
double dist[24][24];
double nd[24][24];
int used[24];
double maxdist[24];
int s[24];
int seg[24];
int ans[24];
struct stud
{
	int x,y;
}p[24],np[24];

void read()
{
	int l;
	scanf("%d",&n);
	for(int i=1;i<=n;i++) scanf("%d %d",&p[i].x,&p[i].y);
	for(int i=1;i<n;i++)
		for(int j=i+1;j<=n;j++)
		{
			l=(p[i].x-p[j].x)*(p[i].x-p[j].x)+(p[i].y-p[j].y)*(p[i].y-p[j].y);
			dist[i][j]=l;dist[j][i]=l;
		}
}

void srt()
{
	double md;
	int ind1,ind2;
	for(int k=1;k<=n;k+=2)
	{
		md=-1;
		for(int i=1;i<n;i++)
		{
			for(int j=i+1;j<=n;j++)
			{
				if(md<dist[i][j]&&used[i]==0&&used[j]==0) 
				{
					md=dist[i][j];
					ind1=i;
					ind2=j;
				}
			}
		}
		np[k].x=p[ind1].x;
		np[k].y=p[ind1].y;
		np[k+1].x=p[ind2].x;
		np[k+1].y=p[ind2].y;
		used[ind1]=1;used[ind2]=1;
		for(int l=1;l<=n;l++) 
		{
			dist[ind1][l]=0;
			dist[l][ind1]=0;
			dist[ind2][l]=0;
			dist[l][ind2]=0;
		}
	}
	int l;
	for(int i=1;i<n;i++)
		for(int j=i+1;j<=n;j++)
		{
			l=(np[i].x-np[j].x)*(np[i].x-np[j].x)+(np[i].y-np[j].y)*(np[i].y-np[j].y);
			dist[i][j]=l;dist[j][i]=l;
		}
}

void solve()
{
	int fst,snd,flag;
	maxdist[1]=dist[1][2];s[1]=2;s[2]=1;
	for(int i=2;i<=n/2;i++)
	{
		for(int j=1;j<=i*2;j++)
		{
			for(int k=1;k<=i*2;k++)
			{
				for(int l=1;l<=i*2;l++) seg[l]=s[l];
				if(j==k) continue;
				if(k==i*2||j==i*2-1) continue;
				if(j==i*2&&k!=i*2-1) continue;
				if(k==i*2-1&&j!=i*2) continue;
				seg[seg[j]]=0;seg[seg[k]]=0;seg[j]=i*2-1;seg[i*2-1]=j;seg[k]=i*2;seg[i*2]=k;
				flag=0;fst=0;snd=0;
				for(int l=1;l<=i*2;l++)
				{
					if(seg[l]==0)
					{
						if(flag==1) {snd=l;}
						else {fst=l;flag=1;}
					}
				}
				if(flag!=0) seg[fst]=snd;seg[snd]=fst;
				double dis=0;
				for(int l=1;l<=2*i;l++)
				{
					dis+=dist[l][seg[l]];
				}
				if(dis>maxdist[i])
				{
					for(int l=1;l<=2*i;l++) ans[l]=seg[l];
					maxdist[i]=dis;
				}
			}
		}
/*		printf("\n");
		for(int l=1;l<=2*i;l++)
		{
			printf("%d %d %lf\n",l,ans[l],dist[l][ans[l]]);
		}
		printf("\n");*/
		for(int l=1;l<=i*2;l++) s[l]=ans[l];
	}
}

int main()
{
	read();
	srt();
	solve();
	printf("%.3lf\n",maxdist[n/2]/2);
	return 0;
}
