/*
TASK:distance
LANG:C++
*/
#include <cstdio>

typedef struct _point
{
	int x;
	int y;
}point;
point Students[32];
int N;
int mas[32][32],avail[32][32];
int Res=0;

void Read();
int Solve(int ind,int hope);
int DistSqr(point a,point b);

int main()
{
	Read();

	int maxres=-1;

	for(int k=0;k<N;k++)
	{
		Res=0;
		for(int y=0;y<N;y++)
			for(int x=0;x<N;x++)
				avail[y][x]=1;
		for(int i=0;i<N;i++)
			if(avail[i][i])
				Solve(i,-1);
		maxres=maxres>Res?maxres:Res;
	}

	double r=maxres;
	printf("%.3f\n",r);

	return 0;
}

void Read()
{
	scanf("%d",&N);
	int i,j;
	for(i=0;i<N;i++)
		scanf("%d%d",&Students[i].x,&Students[i].y);

	for(i=0;i<N;i++)
		for(j=0;j<N;j++)
		{
			mas[i][j]=DistSqr(Students[i],Students[j]);
			avail[i][j]=1;
		}
}

int DistSqr(point a,point b)
{
	return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}

int FindMax(int ind)
{
	int i;
	int max=-1,maxind=-1;

	for(i=0;i<N;i++)
		if(mas[ind][i]>max && avail[i][i] && avail[ind][i] && ind!=i)
		{
			max=mas[ind][i];
			maxind=i;
		}

	return maxind;
}

int Solve(int ind,int hope)
{
	int flag=1;

	while(flag)
	{
		int maxind=FindMax(ind);
		if(maxind==hope) return maxind;
		if(Solve(maxind,ind)==ind)
		{
			avail[ind][maxind]=avail[maxind][ind]=avail[ind][ind]=avail[maxind][maxind]=0;
//			printf("%d --> %d\n",ind,maxind);
			Res+=mas[ind][maxind];
			return maxind;
		}
		avail[ind][maxind]=avail[maxind][ind]=0;
	}

	return 0;
}