/*
TASK:porters
LANG:C++
*/

#include <cstdio>


int Q_T[1000000],Q_X[1000000],Q_Y[1000000];
int D_T[1000000],D_X[1000000],D_V[1000000];

int Shafts[150000];
int N,K;
int num_q=0,num_d=0;

void Read();
void Solve();

int main()
{
	Read();
	Solve();

	return 0;
}

void Read()
{
	scanf("%d%d",&N,&K);
	int i;
	for(i=0;i<N-1;i++)
		scanf("%d",Shafts+i+2);

	char s[16];

	for(i=0;i<K;i++)
	{
		scanf("%s",s);
		if(s[0]=='k')	//query
		{
			scanf("%d%d%d",Q_T+num_q,Q_X+num_q,Q_Y+num_q);
			num_q++;
		}
		else			//drain
		{
			scanf("%d%d%d",D_T+num_d,D_X+num_d,D_V+num_d);
			num_d++;
		}
	}
}

void Solve()
{
	int i,j,drainpos=0;
	int states[150000];

	int fill,pos,MaxVolume,dest;

	for(i=1;i<=N;i++) states[i]=0;

	int prevtime=0,time;

	for(i=0;i<num_q;i++)
	{
		time=Q_T[i];
		fill=(time-prevtime)*10;
		for(j=1;j<=N;j++) states[j]+=fill;

		while(time>=D_T[drainpos] && drainpos < num_d)
		{
			states[D_X[drainpos]]-=D_V[drainpos];
			drainpos++;
		}

		pos=Q_X[i];
		dest=Q_Y[i];
		MaxVolume=states[pos];

		while(pos!=dest)
		{
			pos=Shafts[pos];
			MaxVolume=MaxVolume<states[pos]?MaxVolume:states[pos];
		}

		printf("%d\n",MaxVolume);

		prevtime=time;
	}
}
