/*
TASK:distance
LANG:C++
*/

#include <cstdio>
#include <cstdlib>

#define MAX_N 22

struct STUDENT
{
	int x;
	int y;
};

int n;
int count;
unsigned long long max;
unsigned long long cur;
int used[MAX_N];
int a[6];
STUDENT students[MAX_N];

int dist(STUDENT s1, STUDENT s2)
{
	return (s1.x - s2.x) * (s1.x - s2.x) + (s1.y - s2.y) * (s1.y - s2.y);
}
/*
void calc(int k)
{
	if (cur > max)
		max = cur;
	
	if (k == ogr)
		return;
	//if (used[k])
	//	calc(k + 1);
	
	int i;
	int tmp_dist;
	//printf("%d\n", k);
	for (i = 0; i < n; i++)
	{
		if (!used[i] && i != k)
		{
			tmp_dist = dist(students[k], students[i]);
			
			used[i] = 1;
			used[k] = 1;
			cur += tmp_dist;
			
			printf("%d %d\n", k + 1, i + 1);
			calc(k + 1);
			
			cur -= tmp_dist;
			used[i] = 0;
			used[k] = 0;
		}
	}
}
*/
int temp = 2;
int bla = 6;
void print(void)
{
	for (int i = 0; i < temp; i++)
		printf("%d ", a[i] + 1);
	printf("\n");
}

void calc(int k)
{
	if (cur > max)
		max = cur;
	
	count++;
	if (count == n * (n - 1) / 2 + 1)
	{
		printf("%.3f\n", (double)max);
		exit(0);
	}
	
	int i;
	int j;
	int tmp_dist;
	
	for (i = k; i < n; i++)
	{
		for (j = i + 1; j < n; j++)
		{
			if (!used[i] && !used[j])
			{
				tmp_dist = dist(students[i], students[j]);
				//printf("%d %d\n", i + 1, j + 1);
				used[i] = 1;
				used[j] = 1;
				cur += tmp_dist;
				
				calc(i + 1);
				
				cur -= tmp_dist;
				used[i] = 0;
				used[j] = 0;
			}
		}
	}
}

void init(void)
{
	int i;
	
	scanf("%d", &n);
	
	for (i = 0; i < n; i++)
	{
		scanf("%d", &students[i].x);
		scanf("%d", &students[i].y);
	}
}

void solve(void)
{
	//ogr = n * (n + 1) / 2;
	calc(0);
	
	printf("%.3f\n", (double)max);
}

int main(void)
{
	init();
	solve();
	
    return 0;
}
