/*
TASK:porters
LANG:C++
*/

// solution with index tree

#include <cstdio>
#include <cstring>

#define MAX_N 262144 // 2 ^ 18

struct NODE
{
	int y;
	int v;
};

int n;
int k;
NODE tree[MAX_N]; // tree

void add_edge(int x, int y)
{
	tree[x].y = y;
}

void add(int x, int v)
{
	tree[x].v += v;
}

void search(int t, int x, int y)
{
	int max = 0;
	
	while (x != y)
	{
		if (max < tree[x].v)
			max = tree[x].v;
		x = tree[x].y;
	}
	if (max < tree[x].v)
		max = tree[x].v;
	
	//printf("%d %d %d\n", x, y, max);
	
	printf("%d\n", t * 10 - max);
}

void solve(void)
{
	int i;
	int t;
	int x; int y;
	
	char tmp[10];
	
	scanf("%d", &n);
	scanf("%d", &k);
	
	for (i = 0; i < n - 1; i++)
	{
		scanf("%d", &x);
		add_edge(i + 1, x - 1);
	}
	
	for (i = 0; i < k; i++)
	{
		scanf("%s", &tmp);
		scanf("%d", &t);
		scanf("%d", &x);
		scanf("%d", &y);
		if (strcmp(tmp, "k4i") == 0)
			search(t, x - 1, y - 1);
		else
			add(x - 1, y);
	}
}

int main(void)
{
	solve();
	
    return 0;
}
