/*
TASK: porters
LANG: C++
*/

#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX_N = 150000+5;
const int INF   = 1000000000;

int n, k;
int prev[MAX_N];

int A[MAX_N];

int k4i (int t, int x, int y)
{
	int i, res=INF;

	for (i=x; ; i=prev[i]) {
		res = min(res,t*10-A[i]);
		if (i==y) break;
	}

	return res;
}

int main ()
{
	//freopen ("porters.in", "r", stdin);

	int i, t, x, y;
	char s[15];

	scanf ("%d%d", &n, &k);

	for (i=2; i<=n; i++)
		scanf ("%d", &prev[i]);

	for (i=0; i<k; i++) {
		scanf ("%s", s);
		
		if (s[0]=='k') {
			scanf ("%d%d%d", &t, &x, &y);
			printf ("%d\n", k4i (t,x,y));
		} else {
			scanf ("%d%d%d", &t, &x, &y);
			A[x] += y;
		}
	}

	return 0;
}