/*
TASK:distance
LANG:C++
*/
#include<iostream>
#include<cmath>
#include<time.h>
#include<vector>
#include<cstdio>
using namespace std;
struct point
{ double x;double y;};
double dists[32][32];
int n;
vector <point> p;
double dist(point a,point b)
{ return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);}
int used[24];double res=0;double mres=0;
void solve(int v,int k)
{ int i;int j;
  res+=dists[v][k-1];
  //cout<<res<<endl;
  used[v]=1;
  used[k-1]=1;
  for(i=0;i<n;i++)
  {
	double max=0;int v=0;
	if(!used[i])
	  {
		for(j=n-1;j>=0;j--)
			if(!used[j]&&i!=j)
            if(max<dists[i][j])
				{ max=dists[i][j];
				  v=j;
				}
        used[i]=1;
	    used[v]=1;
	    //cout<<CLOCKS_PER_SEC<endl;
		res+=max;
		//cout<<i<<' '<<v<<' '<<res<<endl;
	  }

  }
}
   
int main()
{ cin>>n;
  int i,j;
  for(i=0;i<n;i++) {
	  point temp;
	  cin>>temp.x>>temp.y;
	  p.push_back(temp);
  }
   
  for(i=0;i<n;i++)
	  for(j=0;j<n;j++)
		  dists[i][j]=dist(p[i],p[j]);
  for(i=0;i<n;i++)
     sort(dists[i],dists[i]+n);
  for(i=0;i<n;i++)
   { for(j=n-1;j>=0;j--)
      { solve(i,j);
        //cout<<res<<endl;
        if(res>mres)
          mres=res;
        res=0;
        for(i=0;i<n;i++)
            used[i]=0;
      }
    }
   printf("%0.3lf\n",mres);   
  return 0;
}
	  
