{
TASK:distance
LANG:PASCAL
}

const MaxN = 22;

type
  Vryh = record
    x: LongInt;
    y: LongInt;
  end;

var
  N: Integer;
  Node: array[1..MaxN] of Vryh;
  vis: array[1..MaxN] of Boolean;
  Sum: Int64;
  i, j: Integer;

procedure ReadInput;

begin
  readln(N);
  for i:= 1 to N do
    readln(Node[i].x, Node[i].y);

  for i:= 1 to N do
    vis[i]:= false;
  Sum:= 0;
end;

procedure Solve;
var
  Dist: Int64;
  MaxD: Int64;
  w, br: Integer;

begin
  br:= 0;
  for i:= 1 to n-1 do
  begin
    if not vis[i] then
    begin
      MaxD:= 0;
      for j:= i+1 to n do
        if not vis[j] then
          begin
            Dist:= sqr(Node[i].x - Node[j].x) + sqr(Node[i].y - Node[j].y);
            if Dist > MaxD then
            begin
              MaxD:= Dist;
              w:= j;
            end;
          end;
    end;
    if br < n then
    begin
      vis[i]:= true;
      vis[w]:= true;
      br:= br + 2;
      Sum:= Sum + MaxD;
    end;
  end;
end;

procedure WriteOutput;

begin
  writeln(Sum,'.000');
end;

begin
  ReadInput;
  Solve;
  WriteOutput;
end.