/*
TASK:PERM
LANG:C++
*/

#include <cstdio>
#include <cstdlib>

#define MAX 16384

int n, temp[MAX], p[MAX], A[MAX], B[MAX], C[MAX], D[MAX];
int i, j, findo, cur;

bool solve(int *p){
	i = p[1];
	for(j = 1; j < n; j++){
		temp[j + 1] = i;
		if(i == 0 || i == 1) return false;
		i = p[i];
	}
	return true;
}

void printa(int *t){
	for(int i = 1; i < n; i++)
		printf("%d ", t[i]);  
	printf("%d\n", t[n]);   
}

void input() {
	temp[1] = 1;
	scanf("%d", &n);
	for(i = 1; i <= n; i++){
		scanf("%d", &p[i]);
	}
}

void tcur() {
	if(solve(p)) {
		printf("1\n");
		printa(temp);
		exit(0);
	}
}

void tcur2() {
	if(solve(C)) {
		printf("2\n");
		printa(A);
		printa(temp);  
		exit(0);            
	} 
}

void tcur3() {
	if(solve(C)) {
		printf("2\n");
		printa(A);
		printa(temp);   
		exit(0);
	}
}

int main() {
	input();

	tcur();

	i = 1;

	while(p[i] != 1)  {
		i++;
	}

	findo = i;

	for(j = 1; j <= n; j++){
		A[j] = p[i];
		i++;
		if(i > n) i = 1;      
	}

	i = 1;

	while(i < n){
		B[A[i]] = A[i + 1];
		i++;
	}

	B[A[n]] = 1;

	for(i = 1; i <= n; i++) {
		D[B[i]] = i;
	}

	for(i = 1; i <= n; i++) {
		C[i] = D[p[i]];
	}

	tcur2();

	i = findo;

	for(j = 1; j <= n; j++) {
		A[j] = p[i];
		i--;
		if(i == 0) i = n;      
	}

	i = 1;

	while(i < n) {
		B[A[i]] = A[i + 1];
		i++;
	}

	B[A[n]] = 1;

	for(i = 1; i <= n; i++) {
		D[B[i]] = i;
	}

	for(i = 1; i <= n; i++) {
		C[i] = D[p[i]];
	}

	tcur3();

	printf("0\n");

	return 0;
}
