/*
TASK:jumps
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
using namespace std;
typedef struct
{
 long x;
 long y;
} Point;
Point db[1000001];
int cmp(const void *a,const void*b)
{
 const Point*p=(Point*)a;
 const Point*q=(Point*)b;
 if(p->y>q->y)return 1;
 if(p->y<q->y)return -1;
 if(p->x>q->x)return 1;
 if(p->x<q->x)return -1;
 return 0;
}
int equal(const Point*a,const Point*b)
{
 if(a->x==b->x && a->y==b->y)return 1;
 return 0;
}

int solve(long start,long n)
{
 long i=start+0,cnt=1;
 for(;i<n;i++)
  if(!equal(&db[i],&db[i-1]))
	 if(db[i].x >= db[i-1].x && db[i].y >=db[i-1].y)
		cnt++;
	 else
		return cnt;
 return cnt;
}

int main()
{
 long n,i,thebest=0,th;
 scanf("%d",&n);
 for(i=0;i<n;i++)
    scanf("%d %d",&db[i].x,&db[i].y);
 qsort(db,n,sizeof(Point),cmp);
 if(n<25001)
  for(i=0;i<n-1;i++)
  {
	 th=solve(i,n);
	 if(th>thebest)
		thebest=th;
  }
 else
     thebest = solve(0,n);
  printf("%d\n",thebest);
 return 0;
}
