/*
TASK:jumps
LANG:C++
*/

#include <iostream>
#include <cstdio>
using namespace std;

const int MAXN = 1000000;

int n;

struct point {
 int x,y;
 point() { }
 point(int a, int b) { x=a; y=b; }
 bool operator < (const point &c) const
 {
  if (x<c.x) return true;
  if (x==c.x && y<c.y) return true;
  return false;
 }
};

int work[MAXN];
point mas[MAXN],norm[MAXN];

int main()
{
 scanf("%d",&n);
 for (int i=0;i<n;i++)
  scanf("%d %d",&mas[i].x,&mas[i].y);
  
 sort(mas,mas+n); 
 
 int r=0;
 point first=mas[0]; norm[r]=first;
 
 for (int i=1;i<n;i++)
 {
  if (mas[i].x==norm[r].x && mas[i].y==norm[r].y) continue;
  norm[++r]=mas[i];
 }
 
 int k=1; work[k]=norm[0].y;
 
 for (int i=1;i<=r;i++)
 {
  if (norm[i].y>=work[k]) { work[++k]=norm[i].y; continue; } else
  *upper_bound(work+1,work+k+1,norm[i].y)=norm[i].y; 
  /*for (int j=1;j<=k;j++) cout<<work[j]<<" ";
  cout<<endl;*/
 }
 
 printf("%d\n",k);
 
 //system("pause"); //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 return 0;
}
