/*
TASK: table
LANG: C++
*/

#include <iostream>

#define f(i, n)					for(int i = 0; i < n; i ++)

const int MOD = 333333;
const int MAX_N = 50;

int X, Y, in[MAX_N][MAX_N], a[MAX_N][MAX_N], t[MAX_N][MAX_N], ans;

void Read()
{
	scanf("%d %d", &X, &Y);
	
	f(i, X) f(j, Y) scanf("%d", &in[i][j]);
}

inline int sum(const int x, const int y)
{
int ret = 0;
	
	if(0 <= x - 1) ret += a[x - 1][y];
	if(0 <= y - 1) ret += a[x][y - 1];
	if(y + 1 < Y) ret += a[x][y + 1];
	
	return ret;
}

void rec(int x)
{
	if(x == X)
	{
		f(y, Y)
		{
			int s = sum(x - 1, y) % 3;
			
			if(a[x - 1][y] != s) return;
		}
		
		ans ++;
		
		return;
	}
	
	f(y, Y)
	{
		int s = sum(x - 1, y) % 3;
		
		a[x][y] = (in[x - 1][y] - s + 12) % 3;
	}
	
	rec(x + 1);
}

void go(int y)
{
	if(y == Y)
	{
		rec(1);
		
		return;
	}
	
	f(i, 3)
	{
		a[0][y] = i;
		go(y + 1);
	}
}

void rotate_table()
{
	f(i, X)f(j, Y) t[j][i] = in[i][j];
	
	int temp = X;
	X = Y;
	Y = temp;
	
	f(i, X) f(j, Y) in[i][j] = t[i][j];
}

void Solve()
{
	if(X < Y) rotate_table();
	
	go(0);
}

void Write()
{
	printf("%d\n", ans % MOD);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}

/*
3 4
0 2 2 1
1 0 2 2
1 1 0 2
*/
