/*
task: table
lang: C++
*/
#include<iostream>
using namespace std;

int a[64][64], s[64][64];
int m, n, br;

void check()
{
  for(int i=1; i<=m; i++)
    for(int j=1; j<=n; j++)
      if(a[i][j]!=(s[i-1][j]+s[i][j-1]+s[i+1][j]+s[i][j+1])%3) return;
  br++;
}

void inits()
{
  for(int i=2; i<=n; i++)
    for(int j=1; j<=m; j++)
      s[i][j]=-1;
}

void fill()
{
  inits();
  int i, j;
  for(i=2; i<=m; i++)
    for(j=1; j<=n; j++)
      {
        if(s[i-1][j-1]!=-1 && s[i-2][j]!=-1 && s[i-1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j-1]-s[i-2][j]-s[i-1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i-1][j-1]!=-1 && s[i][j-2]!=-1 && s[i+1][j-1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j-1]-s[i][j-2]-s[i+1][j-1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i-1][j+1]!=-1 && s[i][j+2]!=-1 && a[i+1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j+1]-s[i][j+2]-s[i+1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i+1][j-1]!=-1 && s[i+2][j]!=-1 && s[i+1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i+1][j-1]-s[i+2][j]-s[i+1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
      }
  for(i=2; i<=m; i++)
    for(j=1; j<=n; j++)
      {
        if(s[i-1][j-1]!=-1 && s[i-2][j]!=-1 && s[i-1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j-1]-s[i-2][j]-s[i-1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i-1][j-1]!=-1 && s[i][j-2]!=-1 && s[i+1][j-1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j-1]-s[i][j-2]-s[i+1][j-1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i-1][j+1]!=-1 && s[i][j+2]!=-1 && a[i+1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i-1][j+1]-s[i][j+2]-s[i+1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
        else if(s[i+1][j-1]!=-1 && s[i+2][j]!=-1 && s[i+1][j+1]!=-1)
        {
          s[i][j]=(a[i][j]-s[i+1][j-1]-s[i+2][j]-s[i+1][j+1])%3;
          if(s[i][j]<0) s[i][j]=-s[i][j];
        }
      }
}
void gen(int i)
{
  s[1][i]=0;
  if( i<n )gen(i+1); else { fill(); check(); }
  s[1][i]=1;
  if( i<n )gen(i+1); else { fill(); check(); }
  s[1][i]=2;
  if( i<n )gen(i+1); else { fill(); check(); }
}

int main()
{
  scanf("%d%d", &m, &n);
  int i, j;
  for(i=1; i<=m; i++)
    for(j=1; j<=n; j++)
    {
      if(m>n) scanf("%d", a[i]+j);
      else scanf("%d", a[j]+i);
    }
  if(m<n) swap(n, m);
  gen(1);
  printf("%d\n", br%333333);
  return 0;
}
