/*
TASK: table
LANG: C++
*/

#include <cstdio>
#include <utility>

int off[4][2] = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };

int fp[] = {1, 1, 3, 9, 27};
int h, w;
bool used[32][32];
int ri, rnx, rny;
inline bool in(int x, int y) {
	return x >= 0 && x < w && y >= 0 && y < h;
}
int calc(int x, int y) {
	if(x == w) { x = 0; ++y; }
	if(y == h) { return 1; }
	int fr = 0;
	for(ri = 0; ri < 4; ++ri) {
		rnx = x+off[ri][0];
		rny = y+off[ri][1];
		if(!used[rnx][rny] && in(rnx, rny)) {
			used[rnx][rny] = true;
			++fr;
		}
	}
	return (fp[fr] * calc(x+1, y));
}

int main() {
	scanf("%d%d", &h, &w);
	if((h+w)%2 == 1) {
		printf("1\n");
	} else {
		printf("0\n");
	}
	//printf("%d\n", calc(0, 0));
	return 0;
}
