/*
TASK:rings
LANG:C++
*/
#include<iostream>

using namespace std;

struct path
{
       int len;
       bool p[1001];
};

int g[1001][1001];
bool used[1001];
int N, M, A1, B1, A2, B2, curPath, hang1, hang2;
int s, m = -1;

path paths[10001];
int br = 0;

void DFS(int n)
{
     used[n] = 1;
     
     if (n == s)
     {
        for (int i = 1; i <= N; i++)
        {
            paths[br].p[i] = used[i];
        }
        paths[br].len = curPath;
        
        br++;
        
        if ((m == -1) || (m > curPath))
           m = curPath;
     }
     
     for (int i = 1; i <= N; i++)
     {
         
         if ((g[i][n]) && (!used[i]))
         {
            curPath++;
            DFS(i);
         }
     }
     curPath--;
     used[n] = 0;
}

void InitUsed()
{
     for (int i = 1; i <= N; i++)
     {
         used[i] = 0;
     }
}

int main()
{   
    int a, b;
    cin >> N >> M;
    
    for (int i = 1; i <= N; i++)
    {
        for (int j = 1; j <= N; j++)
        {
            g[i][j] = 0;
        }
    }
    
    for (int i = 0; i < M; i++)
    {
         cin >> a >> b;
         g[a][b] = 1;
         g[b][a] = 1;
    }
    
    cin >> A1 >> B1 >> A2 >> B2;
    
    InitUsed();
    curPath = 0;
    s = B1;
    DFS(A1);
    
    hang1 = N;
    bool inPath[N+1];
    
    for (int i = 1; i <= N; i++)
    {
        inPath[i] = 0;
    }
    
    for (int i = 0; i < br; i++)
    {
        if (paths[i].len == m)
        {
           for (int j = 1; j <= N; j++)
           {
               if ((!inPath[j]) && (paths[i].p[j]))
               {
                  inPath[j] = 1;
                  hang1--;
               }
           }
        }
    }
    
    InitUsed();
    curPath = 0;
    s = B2;
    DFS(A2);
    
    hang2 = N;
    
    for (int i = 1; i <= N; i++)
    {
        inPath[i] = 0;
    }
    
    for (int i = 0; i < br; i++)
    {
        if (paths[i].len == m)
        {
           for (int j = 1; j <= N; j++)
           {
               if ((!inPath[j]) && (paths[i].p[j]))
               {
                  inPath[j] = 1;
                  hang2--;
               }
           }
        }
    }
    
    cout << hang1 << ' ' << hang2 << endl;
    return 0;
}


