/*
TASK:rings
LANG:C++
*/
#include <iostream>
using namespace std;
bool a[1001][1001], used[1001];
int depth[1001], queue[1001], r, w;
void BFS(int start, int end)
{
     depth[start] = 0;
     queue[0] = start;
     r = 0;
     w = 1;
     while(r!=w)
     {
                     for(int i = 0; i < 1001; ++i)
                     {
                             if(a[queue[r]][i] == true && !used[i])
                             {
                                           queue[w] = i;
                                           ++w;
                                           depth[i] = depth[queue[r]]+1;
                                           used[i] = true;
                             }
                     }
                     ++r;
     }
}
int BFS1(int start, int end)
{
     int ans = 0;
     queue[0] = start;
     r = 0;
     w = 1;
     while(!used[end])
     {
                     for(int i = 0; i < 1001; ++i)
                     {
                             if((a[queue[r]][i] == true && depth[i] == depth[queue[r]]-1)&&!used[i])
                             {
                                           ++ans;
                                           queue[w] = i;
                                           ++w;
                                           used[i] = true;
                             }
                     }
                     ++r;
     }
     return ans;
}
int main()
{
    int m, n, p, q, t, f;
    cin >> n >> m;
    for(int i = 0; i < m; ++i)
    {
            cin >> p >> q;
            a[p][q] = true;
            a[q][p] = true;
    }
    cin >> p >> q;
    BFS(p, q);
    for(int i = 0; i < 1001; ++i)
    {
            used[i] = false; queue[i] = 0;
    }
    t = BFS1(q, p);
    for(int i = 0; i < 1001; ++i)
    {
            used[i] = false; queue[i] = 0; depth[i] = 0;
    }
    cin >> p >> q;
    BFS(p, q);
    for(int i = 0; i < 1001; ++i)
    {
            used[i] = false; queue[i] = 0;
    }
    f = BFS1(q, p);
    cout << n-t << " " << n-f << endl;
    return 0;
}
