/*
TASK:rings
LANG:C++
*/

#include <cstdio>

using namespace std;

int n, m, s, e, b, c;
int a[1024][1024] = { { 0 } };
int used[1024] = { 0 };
int levl[1024] = { 0 };
int f[1024][1024] = { { 0 } };
int ef[1024] = { 0 };
int d[1024] = { 0 };

void bfs();
int bff();

int main()
{
	scanf("%d %d", &n, &m);
	int i;
	for (i = 0; i < m; i++)
	{
		scanf("%d %d", &s, &e);
		s--;
		e--;
		a[s][e] = a[e][s] = 1;
	}
	//****************************************************
	scanf("%d %d", &b, &c);
	b--;
	c--;
	for (i = 0; i < n; i++)
	{
		used[i] = ef[i] = levl[i] = 0;
	}
	used[b] = 1;
	bfs();
	for (i = 0; i < n; i++)
	{
		used[i] = 0;
	}
	printf("%d ", bff());
	//****************************************************
	scanf("%d %d", &b, &c);
	b--;
	c--;
	for (i = 0; i < n; i++)
	{
		used[i] = ef[i] = levl[i] = 0;
	}
	used[b] = 1;
	bfs();
	for (i = 0; i < n; i++)
	{
		used[i] = 0;
	}
	printf("%d\n", bff());
	//****************************************************
	return 0;
}

void bfs()
{
	d[0] = b;
	s = 0;
	e = 1;
	int i;
	while (s < e)
	{
		for (i = 0; i < n; i++)
		{
			if (a[d[s]][i] && d[s] != c)
			{
				if (!used[i])
				{
					used[i] = 1;
					d[e++] = i;
					f[i][ef[i]++] = d[s];
					levl[i] = levl[d[s]] + 1;
				}
				else if (levl[i] == levl[d[s]] + 1)
				{
					f[i][ef[i]++] = d[s];
				}
			}
		}
		s++;
	}
}

int bff()
{
	int x = n, i;
	s = 0;
	e = 1;
	d[0] = c;
	while (s < e)
	{
		for (i = 0; i < ef[d[s]]; i++)
		{
			if (!used[f[d[s]][i]])
			{
				d[e++] = f[d[s]][i];
				used[f[d[s]][i]] = 1;
			}
		}
		s++;
		x--;
	}
	return x;
}
