/*
TASK: rings
LANG: C++
*/
#include<cstdio>
#include<vector>
#include<queue>
using namespace std;
int n,m;
int f,f1,l,l1;
vector<int> g[1024],p[1024];
int a[1024][1024],a1[1024][1024];
queue<int> q;
int used[1024];
void read() {
    int i;
    scanf("%d%d",&n,&m);
    int k,k1;
    for(i=0;i<m;i++) {
        scanf("%d%d",&k,&k1);
        g[k-1].push_back(k1-1);
        g[k1-1].push_back(k-1);
    }
    scanf("%d%d%d%d",&f,&f1,&l,&l1);
}
void bfs (int x,int y) { 
    int i,j;
    q.push(x);
    used[x]=1;
    while(!q.empty()) {
        int cur=q.front();
        q.pop();
        for(i=0;i<g[cur].size();i++)  {
            if(used[g[cur][i]]==0||used[cur]+1==used[g[cur][i]])if(a[g[cur][i]][cur]==0) {
                used[g[cur][i]]=used[cur]+1;
                p[g[cur][i]].push_back(cur);
                a[g[cur][i]][cur]=1;
                q.push(g[cur][i]);
            }
        }
    }
}
void _bfs (int x,int y) { 
    int i,j;
    q.push(x);
    used[x]=1;
    while(!q.empty()) {
        int cur=q.front();
        q.pop();
        for(i=0;i<g[cur].size();i++)  {
            if(used[g[cur][i]]==0||used[cur]+1==used[g[cur][i]])if(a1[g[cur][i]][cur]==0) {
                used[g[cur][i]]=used[cur]+1;
                p[g[cur][i]].push_back(cur);
                a1[g[cur][i]][cur]=1;
                q.push(g[cur][i]);
            }
        }
    }
}
int ans,ans1;
int c (int x,int y) {
    int w=n,i;
    q.push(x);
    used[x]=1;
    w--;
    //printf("%d",x);
    while(!q.empty()) {
        int cur=q.front();
        q.pop();
        if(cur==y)return w;
        for(i=0;i<p[cur].size();i++) {
            if(!used[p[cur][i]]) {
                used[p[cur][i]]=1;
                //printf("%d ",cur+1);
                w--;
                q.push(p[cur][i]);
            }
        }
    }   
    //printf("\n");
    return w; 
}
void solve() {
    int i;
    int j;
    bfs(f-1,f1-1);
    memset(used,0,sizeof(used));
    ans=c(f1-1,f-1);
    memset(used,0,sizeof(used));
    for(i=0;i<n;i++)p[i].clear();
    _bfs(l-1,l1-1);
    memset(used,0,sizeof(used));
    ans1=c(l1-1,l-1);
}
void print() {
    int i,j;
    //for(i=0;i<n;i++) {
      //  printf("%d ", i+1);
        //for(j=0;j<p[i].size();j++)printf("%d ",p[i][j]+1);
        //printf("\n");
    //}
    //printf("\n");
    printf("%d %d\n",ans,ans1);
}
main () {
    read();
    solve();
    print();
    return 0;
}
