/*
TASK: decbin
LANG: C++
*/

#include <iostream>
using namespace std;

int bin[100];
int arr[60];
int x=0, decx=0;
int original;
         
void dec2bin(unsigned long long a) {
     x=0;
     while (a > 0) {
          bin[x] = a%2;
          x++;
          a /= 2; 
     }
     for (int i=0; i<x/2; i++)
         swap(bin[i], bin[x-i-1]);
}


int bin2dec() {
     int i=0;
     int value, sum(0);
     while (i<x) {
           value=bin[x-i-1];
           for (int k=0;k<i;k++) value *= 2;
           sum += value;
           i++;
     }
     return sum;
}

int move1() {
     int newDec;
     bin[x] = 0;
     x--;
     newDec = bin2dec();
     return newDec;
}
int getDecx(unsigned long long decimal) {
    int value;
    while (decimal > 0) {
           decimal /= 10;
           value++;
     }
     return value;
}
int move2(unsigned long long decimal) {
     while (decimal > 0) {
           arr[decx] = decimal%10;
           decimal /= 10;
           decx++;
     }
     for (int i=0; i<decx/2; i++)
         swap(arr[i], arr[decx-i-1]);
     
     arr[decx] = 0;
     decx--;
     int value, sum(0), i(0);
     while (i<decx) {
           value=arr[decx-i-1];
           for (int k=0; k<i; k++)
               value *= 10;
           sum+=value;
           i++;
     }
     dec2bin(sum);
     return sum;
} 

void printBin() {
     for (int i=0;i<x;i++) cout << bin[i];
}

bool isNull() {
     for (int i=0;i<x;i++) if (bin[i] != 0) return false;
     return true;
}

int main() {
    unsigned long long game[4];
    int ch[4];
    for (int i=0;i<4;i++) {
        cin >> game[i];
        dec2bin(game[i]);
        int choice;
        bool first(true);
        unsigned long long number = game[i];
        int player(0), temp, tempx;
         while (number != 0 || !isNull()) {
               temp = number;
               player++;
               if (move1() > move2(temp)) {
                  if (first) choice = 2;
                  number = move2(temp);
               }
               else number = move1(), choice = 1;
               if (number == 0 || isNull()) break;
               first = false;
               temp = number;
               if (move1() > move2(temp)) number = move2(temp);
               else number = move1();
               player++;
         }
    ch[i] = choice;
}
    for (int i=0;i<4;i++) cout << ch[i];
    return 0;
}
