{
  Marinel Serban
  Timp maxim: 3.1 secunde
}
Program NEMURITORUL;

Const DMAX= 32;

Type Tab = Array[1..4] Of Record
                            x, y: Integer;
                          End;
Const Dir: Tab = ((x:1; y:0), (x:-1; y:0), (x:0; y:1), (x:0; y:-1));

Type  Zona = Array[1..DMAX, 1..DMAX] Of Integer;
      Mutari = Array[1..DMAX*DMAX-1]  Of Record
                                           l, c, d: Integer;
                                         End;
Var n, m, NrNem: Integer;
    a          : Zona;
    Mutare     : Mutari;
    g          : Text;

Function InZona(i, j: Integer): Boolean;
Begin  {verifica ramanerea in Zona}
  InZona := (i>0) and (i<=n) and (j>0) and (j<=m);
End;

Procedure Citire;
Var f: Text;
    i, j, li, ci: Integer;
Begin
  Assign(f, 'immortal.in'); Reset(f);
  ReadLn(f, n, m, NrNem);     {dimensiunile zonei si numar nemuritori}
  For i := 1 To n Do          {Zona pe 0}
    For j := 1 To m Do a[i, j] := 0;
  For i := 1 To NrNem Do      {citeste cei NrNem nemuriTori si pune-i in Zona}
    Begin
      ReadLn(f, li, ci);
      a[li, ci] := 1
    End;
  Close(f);
End;

Procedure Afisare;
Var i, j, k, d: Integer;
    id, jd, inou, jnou: Integer;
Begin
  Assign(g, 'immortal.out'); ReWrite(g);
  If NrNem=1 Then
    WriteLn(g, 0)
  Else
    For k := 1 To NrNem-1 Do           {pentru fiecare din cele NrNem-1 lupte}
      Begin
        d := Mutare[k].d;
        i := Mutare[k].l; j := Mutare[k].c;   {de unde a plecat la "lupta"}
        {id := i+Dir[d].x; jd := j+Dir[d].y;} {pe cine a "invins"}
        inou := i+2*Dir[d].x; jnou := j+2*Dir[d].y; {unde a ajuns dupa "lupta"}
        WriteLn(g, i, ' ', j, ' ', inou, ' ', jnou);
      End;
  Close(g);
  Halt
End;

Procedure Aflare(k: Integer);
Var i, j, d, id, inou, jd, jnou: Integer;
Begin
  If k=NrNem Then  {daca am omorat NrNem-1 nemuritori}
    Afisare           {am o solutie}
  Else
    For i := 1 To n Do         {parcurge Zona}
      For j := 1 To m Do
        If a[i,j]=1 Then       {am gasit un nemuritor}
          For d := 1 To 4 Do   {cauta in cele 4 directii}
            Begin
              id := i+Dir[d].x;{coordonatele unui eventual nemuritor in directia d}
	      jd := j+Dir[d].y;
              inou := i+2*Dir[d].x;{coordonatele unde trebuie sa ajunga dupa "lupta"}
	      jnou := j+2*Dir[d].y;
              If (InZona(id, jd)) AND (InZona(inou, jnou)) AND{daca va ajunge tot in Zona si}
                 (a[inou, jnou]=0) AND (a[id, jd]=1) Then{intr-o Zona libera si va invinge un nemuriTor}
                 Begin
                   Mutare[k].l := i; Mutare[k].C := j; Mutare[k].d := d;{retine pozitia si de unde vine}
                   a[i, j] := 0;      {pleaca din Zona si}
                   a[id, jd] := 0;    {"omoara" nemuritorul }
                   a[inou, jnou] := 1;{si ajunge aici}
                   Aflare(k+1);             {se cauta alta "lupta"}
                   a[i, j] := 1;      {revine la locul lui si}
                   a[id, jd] := 1;    {repune nemuritorul la locul lui}
                   a[inou, jnou] := 0;{nu a mai ajuns la locul nou}
                 End;
            End;
End;

Begin
  Citire;
  Aflare(1);   {cauta prima "lupta"}
End.
