//Code by Patcas Csaba
//Time complexity: O(n)
//Space complexity: O(n)
//Method: Greedy
//Implementation time: 10 minutes

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "joc.in"
#define OUT_FILE "joc.out"
ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int n, k;
VVI a;

int Solve()
{
	int ans = 0, i = 1, j = 1, nCons = 1;
	bool changeRow = false;
	while (j < n)
	{
		ans += a[i][j];
		if ((a[i][j + 1] > a[3 - i][j] || changeRow) && (nCons < k)) 
		{
			++j;
			++nCons;
			changeRow = false;
		}
		else 
		{
			i = 3 - i;
			nCons = 1;
			changeRow = true;
		}
	}
	ans += a[i][n];
	if (i == 1) ans += a[2][n];
	return ans;
}

int main()
{
	//Read data
	fin >> n >> k;
	a.RS(3, VI(n + 1));
	FOR(i, 1, n) fin >> a[1][i];
	FOR(i, 1, n) fin >> a[2][i];
	fin.close();

	//Write data
	fout << Solve();
	fout.close();

	return 0;
}